"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TestTask = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

var _Base = require("./Base");

var _enums = require("../enums");

var _util = require("../../util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

class TestTask extends _Base.BaseTask {
  constructor(opts) {
    super(opts);
    this.type = _enums.TaskType.TEST;
  }

  run(env = {}) {
    var _this = this,
        _superprop_callRun = (..._args) => super.run(..._args);

    return _asyncToGenerator(function* () {
      yield _superprop_callRun();
      _this.proc = (0, _util.runCommand)(_this.getScript(), {
        cwd: _this.cwd,
        env // 前端传入的 env

      });

      _this.handleChildProcess(_this.proc);
    })();
  }

  getScript() {
    let command = '';

    if ((0, _util.isScriptKeyExist)(this.pkgPath, 'test')) {
      command = 'npm run test';
    } else if (this.isBigfishProject) {
      command = 'bigfish test'; // TODO: 优先使用 node_modules 中的命令？
    } else {
      command = 'umi test'; // TODO: 优先使用 node_modules 中的命令？
    }

    return command;
  }

}

exports.TestTask = TestTask;