"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _reactSizeme = _interopRequireDefault(require("react-sizeme"));

var _uiModule = _interopRequireDefault(require("../../ui.module.less"));

var _enums = require("../../../server/core/enums");

var _util = require("../../util");

var _hooks = require("../../hooks");

var _Terminal = _interopRequireDefault(require("../Terminal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var SizeMe = _reactSizeme.default.SizeMe;
var taskType = _enums.TaskType.TEST;

var TestComponent = function TestComponent(_ref) {
  var api = _ref.api;
  var intl = api.intl;

  var _useState = (0, _react.useState)({
    state: _enums.TaskState.INIT,
    type: taskType,
    log: ''
  }),
      _useState2 = _slicedToArray(_useState, 2),
      taskDetail = _useState2[0],
      setTaskDetail = _useState2[1];

  var _useState3 = (0, _react.useState)(true),
      _useState4 = _slicedToArray(_useState3, 2),
      loading = _useState4[0],
      setLoading = _useState4[1]; // Mount: 获取 task detail


  var _useTaskDetail = (0, _hooks.useTaskDetail)(taskType),
      detailLoading = _useTaskDetail.loading,
      detail = _useTaskDetail.detail; // Mount: 监听 task state 改变


  (0, _react.useEffect)(function () {
    setLoading(detailLoading);
    setTaskDetail(detail);
    var unsubscribe = api.listenRemote({
      type: 'org.umi.task.state',
      onMessage: function onMessage(_ref2) {
        var result = _ref2.detail,
            type = _ref2.taskType;

        if (!(0, _util.isCaredEvent)(type, taskType)) {
          return null;
        }

        if (result) {
          setTaskDetail(result);
        }
      }
    });
    return function () {
      unsubscribe && unsubscribe();
    };
  }, [detail]); // UnMount: reset form

  (0, _react.useEffect)(function () {
    return function () {
      var terminal = (0, _util.getTerminalIns)(taskType);
      terminal && terminal.clear();
    };
  }, []);

  function test() {
    return _test.apply(this, arguments);
  }

  function _test() {
    _test = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var _ref4, triggerState, errMsg;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _util.exec)(taskType);

            case 2:
              _ref4 = _context.sent;
              triggerState = _ref4.triggerState;
              errMsg = _ref4.errMsg;

              if (triggerState === _util.TriggerState.FAIL) {
                api.notify({
                  type: 'error',
                  title: intl('org.umi.ui.tasks.test.testError'),
                  message: errMsg
                });
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _test.apply(this, arguments);
  }

  function cancelTest() {
    return _cancelTest.apply(this, arguments);
  }

  function _cancelTest() {
    _cancelTest = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      var _ref5, triggerState, errMsg;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return (0, _util.cancel)(taskType);

            case 2:
              _ref5 = _context2.sent;
              triggerState = _ref5.triggerState;
              errMsg = _ref5.errMsg;

              if (!(triggerState === _util.TriggerState.FAIL)) {
                _context2.next = 8;
                break;
              }

              api.notify({
                title: intl('org.umi.ui.tasks.test.cancelError'),
                message: errMsg
              });
              return _context2.abrupt("return");

            case 8:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _cancelTest.apply(this, arguments);
  }

  var isTaskRunning = taskDetail && taskDetail.state === _enums.TaskState.ING;
  return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement("h1", {
    className: _uiModule.default.title
  }, intl('org.umi.ui.tasks.test')), loading ? _react.default.createElement(_antd.Spin, null) : _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_antd.Row, null, _react.default.createElement(_antd.Col, {
    span: 8,
    className: _uiModule.default.buttonGroup
  }, _react.default.createElement(_antd.Button, {
    type: "primary",
    onClick: isTaskRunning ? cancelTest : test,
    loading: loading
  }, isTaskRunning ? intl('org.umi.ui.tasks.test.cancel') : intl('org.umi.ui.tasks.test.start')))), _react.default.createElement("div", {
    className: _uiModule.default.logContainer
  }, _react.default.createElement(SizeMe, {
    monitorWidth: true,
    monitorHeight: true
  }, function (_ref3) {
    var size = _ref3.size;
    return _react.default.createElement(_Terminal.default, {
      api: api,
      size: size,
      terminal: (0, _util.getTerminalIns)(taskType),
      log: taskDetail.log,
      onClear: function onClear() {
        (0, _util.clearLog)(taskType);
      }
    });
  }))));
};

var _default = TestComponent;
exports.default = _default;