"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  TASK_TYPE_TEXT_MAP: true,
  TASK_STATE_TEXT_MAP: true,
  isCaredEvent: true,
  getNoticeMessage: true,
  initApiToGloal: true,
  callRemote: true
};
exports.getNoticeMessage = getNoticeMessage;
exports.initApiToGloal = initApiToGloal;
exports.callRemote = exports.isCaredEvent = exports.TASK_STATE_TEXT_MAP = exports.TASK_TYPE_TEXT_MAP = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

var _enums = require("../../server/core/enums");

var _task = require("./task");

Object.keys(_task).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _task[key];
    }
  });
});

var _terminal = require("./terminal");

Object.keys(_terminal).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _terminal[key];
    }
  });
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const TASK_TYPE_TEXT_MAP = {
  [_enums.TaskType.BUILD]: '构建',
  [_enums.TaskType.DEV]: '本地开发',
  [_enums.TaskType.LINT]: 'LINT',
  [_enums.TaskType.TEST]: '测试'
};
exports.TASK_TYPE_TEXT_MAP = TASK_TYPE_TEXT_MAP;
const TASK_STATE_TEXT_MAP = {
  [_enums.TaskState.INIT]: '初始化',
  [_enums.TaskState.ING]: '执行中',
  [_enums.TaskState.SUCCESS]: '执行成功',
  [_enums.TaskState.FAIL]: '执行失败'
};
exports.TASK_STATE_TEXT_MAP = TASK_STATE_TEXT_MAP;

const isCaredEvent = (taskType, caredTaskType) => {
  if (!taskType || taskType !== caredTaskType) {
    return false;
  }

  return true;
};

exports.isCaredEvent = isCaredEvent;
const NOTICE_MESSAGE_MAP = {
  [_enums.TaskType.BUILD]: {
    [_enums.TaskState.SUCCESS]: {
      title: '构建成功',
      message: '成功'
    },
    [_enums.TaskState.FAIL]: {
      title: '构建失败',
      message: '失败'
    }
  },
  [_enums.TaskType.DEV]: {
    [_enums.TaskState.SUCCESS]: {
      title: '启动成功',
      message: '成功'
    },
    [_enums.TaskState.FAIL]: {
      title: '启动失败',
      message: '失败'
    }
  },
  [_enums.TaskType.TEST]: {
    [_enums.TaskState.SUCCESS]: {
      title: '测试成功',
      message: '成功'
    },
    [_enums.TaskState.FAIL]: {
      title: '测试失败',
      message: '失败'
    }
  },
  [_enums.TaskType.LINT]: {
    [_enums.TaskState.SUCCESS]: {
      title: '代码风格检查成功',
      message: '成功'
    },
    [_enums.TaskState.FAIL]: {
      title: '执行代码风格检查失败',
      message: '失败'
    }
  },
  [_enums.TaskType.INSTALL]: {
    [_enums.TaskState.SUCCESS]: {
      title: '安装依赖成功',
      message: '成功'
    },
    [_enums.TaskState.FAIL]: {
      title: '安装依赖失败',
      message: '失败'
    }
  }
};

function getNoticeMessage(taskType, state) {
  return _objectSpread({
    type: state === _enums.TaskState.SUCCESS ? 'success' : 'error'
  }, NOTICE_MESSAGE_MAP[taskType][state]);
}

let callRemote;
exports.callRemote = callRemote;

function initApiToGloal(api) {
  exports.callRemote = callRemote = api.callRemote; // eslint-disable-line
}