"use strict";

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react'), require('antd'), require('react-dom')) : typeof define === 'function' && define.amd ? define(['react', 'antd', 'react-dom'], factory) : (global = global || self, global.tasks = factory(global.React, global.antd, global.reactDom));
})(void 0, function (React, antd, reactDom) {
  'use strict';

  var React__default = 'default' in React ? React['default'] : React;
  reactDom = reactDom && reactDom.hasOwnProperty('default') ? reactDom['default'] : reactDom;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(source, true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(source).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  function unwrapExports(x) {
    return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
  }

  function createCommonjsModule(fn, module) {
    return module = {
      exports: {}
    }, fn(module, module.exports), module.exports;
  }

  var collectionUtils = createCommonjsModule(function (module) {
    var utils = module.exports = {};
    /**
     * Loops through the collection and calls the callback for each element. if the callback returns truthy, the loop is broken and returns the same value.
     * @public
     * @param {*} collection The collection to loop through. Needs to have a length property set and have indices set from 0 to length - 1.
     * @param {function} callback The callback to be called for each element. The element will be given as a parameter to the callback. If this callback returns truthy, the loop is broken and the same value is returned.
     * @returns {*} The value that a callback has returned (if truthy). Otherwise nothing.
     */

    utils.forEach = function (collection, callback) {
      for (var i = 0; i < collection.length; i++) {
        var result = callback(collection[i]);

        if (result) {
          return result;
        }
      }
    };
  });

  var elementUtils = function elementUtils(options) {
    var getState = options.stateHandler.getState;
    /**
     * Tells if the element has been made detectable and ready to be listened for resize events.
     * @public
     * @param {element} The element to check.
     * @returns {boolean} True or false depending on if the element is detectable or not.
     */

    function isDetectable(element) {
      var state = getState(element);
      return state && !!state.isDetectable;
    }
    /**
     * Marks the element that it has been made detectable and ready to be listened for resize events.
     * @public
     * @param {element} The element to mark.
     */


    function markAsDetectable(element) {
      getState(element).isDetectable = true;
    }
    /**
     * Tells if the element is busy or not.
     * @public
     * @param {element} The element to check.
     * @returns {boolean} True or false depending on if the element is busy or not.
     */


    function isBusy(element) {
      return !!getState(element).busy;
    }
    /**
     * Marks the object is busy and should not be made detectable.
     * @public
     * @param {element} element The element to mark.
     * @param {boolean} busy If the element is busy or not.
     */


    function markBusy(element, busy) {
      getState(element).busy = !!busy;
    }

    return {
      isDetectable: isDetectable,
      markAsDetectable: markAsDetectable,
      isBusy: isBusy,
      markBusy: markBusy
    };
  };

  var listenerHandler = function listenerHandler(idHandler) {
    var eventListeners = {};
    /**
     * Gets all listeners for the given element.
     * @public
     * @param {element} element The element to get all listeners for.
     * @returns All listeners for the given element.
     */

    function getListeners(element) {
      var id = idHandler.get(element);

      if (id === undefined) {
        return [];
      }

      return eventListeners[id] || [];
    }
    /**
     * Stores the given listener for the given element. Will not actually add the listener to the element.
     * @public
     * @param {element} element The element that should have the listener added.
     * @param {function} listener The callback that the element has added.
     */


    function addListener(element, listener) {
      var id = idHandler.get(element);

      if (!eventListeners[id]) {
        eventListeners[id] = [];
      }

      eventListeners[id].push(listener);
    }

    function removeListener(element, listener) {
      var listeners = getListeners(element);

      for (var i = 0, len = listeners.length; i < len; ++i) {
        if (listeners[i] === listener) {
          listeners.splice(i, 1);
          break;
        }
      }
    }

    function removeAllListeners(element) {
      var listeners = getListeners(element);

      if (!listeners) {
        return;
      }

      listeners.length = 0;
    }

    return {
      get: getListeners,
      add: addListener,
      removeListener: removeListener,
      removeAllListeners: removeAllListeners
    };
  };

  var idGenerator = function idGenerator() {
    var idCount = 1;
    /**
     * Generates a new unique id in the context.
     * @public
     * @returns {number} A unique id in the context.
     */

    function generate() {
      return idCount++;
    }

    return {
      generate: generate
    };
  };

  var idHandler = function idHandler(options) {
    var idGenerator = options.idGenerator;
    var getState = options.stateHandler.getState;
    /**
     * Gets the resize detector id of the element.
     * @public
     * @param {element} element The target element to get the id of.
     * @returns {string|number|null} The id of the element. Null if it has no id.
     */

    function getId(element) {
      var state = getState(element);

      if (state && state.id !== undefined) {
        return state.id;
      }

      return null;
    }
    /**
     * Sets the resize detector id of the element. Requires the element to have a resize detector state initialized.
     * @public
     * @param {element} element The target element to set the id of.
     * @returns {string|number|null} The id of the element.
     */


    function setId(element) {
      var state = getState(element);

      if (!state) {
        throw new Error("setId required the element to have a resize detection state.");
      }

      var id = idGenerator.generate();
      state.id = id;
      return id;
    }

    return {
      get: getId,
      set: setId
    };
  };
  /* global console: false */

  /**
   * Reporter that handles the reporting of logs, warnings and errors.
   * @public
   * @param {boolean} quiet Tells if the reporter should be quiet or not.
   */


  var reporter = function reporter(quiet) {
    function noop() {//Does nothing.
    }

    var reporter = {
      log: noop,
      warn: noop,
      error: noop
    };

    if (!quiet && window.console) {
      var attachFunction = function attachFunction(reporter, name) {
        //The proxy is needed to be able to call the method with the console context,
        //since we cannot use bind.
        reporter[name] = function reporterProxy() {
          var f = console[name];

          if (f.apply) {
            //IE9 does not support console.log.apply :)
            f.apply(console, arguments);
          } else {
            for (var i = 0; i < arguments.length; i++) {
              f(arguments[i]);
            }
          }
        };
      };

      attachFunction(reporter, "log");
      attachFunction(reporter, "warn");
      attachFunction(reporter, "error");
    }

    return reporter;
  };

  var browserDetector = createCommonjsModule(function (module) {
    var detector = module.exports = {};

    detector.isIE = function (version) {
      function isAnyIeVersion() {
        var agent = navigator.userAgent.toLowerCase();
        return agent.indexOf("msie") !== -1 || agent.indexOf("trident") !== -1 || agent.indexOf(" edge/") !== -1;
      }

      if (!isAnyIeVersion()) {
        return false;
      }

      if (!version) {
        return true;
      } //Shamelessly stolen from https://gist.github.com/padolsey/527683


      var ieVersion = function () {
        var undef,
            v = 3,
            div = document.createElement("div"),
            all = div.getElementsByTagName("i");

        do {
          div.innerHTML = "<!--[if gt IE " + ++v + "]><i></i><![endif]-->";
        } while (all[0]);

        return v > 4 ? v : undef;
      }();

      return version === ieVersion;
    };

    detector.isLegacyOpera = function () {
      return !!window.opera;
    };
  });
  var utils_1 = createCommonjsModule(function (module) {
    var utils = module.exports = {};
    utils.getOption = getOption;

    function getOption(options, name, defaultValue) {
      var value = options[name];

      if ((value === undefined || value === null) && defaultValue !== undefined) {
        return defaultValue;
      }

      return value;
    }
  });

  var batchProcessor = function batchProcessorMaker(options) {
    options = options || {};
    var reporter = options.reporter;
    var asyncProcess = utils_1.getOption(options, "async", true);
    var autoProcess = utils_1.getOption(options, "auto", true);

    if (autoProcess && !asyncProcess) {
      reporter && reporter.warn("Invalid options combination. auto=true and async=false is invalid. Setting async=true.");
      asyncProcess = true;
    }

    var batch = Batch();
    var asyncFrameHandler;
    var isProcessing = false;

    function addFunction(level, fn) {
      if (!isProcessing && autoProcess && asyncProcess && batch.size() === 0) {
        // Since this is async, it is guaranteed to be executed after that the fn is added to the batch.
        // This needs to be done before, since we're checking the size of the batch to be 0.
        processBatchAsync();
      }

      batch.add(level, fn);
    }

    function processBatch() {
      // Save the current batch, and create a new batch so that incoming functions are not added into the currently processing batch.
      // Continue processing until the top-level batch is empty (functions may be added to the new batch while processing, and so on).
      isProcessing = true;

      while (batch.size()) {
        var processingBatch = batch;
        batch = Batch();
        processingBatch.process();
      }

      isProcessing = false;
    }

    function forceProcessBatch(localAsyncProcess) {
      if (isProcessing) {
        return;
      }

      if (localAsyncProcess === undefined) {
        localAsyncProcess = asyncProcess;
      }

      if (asyncFrameHandler) {
        cancelFrame(asyncFrameHandler);
        asyncFrameHandler = null;
      }

      if (localAsyncProcess) {
        processBatchAsync();
      } else {
        processBatch();
      }
    }

    function processBatchAsync() {
      asyncFrameHandler = requestFrame(processBatch);
    }

    function cancelFrame(listener) {
      // var cancel = window.cancelAnimationFrame || window.mozCancelAnimationFrame || window.webkitCancelAnimationFrame || window.clearTimeout;
      var cancel = clearTimeout;
      return cancel(listener);
    }

    function requestFrame(callback) {
      // var raf = window.requestAnimationFrame || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame || function(fn) { return window.setTimeout(fn, 20); };
      var raf = function raf(fn) {
        return setTimeout(fn, 0);
      };

      return raf(callback);
    }

    return {
      add: addFunction,
      force: forceProcessBatch
    };
  };

  function Batch() {
    var batch = {};
    var size = 0;
    var topLevel = 0;
    var bottomLevel = 0;

    function add(level, fn) {
      if (!fn) {
        fn = level;
        level = 0;
      }

      if (level > topLevel) {
        topLevel = level;
      } else if (level < bottomLevel) {
        bottomLevel = level;
      }

      if (!batch[level]) {
        batch[level] = [];
      }

      batch[level].push(fn);
      size++;
    }

    function process() {
      for (var level = bottomLevel; level <= topLevel; level++) {
        var fns = batch[level];

        for (var i = 0; i < fns.length; i++) {
          var fn = fns[i];
          fn();
        }
      }
    }

    function getSize() {
      return size;
    }

    return {
      add: add,
      process: process,
      size: getSize
    };
  }

  var prop = "_erd";

  function initState(element) {
    element[prop] = {};
    return getState(element);
  }

  function getState(element) {
    return element[prop];
  }

  function cleanState(element) {
    delete element[prop];
  }

  var stateHandler = {
    initState: initState,
    getState: getState,
    cleanState: cleanState
  };

  var object = function object(options) {
    options = options || {};
    var reporter = options.reporter;
    var batchProcessor = options.batchProcessor;
    var getState = options.stateHandler.getState;

    if (!reporter) {
      throw new Error("Missing required dependency: reporter.");
    }
    /**
     * Adds a resize event listener to the element.
     * @public
     * @param {element} element The element that should have the listener added.
     * @param {function} listener The listener callback to be called for each resize event of the element. The element will be given as a parameter to the listener callback.
     */


    function addListener(element, listener) {
      if (!getObject(element)) {
        throw new Error("Element is not detectable by this strategy.");
      }

      function listenerProxy() {
        listener(element);
      }

      if (browserDetector.isIE(8)) {
        //IE 8 does not support object, but supports the resize event directly on elements.
        getState(element).object = {
          proxy: listenerProxy
        };
        element.attachEvent("onresize", listenerProxy);
      } else {
        var object = getObject(element);
        object.contentDocument.defaultView.addEventListener("resize", listenerProxy);
      }
    }
    /**
     * Makes an element detectable and ready to be listened for resize events. Will call the callback when the element is ready to be listened for resize changes.
     * @private
     * @param {object} options Optional options object.
     * @param {element} element The element to make detectable
     * @param {function} callback The callback to be called when the element is ready to be listened for resize changes. Will be called with the element as first parameter.
     */


    function makeDetectable(options, element, callback) {
      if (!callback) {
        callback = element;
        element = options;
        options = null;
      }

      options = options || {};
      var debug = options.debug;

      function injectObject(element, callback) {
        var OBJECT_STYLE = "display: block; position: absolute; top: 0; left: 0; width: 100%; height: 100%; border: none; padding: 0; margin: 0; opacity: 0; z-index: -1000; pointer-events: none;"; //The target element needs to be positioned (everything except static) so the absolute positioned object will be positioned relative to the target element.
        // Position altering may be performed directly or on object load, depending on if style resolution is possible directly or not.

        var positionCheckPerformed = false; // The element may not yet be attached to the DOM, and therefore the style object may be empty in some browsers.
        // Since the style object is a reference, it will be updated as soon as the element is attached to the DOM.

        var style = window.getComputedStyle(element);
        var width = element.offsetWidth;
        var height = element.offsetHeight;
        getState(element).startSize = {
          width: width,
          height: height
        };

        function mutateDom() {
          function alterPositionStyles() {
            if (style.position === "static") {
              element.style.position = "relative";

              var removeRelativeStyles = function removeRelativeStyles(reporter, element, style, property) {
                function getNumericalValue(value) {
                  return value.replace(/[^-\d\.]/g, "");
                }

                var value = style[property];

                if (value !== "auto" && getNumericalValue(value) !== "0") {
                  reporter.warn("An element that is positioned static has style." + property + "=" + value + " which is ignored due to the static positioning. The element will need to be positioned relative, so the style." + property + " will be set to 0. Element: ", element);
                  element.style[property] = 0;
                }
              }; //Check so that there are no accidental styles that will make the element styled differently now that is is relative.
              //If there are any, set them to 0 (this should be okay with the user since the style properties did nothing before [since the element was positioned static] anyway).


              removeRelativeStyles(reporter, element, style, "top");
              removeRelativeStyles(reporter, element, style, "right");
              removeRelativeStyles(reporter, element, style, "bottom");
              removeRelativeStyles(reporter, element, style, "left");
            }
          }

          function onObjectLoad() {
            // The object has been loaded, which means that the element now is guaranteed to be attached to the DOM.
            if (!positionCheckPerformed) {
              alterPositionStyles();
            }
            /*jshint validthis: true */


            function getDocument(element, callback) {
              //Opera 12 seem to call the object.onload before the actual document has been created.
              //So if it is not present, poll it with an timeout until it is present.
              //TODO: Could maybe be handled better with object.onreadystatechange or similar.
              if (!element.contentDocument) {
                setTimeout(function checkForObjectDocument() {
                  getDocument(element, callback);
                }, 100);
                return;
              }

              callback(element.contentDocument);
            } //Mutating the object element here seems to fire another load event.
            //Mutating the inner document of the object element is fine though.


            var objectElement = this; //Create the style element to be added to the object.

            getDocument(objectElement, function onObjectDocumentReady(objectDocument) {
              //Notify that the element is ready to be listened to.
              callback(element);
            });
          } // The element may be detached from the DOM, and some browsers does not support style resolving of detached elements.
          // The alterPositionStyles needs to be delayed until we know the element has been attached to the DOM (which we are sure of when the onObjectLoad has been fired), if style resolution is not possible.


          if (style.position !== "") {
            alterPositionStyles();
            positionCheckPerformed = true;
          } //Add an object element as a child to the target element that will be listened to for resize events.


          var object = document.createElement("object");
          object.style.cssText = OBJECT_STYLE;
          object.tabIndex = -1;
          object.type = "text/html";
          object.setAttribute("aria-hidden", "true");
          object.onload = onObjectLoad; //Safari: This must occur before adding the object to the DOM.
          //IE: Does not like that this happens before, even if it is also added after.

          if (!browserDetector.isIE()) {
            object.data = "about:blank";
          }

          element.appendChild(object);
          getState(element).object = object; //IE: This must occur after adding the object to the DOM.

          if (browserDetector.isIE()) {
            object.data = "about:blank";
          }
        }

        if (batchProcessor) {
          batchProcessor.add(mutateDom);
        } else {
          mutateDom();
        }
      }

      if (browserDetector.isIE(8)) {
        //IE 8 does not support objects properly. Luckily they do support the resize event.
        //So do not inject the object and notify that the element is already ready to be listened to.
        //The event handler for the resize event is attached in the utils.addListener instead.
        callback(element);
      } else {
        injectObject(element, callback);
      }
    }
    /**
     * Returns the child object of the target element.
     * @private
     * @param {element} element The target element.
     * @returns The object element of the target.
     */


    function getObject(element) {
      return getState(element).object;
    }

    function uninstall(element) {
      if (browserDetector.isIE(8)) {
        element.detachEvent("onresize", getState(element).object.proxy);
      } else {
        element.removeChild(getObject(element));
      }

      delete getState(element).object;
    }

    return {
      makeDetectable: makeDetectable,
      addListener: addListener,
      uninstall: uninstall
    };
  };

  var forEach = collectionUtils.forEach;

  var scroll = function scroll(options) {
    options = options || {};
    var reporter = options.reporter;
    var batchProcessor = options.batchProcessor;
    var getState = options.stateHandler.getState;
    var hasState = options.stateHandler.hasState;
    var idHandler = options.idHandler;

    if (!batchProcessor) {
      throw new Error("Missing required dependency: batchProcessor");
    }

    if (!reporter) {
      throw new Error("Missing required dependency: reporter.");
    } //TODO: Could this perhaps be done at installation time?


    var scrollbarSizes = getScrollbarSizes(); // Inject the scrollbar styling that prevents them from appearing sometimes in Chrome.
    // The injected container needs to have a class, so that it may be styled with CSS (pseudo elements).

    var styleId = "erd_scroll_detection_scrollbar_style";
    var detectionContainerClass = "erd_scroll_detection_container";
    injectScrollStyle(styleId, detectionContainerClass);

    function getScrollbarSizes() {
      var width = 500;
      var height = 500;
      var child = document.createElement("div");
      child.style.cssText = "position: absolute; width: " + width * 2 + "px; height: " + height * 2 + "px; visibility: hidden; margin: 0; padding: 0;";
      var container = document.createElement("div");
      container.style.cssText = "position: absolute; width: " + width + "px; height: " + height + "px; overflow: scroll; visibility: none; top: " + -width * 3 + "px; left: " + -height * 3 + "px; visibility: hidden; margin: 0; padding: 0;";
      container.appendChild(child);
      document.body.insertBefore(container, document.body.firstChild);
      var widthSize = width - container.clientWidth;
      var heightSize = height - container.clientHeight;
      document.body.removeChild(container);
      return {
        width: widthSize,
        height: heightSize
      };
    }

    function injectScrollStyle(styleId, containerClass) {
      function injectStyle(style, method) {
        method = method || function (element) {
          document.head.appendChild(element);
        };

        var styleElement = document.createElement("style");
        styleElement.innerHTML = style;
        styleElement.id = styleId;
        method(styleElement);
        return styleElement;
      }

      if (!document.getElementById(styleId)) {
        var containerAnimationClass = containerClass + "_animation";
        var containerAnimationActiveClass = containerClass + "_animation_active";
        var style = "/* Created by the element-resize-detector library. */\n";
        style += "." + containerClass + " > div::-webkit-scrollbar { display: none; }\n\n";
        style += "." + containerAnimationActiveClass + " { -webkit-animation-duration: 0.1s; animation-duration: 0.1s; -webkit-animation-name: " + containerAnimationClass + "; animation-name: " + containerAnimationClass + "; }\n";
        style += "@-webkit-keyframes " + containerAnimationClass + " { 0% { opacity: 1; } 50% { opacity: 0; } 100% { opacity: 1; } }\n";
        style += "@keyframes " + containerAnimationClass + " { 0% { opacity: 1; } 50% { opacity: 0; } 100% { opacity: 1; } }";
        injectStyle(style);
      }
    }

    function addAnimationClass(element) {
      element.className += " " + detectionContainerClass + "_animation_active";
    }

    function addEvent(el, name, cb) {
      if (el.addEventListener) {
        el.addEventListener(name, cb);
      } else if (el.attachEvent) {
        el.attachEvent("on" + name, cb);
      } else {
        return reporter.error("[scroll] Don't know how to add event listeners.");
      }
    }

    function removeEvent(el, name, cb) {
      if (el.removeEventListener) {
        el.removeEventListener(name, cb);
      } else if (el.detachEvent) {
        el.detachEvent("on" + name, cb);
      } else {
        return reporter.error("[scroll] Don't know how to remove event listeners.");
      }
    }

    function getExpandElement(element) {
      return getState(element).container.childNodes[0].childNodes[0].childNodes[0];
    }

    function getShrinkElement(element) {
      return getState(element).container.childNodes[0].childNodes[0].childNodes[1];
    }
    /**
     * Adds a resize event listener to the element.
     * @public
     * @param {element} element The element that should have the listener added.
     * @param {function} listener The listener callback to be called for each resize event of the element. The element will be given as a parameter to the listener callback.
     */


    function addListener(element, listener) {
      var listeners = getState(element).listeners;

      if (!listeners.push) {
        throw new Error("Cannot add listener to an element that is not detectable.");
      }

      getState(element).listeners.push(listener);
    }
    /**
     * Makes an element detectable and ready to be listened for resize events. Will call the callback when the element is ready to be listened for resize changes.
     * @private
     * @param {object} options Optional options object.
     * @param {element} element The element to make detectable
     * @param {function} callback The callback to be called when the element is ready to be listened for resize changes. Will be called with the element as first parameter.
     */


    function makeDetectable(options, element, callback) {
      if (!callback) {
        callback = element;
        element = options;
        options = null;
      }

      options = options || {};

      function debug() {
        if (options.debug) {
          var args = Array.prototype.slice.call(arguments);
          args.unshift(idHandler.get(element), "Scroll: ");

          if (reporter.log.apply) {
            reporter.log.apply(null, args);
          } else {
            for (var i = 0; i < args.length; i++) {
              reporter.log(args[i]);
            }
          }
        }
      }

      function isDetached(element) {
        function isInDocument(element) {
          return element === element.ownerDocument.body || element.ownerDocument.body.contains(element);
        }

        if (!isInDocument(element)) {
          return true;
        } // FireFox returns null style in hidden iframes. See https://github.com/wnr/element-resize-detector/issues/68 and https://bugzilla.mozilla.org/show_bug.cgi?id=795520


        if (window.getComputedStyle(element) === null) {
          return true;
        }

        return false;
      }

      function isUnrendered(element) {
        // Check the absolute positioned container since the top level container is display: inline.
        var container = getState(element).container.childNodes[0];
        var style = window.getComputedStyle(container);
        return !style.width || style.width.indexOf("px") === -1; //Can only compute pixel value when rendered.
      }

      function getStyle() {
        // Some browsers only force layouts when actually reading the style properties of the style object, so make sure that they are all read here,
        // so that the user of the function can be sure that it will perform the layout here, instead of later (important for batching).
        var elementStyle = window.getComputedStyle(element);
        var style = {};
        style.position = elementStyle.position;
        style.width = element.offsetWidth;
        style.height = element.offsetHeight;
        style.top = elementStyle.top;
        style.right = elementStyle.right;
        style.bottom = elementStyle.bottom;
        style.left = elementStyle.left;
        style.widthCSS = elementStyle.width;
        style.heightCSS = elementStyle.height;
        return style;
      }

      function storeStartSize() {
        var style = getStyle();
        getState(element).startSize = {
          width: style.width,
          height: style.height
        };
        debug("Element start size", getState(element).startSize);
      }

      function initListeners() {
        getState(element).listeners = [];
      }

      function storeStyle() {
        debug("storeStyle invoked.");

        if (!getState(element)) {
          debug("Aborting because element has been uninstalled");
          return;
        }

        var style = getStyle();
        getState(element).style = style;
      }

      function storeCurrentSize(element, width, height) {
        getState(element).lastWidth = width;
        getState(element).lastHeight = height;
      }

      function getExpandChildElement(element) {
        return getExpandElement(element).childNodes[0];
      }

      function getWidthOffset() {
        return 2 * scrollbarSizes.width + 1;
      }

      function getHeightOffset() {
        return 2 * scrollbarSizes.height + 1;
      }

      function getExpandWidth(width) {
        return width + 10 + getWidthOffset();
      }

      function getExpandHeight(height) {
        return height + 10 + getHeightOffset();
      }

      function getShrinkWidth(width) {
        return width * 2 + getWidthOffset();
      }

      function getShrinkHeight(height) {
        return height * 2 + getHeightOffset();
      }

      function positionScrollbars(element, width, height) {
        var expand = getExpandElement(element);
        var shrink = getShrinkElement(element);
        var expandWidth = getExpandWidth(width);
        var expandHeight = getExpandHeight(height);
        var shrinkWidth = getShrinkWidth(width);
        var shrinkHeight = getShrinkHeight(height);
        expand.scrollLeft = expandWidth;
        expand.scrollTop = expandHeight;
        shrink.scrollLeft = shrinkWidth;
        shrink.scrollTop = shrinkHeight;
      }

      function injectContainerElement() {
        var container = getState(element).container;

        if (!container) {
          container = document.createElement("div");
          container.className = detectionContainerClass;
          container.style.cssText = "visibility: hidden; display: inline; width: 0px; height: 0px; z-index: -1; overflow: hidden; margin: 0; padding: 0;";
          getState(element).container = container;
          addAnimationClass(container);
          element.appendChild(container);

          var onAnimationStart = function onAnimationStart() {
            getState(element).onRendered && getState(element).onRendered();
          };

          addEvent(container, "animationstart", onAnimationStart); // Store the event handler here so that they may be removed when uninstall is called.
          // See uninstall function for an explanation why it is needed.

          getState(element).onAnimationStart = onAnimationStart;
        }

        return container;
      }

      function injectScrollElements() {
        function alterPositionStyles() {
          var style = getState(element).style;

          if (style.position === "static") {
            element.style.position = "relative";

            var removeRelativeStyles = function removeRelativeStyles(reporter, element, style, property) {
              function getNumericalValue(value) {
                return value.replace(/[^-\d\.]/g, "");
              }

              var value = style[property];

              if (value !== "auto" && getNumericalValue(value) !== "0") {
                reporter.warn("An element that is positioned static has style." + property + "=" + value + " which is ignored due to the static positioning. The element will need to be positioned relative, so the style." + property + " will be set to 0. Element: ", element);
                element.style[property] = 0;
              }
            }; //Check so that there are no accidental styles that will make the element styled differently now that is is relative.
            //If there are any, set them to 0 (this should be okay with the user since the style properties did nothing before [since the element was positioned static] anyway).


            removeRelativeStyles(reporter, element, style, "top");
            removeRelativeStyles(reporter, element, style, "right");
            removeRelativeStyles(reporter, element, style, "bottom");
            removeRelativeStyles(reporter, element, style, "left");
          }
        }

        function getLeftTopBottomRightCssText(left, top, bottom, right) {
          left = !left ? "0" : left + "px";
          top = !top ? "0" : top + "px";
          bottom = !bottom ? "0" : bottom + "px";
          right = !right ? "0" : right + "px";
          return "left: " + left + "; top: " + top + "; right: " + right + "; bottom: " + bottom + ";";
        }

        debug("Injecting elements");

        if (!getState(element)) {
          debug("Aborting because element has been uninstalled");
          return;
        }

        alterPositionStyles();
        var rootContainer = getState(element).container;

        if (!rootContainer) {
          rootContainer = injectContainerElement();
        } // Due to this WebKit bug https://bugs.webkit.org/show_bug.cgi?id=80808 (currently fixed in Blink, but still present in WebKit browsers such as Safari),
        // we need to inject two containers, one that is width/height 100% and another that is left/top -1px so that the final container always is 1x1 pixels bigger than
        // the targeted element.
        // When the bug is resolved, "containerContainer" may be removed.
        // The outer container can occasionally be less wide than the targeted when inside inline elements element in WebKit (see https://bugs.webkit.org/show_bug.cgi?id=152980).
        // This should be no problem since the inner container either way makes sure the injected scroll elements are at least 1x1 px.


        var scrollbarWidth = scrollbarSizes.width;
        var scrollbarHeight = scrollbarSizes.height;
        var containerContainerStyle = "position: absolute; flex: none; overflow: hidden; z-index: -1; visibility: hidden; width: 100%; height: 100%; left: 0px; top: 0px;";
        var containerStyle = "position: absolute; flex: none; overflow: hidden; z-index: -1; visibility: hidden; " + getLeftTopBottomRightCssText(-(1 + scrollbarWidth), -(1 + scrollbarHeight), -scrollbarHeight, -scrollbarWidth);
        var expandStyle = "position: absolute; flex: none; overflow: scroll; z-index: -1; visibility: hidden; width: 100%; height: 100%;";
        var shrinkStyle = "position: absolute; flex: none; overflow: scroll; z-index: -1; visibility: hidden; width: 100%; height: 100%;";
        var expandChildStyle = "position: absolute; left: 0; top: 0;";
        var shrinkChildStyle = "position: absolute; width: 200%; height: 200%;";
        var containerContainer = document.createElement("div");
        var container = document.createElement("div");
        var expand = document.createElement("div");
        var expandChild = document.createElement("div");
        var shrink = document.createElement("div");
        var shrinkChild = document.createElement("div"); // Some browsers choke on the resize system being rtl, so force it to ltr. https://github.com/wnr/element-resize-detector/issues/56
        // However, dir should not be set on the top level container as it alters the dimensions of the target element in some browsers.

        containerContainer.dir = "ltr";
        containerContainer.style.cssText = containerContainerStyle;
        containerContainer.className = detectionContainerClass;
        container.className = detectionContainerClass;
        container.style.cssText = containerStyle;
        expand.style.cssText = expandStyle;
        expandChild.style.cssText = expandChildStyle;
        shrink.style.cssText = shrinkStyle;
        shrinkChild.style.cssText = shrinkChildStyle;
        expand.appendChild(expandChild);
        shrink.appendChild(shrinkChild);
        container.appendChild(expand);
        container.appendChild(shrink);
        containerContainer.appendChild(container);
        rootContainer.appendChild(containerContainer);

        function onExpandScroll() {
          getState(element).onExpand && getState(element).onExpand();
        }

        function onShrinkScroll() {
          getState(element).onShrink && getState(element).onShrink();
        }

        addEvent(expand, "scroll", onExpandScroll);
        addEvent(shrink, "scroll", onShrinkScroll); // Store the event handlers here so that they may be removed when uninstall is called.
        // See uninstall function for an explanation why it is needed.

        getState(element).onExpandScroll = onExpandScroll;
        getState(element).onShrinkScroll = onShrinkScroll;
      }

      function registerListenersAndPositionElements() {
        function updateChildSizes(element, width, height) {
          var expandChild = getExpandChildElement(element);
          var expandWidth = getExpandWidth(width);
          var expandHeight = getExpandHeight(height);
          expandChild.style.width = expandWidth + "px";
          expandChild.style.height = expandHeight + "px";
        }

        function updateDetectorElements(done) {
          var width = element.offsetWidth;
          var height = element.offsetHeight;
          debug("Storing current size", width, height); // Store the size of the element sync here, so that multiple scroll events may be ignored in the event listeners.
          // Otherwise the if-check in handleScroll is useless.

          storeCurrentSize(element, width, height); // Since we delay the processing of the batch, there is a risk that uninstall has been called before the batch gets to execute.
          // Since there is no way to cancel the fn executions, we need to add an uninstall guard to all fns of the batch.

          batchProcessor.add(0, function performUpdateChildSizes() {
            if (!getState(element)) {
              debug("Aborting because element has been uninstalled");
              return;
            }

            if (!areElementsInjected()) {
              debug("Aborting because element container has not been initialized");
              return;
            }

            if (options.debug) {
              var w = element.offsetWidth;
              var h = element.offsetHeight;

              if (w !== width || h !== height) {
                reporter.warn(idHandler.get(element), "Scroll: Size changed before updating detector elements.");
              }
            }

            updateChildSizes(element, width, height);
          });
          batchProcessor.add(1, function updateScrollbars() {
            if (!getState(element)) {
              debug("Aborting because element has been uninstalled");
              return;
            }

            if (!areElementsInjected()) {
              debug("Aborting because element container has not been initialized");
              return;
            }

            positionScrollbars(element, width, height);
          });

          if (done) {
            batchProcessor.add(2, function () {
              if (!getState(element)) {
                debug("Aborting because element has been uninstalled");
                return;
              }

              if (!areElementsInjected()) {
                debug("Aborting because element container has not been initialized");
                return;
              }

              done();
            });
          }
        }

        function areElementsInjected() {
          return !!getState(element).container;
        }

        function notifyListenersIfNeeded() {
          function isFirstNotify() {
            return getState(element).lastNotifiedWidth === undefined;
          }

          debug("notifyListenersIfNeeded invoked");
          var state = getState(element); // Don't notify the if the current size is the start size, and this is the first notification.

          if (isFirstNotify() && state.lastWidth === state.startSize.width && state.lastHeight === state.startSize.height) {
            return debug("Not notifying: Size is the same as the start size, and there has been no notification yet.");
          } // Don't notify if the size already has been notified.


          if (state.lastWidth === state.lastNotifiedWidth && state.lastHeight === state.lastNotifiedHeight) {
            return debug("Not notifying: Size already notified");
          }

          debug("Current size not notified, notifying...");
          state.lastNotifiedWidth = state.lastWidth;
          state.lastNotifiedHeight = state.lastHeight;
          forEach(getState(element).listeners, function (listener) {
            listener(element);
          });
        }

        function handleRender() {
          debug("startanimation triggered.");

          if (isUnrendered(element)) {
            debug("Ignoring since element is still unrendered...");
            return;
          }

          debug("Element rendered.");
          var expand = getExpandElement(element);
          var shrink = getShrinkElement(element);

          if (expand.scrollLeft === 0 || expand.scrollTop === 0 || shrink.scrollLeft === 0 || shrink.scrollTop === 0) {
            debug("Scrollbars out of sync. Updating detector elements...");
            updateDetectorElements(notifyListenersIfNeeded);
          }
        }

        function handleScroll() {
          debug("Scroll detected.");

          if (isUnrendered(element)) {
            // Element is still unrendered. Skip this scroll event.
            debug("Scroll event fired while unrendered. Ignoring...");
            return;
          }

          var width = element.offsetWidth;
          var height = element.offsetHeight;

          if (width !== getState(element).lastWidth || height !== getState(element).lastHeight) {
            debug("Element size changed.");
            updateDetectorElements(notifyListenersIfNeeded);
          } else {
            debug("Element size has not changed (" + width + "x" + height + ").");
          }
        }

        debug("registerListenersAndPositionElements invoked.");

        if (!getState(element)) {
          debug("Aborting because element has been uninstalled");
          return;
        }

        getState(element).onRendered = handleRender;
        getState(element).onExpand = handleScroll;
        getState(element).onShrink = handleScroll;
        var style = getState(element).style;
        updateChildSizes(element, style.width, style.height);
      }

      function finalizeDomMutation() {
        debug("finalizeDomMutation invoked.");

        if (!getState(element)) {
          debug("Aborting because element has been uninstalled");
          return;
        }

        var style = getState(element).style;
        storeCurrentSize(element, style.width, style.height);
        positionScrollbars(element, style.width, style.height);
      }

      function ready() {
        callback(element);
      }

      function install() {
        debug("Installing...");
        initListeners();
        storeStartSize();
        batchProcessor.add(0, storeStyle);
        batchProcessor.add(1, injectScrollElements);
        batchProcessor.add(2, registerListenersAndPositionElements);
        batchProcessor.add(3, finalizeDomMutation);
        batchProcessor.add(4, ready);
      }

      debug("Making detectable...");

      if (isDetached(element)) {
        debug("Element is detached");
        injectContainerElement();
        debug("Waiting until element is attached...");

        getState(element).onRendered = function () {
          debug("Element is now attached");
          install();
        };
      } else {
        install();
      }
    }

    function uninstall(element) {
      var state = getState(element);

      if (!state) {
        // Uninstall has been called on a non-erd element.
        return;
      } // Uninstall may have been called in the following scenarios:
      // (1) Right between the sync code and async batch (here state.busy = true, but nothing have been registered or injected).
      // (2) In the ready callback of the last level of the batch by another element (here, state.busy = true, but all the stuff has been injected).
      // (3) After the installation process (here, state.busy = false and all the stuff has been injected).
      // So to be on the safe side, let's check for each thing before removing.
      // We need to remove the event listeners, because otherwise the event might fire on an uninstall element which results in an error when trying to get the state of the element.


      state.onExpandScroll && removeEvent(getExpandElement(element), "scroll", state.onExpandScroll);
      state.onShrinkScroll && removeEvent(getShrinkElement(element), "scroll", state.onShrinkScroll);
      state.onAnimationStart && removeEvent(state.container, "animationstart", state.onAnimationStart);
      state.container && element.removeChild(state.container);
    }

    return {
      makeDetectable: makeDetectable,
      addListener: addListener,
      uninstall: uninstall
    };
  };

  var forEach$1 = collectionUtils.forEach; //Detection strategies.

  function isCollection(obj) {
    return Array.isArray(obj) || obj.length !== undefined;
  }

  function toArray(collection) {
    if (!Array.isArray(collection)) {
      var array = [];
      forEach$1(collection, function (obj) {
        array.push(obj);
      });
      return array;
    } else {
      return collection;
    }
  }

  function isElement(obj) {
    return obj && obj.nodeType === 1;
  }
  /**
   * @typedef idHandler
   * @type {object}
   * @property {function} get Gets the resize detector id of the element.
   * @property {function} set Generate and sets the resize detector id of the element.
   */

  /**
   * @typedef Options
   * @type {object}
   * @property {boolean} callOnAdd    Determines if listeners should be called when they are getting added.
                                      Default is true. If true, the listener is guaranteed to be called when it has been added.
                                      If false, the listener will not be guarenteed to be called when it has been added (does not prevent it from being called).
   * @property {idHandler} idHandler  A custom id handler that is responsible for generating, setting and retrieving id's for elements.
                                      If not provided, a default id handler will be used.
   * @property {reporter} reporter    A custom reporter that handles reporting logs, warnings and errors.
                                      If not provided, a default id handler will be used.
                                      If set to false, then nothing will be reported.
   * @property {boolean} debug        If set to true, the the system will report debug messages as default for the listenTo method.
   */

  /**
   * Creates an element resize detector instance.
   * @public
   * @param {Options?} options Optional global options object that will decide how this instance will work.
   */


  var elementResizeDetector = function elementResizeDetector(options) {
    options = options || {}; //idHandler is currently not an option to the listenTo function, so it should not be added to globalOptions.

    var idHandler$1;

    if (options.idHandler) {
      // To maintain compatability with idHandler.get(element, readonly), make sure to wrap the given idHandler
      // so that readonly flag always is true when it's used here. This may be removed next major version bump.
      idHandler$1 = {
        get: function get(element) {
          return options.idHandler.get(element, true);
        },
        set: options.idHandler.set
      };
    } else {
      var idGenerator$1 = idGenerator();
      var defaultIdHandler = idHandler({
        idGenerator: idGenerator$1,
        stateHandler: stateHandler
      });
      idHandler$1 = defaultIdHandler;
    } //reporter is currently not an option to the listenTo function, so it should not be added to globalOptions.


    var reporter$1 = options.reporter;

    if (!reporter$1) {
      //If options.reporter is false, then the reporter should be quiet.
      var quiet = reporter$1 === false;
      reporter$1 = reporter(quiet);
    } //batchProcessor is currently not an option to the listenTo function, so it should not be added to globalOptions.


    var batchProcessor$1 = getOption(options, "batchProcessor", batchProcessor({
      reporter: reporter$1
    })); //Options to be used as default for the listenTo function.

    var globalOptions = {};
    globalOptions.callOnAdd = !!getOption(options, "callOnAdd", true);
    globalOptions.debug = !!getOption(options, "debug", false);
    var eventListenerHandler = listenerHandler(idHandler$1);
    var elementUtils$1 = elementUtils({
      stateHandler: stateHandler
    }); //The detection strategy to be used.

    var detectionStrategy;
    var desiredStrategy = getOption(options, "strategy", "object");
    var strategyOptions = {
      reporter: reporter$1,
      batchProcessor: batchProcessor$1,
      stateHandler: stateHandler,
      idHandler: idHandler$1
    };

    if (desiredStrategy === "scroll") {
      if (browserDetector.isLegacyOpera()) {
        reporter$1.warn("Scroll strategy is not supported on legacy Opera. Changing to object strategy.");
        desiredStrategy = "object";
      } else if (browserDetector.isIE(9)) {
        reporter$1.warn("Scroll strategy is not supported on IE9. Changing to object strategy.");
        desiredStrategy = "object";
      }
    }

    if (desiredStrategy === "scroll") {
      detectionStrategy = scroll(strategyOptions);
    } else if (desiredStrategy === "object") {
      detectionStrategy = object(strategyOptions);
    } else {
      throw new Error("Invalid strategy name: " + desiredStrategy);
    } //Calls can be made to listenTo with elements that are still being installed.
    //Also, same elements can occur in the elements list in the listenTo function.
    //With this map, the ready callbacks can be synchronized between the calls
    //so that the ready callback can always be called when an element is ready - even if
    //it wasn't installed from the function itself.


    var onReadyCallbacks = {};
    /**
     * Makes the given elements resize-detectable and starts listening to resize events on the elements. Calls the event callback for each event for each element.
     * @public
     * @param {Options?} options Optional options object. These options will override the global options. Some options may not be overriden, such as idHandler.
     * @param {element[]|element} elements The given array of elements to detect resize events of. Single element is also valid.
     * @param {function} listener The callback to be executed for each resize event for each element.
     */

    function listenTo(options, elements, listener) {
      function onResizeCallback(element) {
        var listeners = eventListenerHandler.get(element);
        forEach$1(listeners, function callListenerProxy(listener) {
          listener(element);
        });
      }

      function addListener(callOnAdd, element, listener) {
        eventListenerHandler.add(element, listener);

        if (callOnAdd) {
          listener(element);
        }
      } //Options object may be omitted.


      if (!listener) {
        listener = elements;
        elements = options;
        options = {};
      }

      if (!elements) {
        throw new Error("At least one element required.");
      }

      if (!listener) {
        throw new Error("Listener required.");
      }

      if (isElement(elements)) {
        // A single element has been passed in.
        elements = [elements];
      } else if (isCollection(elements)) {
        // Convert collection to array for plugins.
        // TODO: May want to check so that all the elements in the collection are valid elements.
        elements = toArray(elements);
      } else {
        return reporter$1.error("Invalid arguments. Must be a DOM element or a collection of DOM elements.");
      }

      var elementsReady = 0;
      var callOnAdd = getOption(options, "callOnAdd", globalOptions.callOnAdd);
      var onReadyCallback = getOption(options, "onReady", function noop() {});
      var debug = getOption(options, "debug", globalOptions.debug);
      forEach$1(elements, function attachListenerToElement(element) {
        if (!stateHandler.getState(element)) {
          stateHandler.initState(element);
          idHandler$1.set(element);
        }

        var id = idHandler$1.get(element);
        debug && reporter$1.log("Attaching listener to element", id, element);

        if (!elementUtils$1.isDetectable(element)) {
          debug && reporter$1.log(id, "Not detectable.");

          if (elementUtils$1.isBusy(element)) {
            debug && reporter$1.log(id, "System busy making it detectable"); //The element is being prepared to be detectable. Do not make it detectable.
            //Just add the listener, because the element will soon be detectable.

            addListener(callOnAdd, element, listener);
            onReadyCallbacks[id] = onReadyCallbacks[id] || [];
            onReadyCallbacks[id].push(function onReady() {
              elementsReady++;

              if (elementsReady === elements.length) {
                onReadyCallback();
              }
            });
            return;
          }

          debug && reporter$1.log(id, "Making detectable..."); //The element is not prepared to be detectable, so do prepare it and add a listener to it.

          elementUtils$1.markBusy(element, true);
          return detectionStrategy.makeDetectable({
            debug: debug
          }, element, function onElementDetectable(element) {
            debug && reporter$1.log(id, "onElementDetectable");

            if (stateHandler.getState(element)) {
              elementUtils$1.markAsDetectable(element);
              elementUtils$1.markBusy(element, false);
              detectionStrategy.addListener(element, onResizeCallback);
              addListener(callOnAdd, element, listener); // Since the element size might have changed since the call to "listenTo", we need to check for this change,
              // so that a resize event may be emitted.
              // Having the startSize object is optional (since it does not make sense in some cases such as unrendered elements), so check for its existance before.
              // Also, check the state existance before since the element may have been uninstalled in the installation process.

              var state = stateHandler.getState(element);

              if (state && state.startSize) {
                var width = element.offsetWidth;
                var height = element.offsetHeight;

                if (state.startSize.width !== width || state.startSize.height !== height) {
                  onResizeCallback(element);
                }
              }

              if (onReadyCallbacks[id]) {
                forEach$1(onReadyCallbacks[id], function (callback) {
                  callback();
                });
              }
            } else {
              // The element has been unisntalled before being detectable.
              debug && reporter$1.log(id, "Element uninstalled before being detectable.");
            }

            delete onReadyCallbacks[id];
            elementsReady++;

            if (elementsReady === elements.length) {
              onReadyCallback();
            }
          });
        }

        debug && reporter$1.log(id, "Already detecable, adding listener."); //The element has been prepared to be detectable and is ready to be listened to.

        addListener(callOnAdd, element, listener);
        elementsReady++;
      });

      if (elementsReady === elements.length) {
        onReadyCallback();
      }
    }

    function uninstall(elements) {
      if (!elements) {
        return reporter$1.error("At least one element is required.");
      }

      if (isElement(elements)) {
        // A single element has been passed in.
        elements = [elements];
      } else if (isCollection(elements)) {
        // Convert collection to array for plugins.
        // TODO: May want to check so that all the elements in the collection are valid elements.
        elements = toArray(elements);
      } else {
        return reporter$1.error("Invalid arguments. Must be a DOM element or a collection of DOM elements.");
      }

      forEach$1(elements, function (element) {
        eventListenerHandler.removeAllListeners(element);
        detectionStrategy.uninstall(element);
        stateHandler.cleanState(element);
      });
    }

    return {
      listenTo: listenTo,
      removeListener: eventListenerHandler.removeListener,
      removeAllListeners: eventListenerHandler.removeAllListeners,
      uninstall: uninstall
    };
  };

  function getOption(options, name, defaultValue) {
    var value = options[name];

    if ((value === undefined || value === null) && defaultValue !== undefined) {
      return defaultValue;
    }

    return value;
  }

  var reactIs_production_min = createCommonjsModule(function (module, exports) {
    Object.defineProperty(exports, "__esModule", {
      value: !0
    });
    var b = "function" === typeof Symbol && Symbol.for,
        c = b ? Symbol.for("react.element") : 60103,
        d = b ? Symbol.for("react.portal") : 60106,
        e = b ? Symbol.for("react.fragment") : 60107,
        f = b ? Symbol.for("react.strict_mode") : 60108,
        g = b ? Symbol.for("react.profiler") : 60114,
        h = b ? Symbol.for("react.provider") : 60109,
        k = b ? Symbol.for("react.context") : 60110,
        l = b ? Symbol.for("react.async_mode") : 60111,
        m = b ? Symbol.for("react.concurrent_mode") : 60111,
        n = b ? Symbol.for("react.forward_ref") : 60112,
        p = b ? Symbol.for("react.suspense") : 60113,
        q = b ? Symbol.for("react.suspense_list") : 60120,
        r = b ? Symbol.for("react.memo") : 60115,
        t = b ? Symbol.for("react.lazy") : 60116,
        v = b ? Symbol.for("react.fundamental") : 60117,
        w = b ? Symbol.for("react.responder") : 60118;

    function x(a) {
      if ("object" === typeof a && null !== a) {
        var u = a.$$typeof;

        switch (u) {
          case c:
            switch (a = a.type, a) {
              case l:
              case m:
              case e:
              case g:
              case f:
              case p:
                return a;

              default:
                switch (a = a && a.$$typeof, a) {
                  case k:
                  case n:
                  case h:
                    return a;

                  default:
                    return u;
                }

            }

          case t:
          case r:
          case d:
            return u;
        }
      }
    }

    function y(a) {
      return x(a) === m;
    }

    exports.typeOf = x;
    exports.AsyncMode = l;
    exports.ConcurrentMode = m;
    exports.ContextConsumer = k;
    exports.ContextProvider = h;
    exports.Element = c;
    exports.ForwardRef = n;
    exports.Fragment = e;
    exports.Lazy = t;
    exports.Memo = r;
    exports.Portal = d;
    exports.Profiler = g;
    exports.StrictMode = f;
    exports.Suspense = p;

    exports.isValidElementType = function (a) {
      return "string" === typeof a || "function" === typeof a || a === e || a === m || a === g || a === f || a === p || a === q || "object" === typeof a && null !== a && (a.$$typeof === t || a.$$typeof === r || a.$$typeof === h || a.$$typeof === k || a.$$typeof === n || a.$$typeof === v || a.$$typeof === w);
    };

    exports.isAsyncMode = function (a) {
      return y(a) || x(a) === l;
    };

    exports.isConcurrentMode = y;

    exports.isContextConsumer = function (a) {
      return x(a) === k;
    };

    exports.isContextProvider = function (a) {
      return x(a) === h;
    };

    exports.isElement = function (a) {
      return "object" === typeof a && null !== a && a.$$typeof === c;
    };

    exports.isForwardRef = function (a) {
      return x(a) === n;
    };

    exports.isFragment = function (a) {
      return x(a) === e;
    };

    exports.isLazy = function (a) {
      return x(a) === t;
    };

    exports.isMemo = function (a) {
      return x(a) === r;
    };

    exports.isPortal = function (a) {
      return x(a) === d;
    };

    exports.isProfiler = function (a) {
      return x(a) === g;
    };

    exports.isStrictMode = function (a) {
      return x(a) === f;
    };

    exports.isSuspense = function (a) {
      return x(a) === p;
    };
  });
  unwrapExports(reactIs_production_min);
  var reactIs_production_min_1 = reactIs_production_min.typeOf;
  var reactIs_production_min_2 = reactIs_production_min.AsyncMode;
  var reactIs_production_min_3 = reactIs_production_min.ConcurrentMode;
  var reactIs_production_min_4 = reactIs_production_min.ContextConsumer;
  var reactIs_production_min_5 = reactIs_production_min.ContextProvider;
  var reactIs_production_min_6 = reactIs_production_min.Element;
  var reactIs_production_min_7 = reactIs_production_min.ForwardRef;
  var reactIs_production_min_8 = reactIs_production_min.Fragment;
  var reactIs_production_min_9 = reactIs_production_min.Lazy;
  var reactIs_production_min_10 = reactIs_production_min.Memo;
  var reactIs_production_min_11 = reactIs_production_min.Portal;
  var reactIs_production_min_12 = reactIs_production_min.Profiler;
  var reactIs_production_min_13 = reactIs_production_min.StrictMode;
  var reactIs_production_min_14 = reactIs_production_min.Suspense;
  var reactIs_production_min_15 = reactIs_production_min.isValidElementType;
  var reactIs_production_min_16 = reactIs_production_min.isAsyncMode;
  var reactIs_production_min_17 = reactIs_production_min.isConcurrentMode;
  var reactIs_production_min_18 = reactIs_production_min.isContextConsumer;
  var reactIs_production_min_19 = reactIs_production_min.isContextProvider;
  var reactIs_production_min_20 = reactIs_production_min.isElement;
  var reactIs_production_min_21 = reactIs_production_min.isForwardRef;
  var reactIs_production_min_22 = reactIs_production_min.isFragment;
  var reactIs_production_min_23 = reactIs_production_min.isLazy;
  var reactIs_production_min_24 = reactIs_production_min.isMemo;
  var reactIs_production_min_25 = reactIs_production_min.isPortal;
  var reactIs_production_min_26 = reactIs_production_min.isProfiler;
  var reactIs_production_min_27 = reactIs_production_min.isStrictMode;
  var reactIs_production_min_28 = reactIs_production_min.isSuspense;
  var reactIs_development = createCommonjsModule(function (module, exports) {
    {
      (function () {
        Object.defineProperty(exports, '__esModule', {
          value: true
        }); // The Symbol used to tag the ReactElement-like types. If there is no native Symbol
        // nor polyfill, then a plain number is used for performance.

        var hasSymbol = typeof Symbol === 'function' && Symbol.for;
        var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
        var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
        var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
        var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
        var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
        var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
        var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
        // (unstable) APIs that have been removed. Can we remove the symbols?

        var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
        var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
        var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
        var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
        var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
        var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
        var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
        var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
        var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;

        function isValidElementType(type) {
          return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
          type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE);
        }
        /**
         * Forked from fbjs/warning:
         * https://github.com/facebook/fbjs/blob/e66ba20ad5be433eb54423f2b097d829324d9de6/packages/fbjs/src/__forks__/warning.js
         *
         * Only change is we use console.warn instead of console.error,
         * and do nothing when 'console' is not supported.
         * This really simplifies the code.
         * ---
         * Similar to invariant but only logs a warning if the condition is not met.
         * This can be used to log issues in development environments in critical
         * paths. Removing the logging code for production environments will keep the
         * same logic and follow the same code paths.
         */


        var lowPriorityWarning = function lowPriorityWarning() {};

        {
          var printWarning = function printWarning(format) {
            for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              args[_key - 1] = arguments[_key];
            }

            var argIndex = 0;
            var message = 'Warning: ' + format.replace(/%s/g, function () {
              return args[argIndex++];
            });

            if (typeof console !== 'undefined') {
              console.warn(message);
            }

            try {
              // --- Welcome to debugging React ---
              // This error was thrown as a convenience so that you can use this stack
              // to find the callsite that caused this warning to fire.
              throw new Error(message);
            } catch (x) {}
          };

          lowPriorityWarning = function lowPriorityWarning(condition, format) {
            if (format === undefined) {
              throw new Error('`lowPriorityWarning(condition, format, ...args)` requires a warning ' + 'message argument');
            }

            if (!condition) {
              for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
                args[_key2 - 2] = arguments[_key2];
              }

              printWarning.apply(undefined, [format].concat(args));
            }
          };
        }
        var lowPriorityWarning$1 = lowPriorityWarning;

        function typeOf(object) {
          if (typeof object === 'object' && object !== null) {
            var $$typeof = object.$$typeof;

            switch ($$typeof) {
              case REACT_ELEMENT_TYPE:
                var type = object.type;

                switch (type) {
                  case REACT_ASYNC_MODE_TYPE:
                  case REACT_CONCURRENT_MODE_TYPE:
                  case REACT_FRAGMENT_TYPE:
                  case REACT_PROFILER_TYPE:
                  case REACT_STRICT_MODE_TYPE:
                  case REACT_SUSPENSE_TYPE:
                    return type;

                  default:
                    var $$typeofType = type && type.$$typeof;

                    switch ($$typeofType) {
                      case REACT_CONTEXT_TYPE:
                      case REACT_FORWARD_REF_TYPE:
                      case REACT_PROVIDER_TYPE:
                        return $$typeofType;

                      default:
                        return $$typeof;
                    }

                }

              case REACT_LAZY_TYPE:
              case REACT_MEMO_TYPE:
              case REACT_PORTAL_TYPE:
                return $$typeof;
            }
          }

          return undefined;
        } // AsyncMode is deprecated along with isAsyncMode


        var AsyncMode = REACT_ASYNC_MODE_TYPE;
        var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
        var ContextConsumer = REACT_CONTEXT_TYPE;
        var ContextProvider = REACT_PROVIDER_TYPE;
        var Element = REACT_ELEMENT_TYPE;
        var ForwardRef = REACT_FORWARD_REF_TYPE;
        var Fragment = REACT_FRAGMENT_TYPE;
        var Lazy = REACT_LAZY_TYPE;
        var Memo = REACT_MEMO_TYPE;
        var Portal = REACT_PORTAL_TYPE;
        var Profiler = REACT_PROFILER_TYPE;
        var StrictMode = REACT_STRICT_MODE_TYPE;
        var Suspense = REACT_SUSPENSE_TYPE;
        var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

        function isAsyncMode(object) {
          {
            if (!hasWarnedAboutDeprecatedIsAsyncMode) {
              hasWarnedAboutDeprecatedIsAsyncMode = true;
              lowPriorityWarning$1(false, 'The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
            }
          }
          return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
        }

        function isConcurrentMode(object) {
          return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
        }

        function isContextConsumer(object) {
          return typeOf(object) === REACT_CONTEXT_TYPE;
        }

        function isContextProvider(object) {
          return typeOf(object) === REACT_PROVIDER_TYPE;
        }

        function isElement(object) {
          return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
        }

        function isForwardRef(object) {
          return typeOf(object) === REACT_FORWARD_REF_TYPE;
        }

        function isFragment(object) {
          return typeOf(object) === REACT_FRAGMENT_TYPE;
        }

        function isLazy(object) {
          return typeOf(object) === REACT_LAZY_TYPE;
        }

        function isMemo(object) {
          return typeOf(object) === REACT_MEMO_TYPE;
        }

        function isPortal(object) {
          return typeOf(object) === REACT_PORTAL_TYPE;
        }

        function isProfiler(object) {
          return typeOf(object) === REACT_PROFILER_TYPE;
        }

        function isStrictMode(object) {
          return typeOf(object) === REACT_STRICT_MODE_TYPE;
        }

        function isSuspense(object) {
          return typeOf(object) === REACT_SUSPENSE_TYPE;
        }

        exports.typeOf = typeOf;
        exports.AsyncMode = AsyncMode;
        exports.ConcurrentMode = ConcurrentMode;
        exports.ContextConsumer = ContextConsumer;
        exports.ContextProvider = ContextProvider;
        exports.Element = Element;
        exports.ForwardRef = ForwardRef;
        exports.Fragment = Fragment;
        exports.Lazy = Lazy;
        exports.Memo = Memo;
        exports.Portal = Portal;
        exports.Profiler = Profiler;
        exports.StrictMode = StrictMode;
        exports.Suspense = Suspense;
        exports.isValidElementType = isValidElementType;
        exports.isAsyncMode = isAsyncMode;
        exports.isConcurrentMode = isConcurrentMode;
        exports.isContextConsumer = isContextConsumer;
        exports.isContextProvider = isContextProvider;
        exports.isElement = isElement;
        exports.isForwardRef = isForwardRef;
        exports.isFragment = isFragment;
        exports.isLazy = isLazy;
        exports.isMemo = isMemo;
        exports.isPortal = isPortal;
        exports.isProfiler = isProfiler;
        exports.isStrictMode = isStrictMode;
        exports.isSuspense = isSuspense;
      })();
    }
  });
  unwrapExports(reactIs_development);
  var reactIs_development_1 = reactIs_development.typeOf;
  var reactIs_development_2 = reactIs_development.AsyncMode;
  var reactIs_development_3 = reactIs_development.ConcurrentMode;
  var reactIs_development_4 = reactIs_development.ContextConsumer;
  var reactIs_development_5 = reactIs_development.ContextProvider;
  var reactIs_development_6 = reactIs_development.Element;
  var reactIs_development_7 = reactIs_development.ForwardRef;
  var reactIs_development_8 = reactIs_development.Fragment;
  var reactIs_development_9 = reactIs_development.Lazy;
  var reactIs_development_10 = reactIs_development.Memo;
  var reactIs_development_11 = reactIs_development.Portal;
  var reactIs_development_12 = reactIs_development.Profiler;
  var reactIs_development_13 = reactIs_development.StrictMode;
  var reactIs_development_14 = reactIs_development.Suspense;
  var reactIs_development_15 = reactIs_development.isValidElementType;
  var reactIs_development_16 = reactIs_development.isAsyncMode;
  var reactIs_development_17 = reactIs_development.isConcurrentMode;
  var reactIs_development_18 = reactIs_development.isContextConsumer;
  var reactIs_development_19 = reactIs_development.isContextProvider;
  var reactIs_development_20 = reactIs_development.isElement;
  var reactIs_development_21 = reactIs_development.isForwardRef;
  var reactIs_development_22 = reactIs_development.isFragment;
  var reactIs_development_23 = reactIs_development.isLazy;
  var reactIs_development_24 = reactIs_development.isMemo;
  var reactIs_development_25 = reactIs_development.isPortal;
  var reactIs_development_26 = reactIs_development.isProfiler;
  var reactIs_development_27 = reactIs_development.isStrictMode;
  var reactIs_development_28 = reactIs_development.isSuspense;
  var reactIs = createCommonjsModule(function (module) {
    {
      module.exports = reactIs_development;
    }
  });
  /*
  object-assign
  (c) Sindre Sorhus
  @license MIT
  */

  /* eslint-disable no-unused-vars */

  var getOwnPropertySymbols = Object.getOwnPropertySymbols;
  var hasOwnProperty = Object.prototype.hasOwnProperty;
  var propIsEnumerable = Object.prototype.propertyIsEnumerable;

  function toObject(val) {
    if (val === null || val === undefined) {
      throw new TypeError('Object.assign cannot be called with null or undefined');
    }

    return Object(val);
  }

  function shouldUseNative() {
    try {
      if (!Object.assign) {
        return false;
      } // Detect buggy property enumeration order in older V8 versions.
      // https://bugs.chromium.org/p/v8/issues/detail?id=4118


      var test1 = new String('abc'); // eslint-disable-line no-new-wrappers

      test1[5] = 'de';

      if (Object.getOwnPropertyNames(test1)[0] === '5') {
        return false;
      } // https://bugs.chromium.org/p/v8/issues/detail?id=3056


      var test2 = {};

      for (var i = 0; i < 10; i++) {
        test2['_' + String.fromCharCode(i)] = i;
      }

      var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
        return test2[n];
      });

      if (order2.join('') !== '0123456789') {
        return false;
      } // https://bugs.chromium.org/p/v8/issues/detail?id=3056


      var test3 = {};
      'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
        test3[letter] = letter;
      });

      if (Object.keys(Object.assign({}, test3)).join('') !== 'abcdefghijklmnopqrst') {
        return false;
      }

      return true;
    } catch (err) {
      // We don't expect any of the above to throw, but better to be safe.
      return false;
    }
  }

  var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
    var from;
    var to = toObject(target);
    var symbols;

    for (var s = 1; s < arguments.length; s++) {
      from = Object(arguments[s]);

      for (var key in from) {
        if (hasOwnProperty.call(from, key)) {
          to[key] = from[key];
        }
      }

      if (getOwnPropertySymbols) {
        symbols = getOwnPropertySymbols(from);

        for (var i = 0; i < symbols.length; i++) {
          if (propIsEnumerable.call(from, symbols[i])) {
            to[symbols[i]] = from[symbols[i]];
          }
        }
      }
    }

    return to;
  };
  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';
  var ReactPropTypesSecret_1 = ReactPropTypesSecret;

  var printWarning = function printWarning() {};

  {
    var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
    var loggedTypeFailures = {};
    var has = Function.call.bind(Object.prototype.hasOwnProperty);

    printWarning = function printWarning(text) {
      var message = 'Warning: ' + text;

      if (typeof console !== 'undefined') {
        console.error(message);
      }

      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };
  }
  /**
   * Assert that the values match with the type specs.
   * Error messages are memorized and will only be shown once.
   *
   * @param {object} typeSpecs Map of name to a ReactPropType
   * @param {object} values Runtime values that need to be type-checked
   * @param {string} location e.g. "prop", "context", "child context"
   * @param {string} componentName Name of the component for error messages.
   * @param {?Function} getStack Returns the component stack.
   * @private
   */

  function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
    {
      for (var typeSpecName in typeSpecs) {
        if (has(typeSpecs, typeSpecName)) {
          var error; // Prop type validation may throw. In case they do, we don't want to
          // fail the render phase where it didn't fail before. So we log it.
          // After these have been cleaned up, we'll let them throw.

          try {
            // This is intentionally an invariant that gets caught. It's the same
            // behavior as without this statement except with a better message.
            if (typeof typeSpecs[typeSpecName] !== 'function') {
              var err = Error((componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' + 'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.');
              err.name = 'Invariant Violation';
              throw err;
            }

            error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
          } catch (ex) {
            error = ex;
          }

          if (error && !(error instanceof Error)) {
            printWarning((componentName || 'React class') + ': type specification of ' + location + ' `' + typeSpecName + '` is invalid; the type checker ' + 'function must return `null` or an `Error` but returned a ' + typeof error + '. ' + 'You may have forgotten to pass an argument to the type checker ' + 'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' + 'shape all require an argument).');
          }

          if (error instanceof Error && !(error.message in loggedTypeFailures)) {
            // Only monitor this failure once because there tends to be a lot of the
            // same error.
            loggedTypeFailures[error.message] = true;
            var stack = getStack ? getStack() : '';
            printWarning('Failed ' + location + ' type: ' + error.message + (stack != null ? stack : ''));
          }
        }
      }
    }
  }
  /**
   * Resets warning cache when testing.
   *
   * @private
   */


  checkPropTypes.resetWarningCache = function () {
    {
      loggedTypeFailures = {};
    }
  };

  var checkPropTypes_1 = checkPropTypes;
  var has$1 = Function.call.bind(Object.prototype.hasOwnProperty);

  var printWarning$1 = function printWarning$1() {};

  {
    printWarning$1 = function printWarning$1(text) {
      var message = 'Warning: ' + text;

      if (typeof console !== 'undefined') {
        console.error(message);
      }

      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };
  }

  function emptyFunctionThatReturnsNull() {
    return null;
  }

  var factoryWithTypeCheckers = function factoryWithTypeCheckers(isValidElement, throwOnDirectAccess) {
    /* global Symbol */
    var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
    var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

    /**
     * Returns the iterator method function contained on the iterable object.
     *
     * Be sure to invoke the function with the iterable as context:
     *
     *     var iteratorFn = getIteratorFn(myIterable);
     *     if (iteratorFn) {
     *       var iterator = iteratorFn.call(myIterable);
     *       ...
     *     }
     *
     * @param {?object} maybeIterable
     * @return {?function}
     */

    function getIteratorFn(maybeIterable) {
      var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);

      if (typeof iteratorFn === 'function') {
        return iteratorFn;
      }
    }
    /**
     * Collection of methods that allow declaration and validation of props that are
     * supplied to React components. Example usage:
     *
     *   var Props = require('ReactPropTypes');
     *   var MyArticle = React.createClass({
     *     propTypes: {
     *       // An optional string prop named "description".
     *       description: Props.string,
     *
     *       // A required enum prop named "category".
     *       category: Props.oneOf(['News','Photos']).isRequired,
     *
     *       // A prop named "dialog" that requires an instance of Dialog.
     *       dialog: Props.instanceOf(Dialog).isRequired
     *     },
     *     render: function() { ... }
     *   });
     *
     * A more formal specification of how these methods are used:
     *
     *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
     *   decl := ReactPropTypes.{type}(.isRequired)?
     *
     * Each and every declaration produces a function with the same signature. This
     * allows the creation of custom validation functions. For example:
     *
     *  var MyLink = React.createClass({
     *    propTypes: {
     *      // An optional string or URI prop named "href".
     *      href: function(props, propName, componentName) {
     *        var propValue = props[propName];
     *        if (propValue != null && typeof propValue !== 'string' &&
     *            !(propValue instanceof URI)) {
     *          return new Error(
     *            'Expected a string or an URI for ' + propName + ' in ' +
     *            componentName
     *          );
     *        }
     *      }
     *    },
     *    render: function() {...}
     *  });
     *
     * @internal
     */


    var ANONYMOUS = '<<anonymous>>'; // Important!
    // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.

    var ReactPropTypes = {
      array: createPrimitiveTypeChecker('array'),
      bool: createPrimitiveTypeChecker('boolean'),
      func: createPrimitiveTypeChecker('function'),
      number: createPrimitiveTypeChecker('number'),
      object: createPrimitiveTypeChecker('object'),
      string: createPrimitiveTypeChecker('string'),
      symbol: createPrimitiveTypeChecker('symbol'),
      any: createAnyTypeChecker(),
      arrayOf: createArrayOfTypeChecker,
      element: createElementTypeChecker(),
      elementType: createElementTypeTypeChecker(),
      instanceOf: createInstanceTypeChecker,
      node: createNodeChecker(),
      objectOf: createObjectOfTypeChecker,
      oneOf: createEnumTypeChecker,
      oneOfType: createUnionTypeChecker,
      shape: createShapeTypeChecker,
      exact: createStrictShapeTypeChecker
    };
    /**
     * inlined Object.is polyfill to avoid requiring consumers ship their own
     * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
     */

    /*eslint-disable no-self-compare*/

    function is(x, y) {
      // SameValue algorithm
      if (x === y) {
        // Steps 1-5, 7-10
        // Steps 6.b-6.e: +0 != -0
        return x !== 0 || 1 / x === 1 / y;
      } else {
        // Step 6.a: NaN == NaN
        return x !== x && y !== y;
      }
    }
    /*eslint-enable no-self-compare*/

    /**
     * We use an Error-like object for backward compatibility as people may call
     * PropTypes directly and inspect their output. However, we don't use real
     * Errors anymore. We don't inspect their stack anyway, and creating them
     * is prohibitively expensive if they are created too often, such as what
     * happens in oneOfType() for any type before the one that matched.
     */


    function PropTypeError(message) {
      this.message = message;
      this.stack = '';
    } // Make `instanceof Error` still work for returned errors.


    PropTypeError.prototype = Error.prototype;

    function createChainableTypeChecker(validate) {
      {
        var manualPropTypeCallCache = {};
        var manualPropTypeWarningCount = 0;
      }

      function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
        componentName = componentName || ANONYMOUS;
        propFullName = propFullName || propName;

        if (secret !== ReactPropTypesSecret_1) {
          if (throwOnDirectAccess) {
            // New behavior only for users of `prop-types` package
            var err = new Error('Calling PropTypes validators directly is not supported by the `prop-types` package. ' + 'Use `PropTypes.checkPropTypes()` to call them. ' + 'Read more at http://fb.me/use-check-prop-types');
            err.name = 'Invariant Violation';
            throw err;
          } else if (typeof console !== 'undefined') {
            // Old behavior for people using React.PropTypes
            var cacheKey = componentName + ':' + propName;

            if (!manualPropTypeCallCache[cacheKey] && // Avoid spamming the console because they are often not actionable except for lib authors
            manualPropTypeWarningCount < 3) {
              printWarning$1('You are manually calling a React.PropTypes validation ' + 'function for the `' + propFullName + '` prop on `' + componentName + '`. This is deprecated ' + 'and will throw in the standalone `prop-types` package. ' + 'You may be seeing this warning due to a third-party PropTypes ' + 'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.');
              manualPropTypeCallCache[cacheKey] = true;
              manualPropTypeWarningCount++;
            }
          }
        }

        if (props[propName] == null) {
          if (isRequired) {
            if (props[propName] === null) {
              return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
            }

            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
          }

          return null;
        } else {
          return validate(props, propName, componentName, location, propFullName);
        }
      }

      var chainedCheckType = checkType.bind(null, false);
      chainedCheckType.isRequired = checkType.bind(null, true);
      return chainedCheckType;
    }

    function createPrimitiveTypeChecker(expectedType) {
      function validate(props, propName, componentName, location, propFullName, secret) {
        var propValue = props[propName];
        var propType = getPropType(propValue);

        if (propType !== expectedType) {
          // `propValue` being instance of, say, date/regexp, pass the 'object'
          // check, but we can offer a more precise error message here rather than
          // 'of type `object`'.
          var preciseType = getPreciseType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function createAnyTypeChecker() {
      return createChainableTypeChecker(emptyFunctionThatReturnsNull);
    }

    function createArrayOfTypeChecker(typeChecker) {
      function validate(props, propName, componentName, location, propFullName) {
        if (typeof typeChecker !== 'function') {
          return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
        }

        var propValue = props[propName];

        if (!Array.isArray(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
        }

        for (var i = 0; i < propValue.length; i++) {
          var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);

          if (error instanceof Error) {
            return error;
          }
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function createElementTypeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];

        if (!isValidElement(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function createElementTypeTypeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];

        if (!reactIs.isValidElementType(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function createInstanceTypeChecker(expectedClass) {
      function validate(props, propName, componentName, location, propFullName) {
        if (!(props[propName] instanceof expectedClass)) {
          var expectedClassName = expectedClass.name || ANONYMOUS;
          var actualClassName = getClassName(props[propName]);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function createEnumTypeChecker(expectedValues) {
      if (!Array.isArray(expectedValues)) {
        {
          if (arguments.length > 1) {
            printWarning$1('Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' + 'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).');
          } else {
            printWarning$1('Invalid argument supplied to oneOf, expected an array.');
          }
        }
        return emptyFunctionThatReturnsNull;
      }

      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];

        for (var i = 0; i < expectedValues.length; i++) {
          if (is(propValue, expectedValues[i])) {
            return null;
          }
        }

        var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
          var type = getPreciseType(value);

          if (type === 'symbol') {
            return String(value);
          }

          return value;
        });
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
      }

      return createChainableTypeChecker(validate);
    }

    function createObjectOfTypeChecker(typeChecker) {
      function validate(props, propName, componentName, location, propFullName) {
        if (typeof typeChecker !== 'function') {
          return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
        }

        var propValue = props[propName];
        var propType = getPropType(propValue);

        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
        }

        for (var key in propValue) {
          if (has$1(propValue, key)) {
            var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);

            if (error instanceof Error) {
              return error;
            }
          }
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function createUnionTypeChecker(arrayOfTypeCheckers) {
      if (!Array.isArray(arrayOfTypeCheckers)) {
        printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.');
        return emptyFunctionThatReturnsNull;
      }

      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];

        if (typeof checker !== 'function') {
          printWarning$1('Invalid argument supplied to oneOfType. Expected an array of check functions, but ' + 'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.');
          return emptyFunctionThatReturnsNull;
        }
      }

      function validate(props, propName, componentName, location, propFullName) {
        for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
          var checker = arrayOfTypeCheckers[i];

          if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
            return null;
          }
        }

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
      }

      return createChainableTypeChecker(validate);
    }

    function createNodeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        if (!isNode(props[propName])) {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function createShapeTypeChecker(shapeTypes) {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        var propType = getPropType(propValue);

        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
        }

        for (var key in shapeTypes) {
          var checker = shapeTypes[key];

          if (!checker) {
            continue;
          }

          var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);

          if (error) {
            return error;
          }
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function createStrictShapeTypeChecker(shapeTypes) {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        var propType = getPropType(propValue);

        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
        } // We need to check all keys in case some are required but missing from
        // props.


        var allKeys = objectAssign({}, props[propName], shapeTypes);

        for (var key in allKeys) {
          var checker = shapeTypes[key];

          if (!checker) {
            return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' + '\nBad object: ' + JSON.stringify(props[propName], null, '  ') + '\nValid keys: ' + JSON.stringify(Object.keys(shapeTypes), null, '  '));
          }

          var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);

          if (error) {
            return error;
          }
        }

        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function isNode(propValue) {
      switch (typeof propValue) {
        case 'number':
        case 'string':
        case 'undefined':
          return true;

        case 'boolean':
          return !propValue;

        case 'object':
          if (Array.isArray(propValue)) {
            return propValue.every(isNode);
          }

          if (propValue === null || isValidElement(propValue)) {
            return true;
          }

          var iteratorFn = getIteratorFn(propValue);

          if (iteratorFn) {
            var iterator = iteratorFn.call(propValue);
            var step;

            if (iteratorFn !== propValue.entries) {
              while (!(step = iterator.next()).done) {
                if (!isNode(step.value)) {
                  return false;
                }
              }
            } else {
              // Iterator will provide entry [k,v] tuples rather than values.
              while (!(step = iterator.next()).done) {
                var entry = step.value;

                if (entry) {
                  if (!isNode(entry[1])) {
                    return false;
                  }
                }
              }
            }
          } else {
            return false;
          }

          return true;

        default:
          return false;
      }
    }

    function isSymbol(propType, propValue) {
      // Native Symbol.
      if (propType === 'symbol') {
        return true;
      } // falsy value can't be a Symbol


      if (!propValue) {
        return false;
      } // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'


      if (propValue['@@toStringTag'] === 'Symbol') {
        return true;
      } // Fallback for non-spec compliant Symbols which are polyfilled.


      if (typeof Symbol === 'function' && propValue instanceof Symbol) {
        return true;
      }

      return false;
    } // Equivalent of `typeof` but with special handling for array and regexp.


    function getPropType(propValue) {
      var propType = typeof propValue;

      if (Array.isArray(propValue)) {
        return 'array';
      }

      if (propValue instanceof RegExp) {
        // Old webkits (at least until Android 4.0) return 'function' rather than
        // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
        // passes PropTypes.object.
        return 'object';
      }

      if (isSymbol(propType, propValue)) {
        return 'symbol';
      }

      return propType;
    } // This handles more types than `getPropType`. Only used for error messages.
    // See `createPrimitiveTypeChecker`.


    function getPreciseType(propValue) {
      if (typeof propValue === 'undefined' || propValue === null) {
        return '' + propValue;
      }

      var propType = getPropType(propValue);

      if (propType === 'object') {
        if (propValue instanceof Date) {
          return 'date';
        } else if (propValue instanceof RegExp) {
          return 'regexp';
        }
      }

      return propType;
    } // Returns a string that is postfixed to a warning about an invalid type.
    // For example, "undefined" or "of type array"


    function getPostfixForTypeWarning(value) {
      var type = getPreciseType(value);

      switch (type) {
        case 'array':
        case 'object':
          return 'an ' + type;

        case 'boolean':
        case 'date':
        case 'regexp':
          return 'a ' + type;

        default:
          return type;
      }
    } // Returns class name of the object, if any.


    function getClassName(propValue) {
      if (!propValue.constructor || !propValue.constructor.name) {
        return ANONYMOUS;
      }

      return propValue.constructor.name;
    }

    ReactPropTypes.checkPropTypes = checkPropTypes_1;
    ReactPropTypes.resetWarningCache = checkPropTypes_1.resetWarningCache;
    ReactPropTypes.PropTypes = ReactPropTypes;
    return ReactPropTypes;
  };

  var propTypes = createCommonjsModule(function (module) {
    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */
    {
      var ReactIs = reactIs; // By explicitly using `prop-types` you are opting into new development behavior.
      // http://fb.me/prop-types-in-prod

      var throwOnDirectAccess = true;
      module.exports = factoryWithTypeCheckers(ReactIs.isElement, throwOnDirectAccess);
    }
  });
  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var invariant = function invariant(condition, format, a, b, c, d, e, f) {
    {
      if (format === undefined) {
        throw new Error('invariant requires an error message argument');
      }
    }

    if (!condition) {
      var error;

      if (format === undefined) {
        error = new Error('Minified exception occurred; use the non-minified dev environment ' + 'for the full error message and additional helpful warnings.');
      } else {
        var args = [a, b, c, d, e, f];
        var argIndex = 0;
        error = new Error(format.replace(/%s/g, function () {
          return args[argIndex++];
        }));
        error.name = 'Invariant Violation';
      }

      error.framesToPop = 1; // we don't care about invariant's own frame

      throw error;
    }
  };

  var invariant_1 = invariant;
  /* eslint-disable no-undefined,no-param-reassign,no-shadow */

  /**
   * Throttle execution of a function. Especially useful for rate limiting
   * execution of handlers on events like resize and scroll.
   *
   * @param  {Number}    delay          A zero-or-greater delay in milliseconds. For event callbacks, values around 100 or 250 (or even higher) are most useful.
   * @param  {Boolean}   [noTrailing]   Optional, defaults to false. If noTrailing is true, callback will only execute every `delay` milliseconds while the
   *                                    throttled-function is being called. If noTrailing is false or unspecified, callback will be executed one final time
   *                                    after the last throttled-function call. (After the throttled-function has not been called for `delay` milliseconds,
   *                                    the internal counter is reset)
   * @param  {Function}  callback       A function to be executed after delay milliseconds. The `this` context and all arguments are passed through, as-is,
   *                                    to `callback` when the throttled-function is executed.
   * @param  {Boolean}   [debounceMode] If `debounceMode` is true (at begin), schedule `clear` to execute after `delay` ms. If `debounceMode` is false (at end),
   *                                    schedule `callback` to execute after `delay` ms.
   *
   * @return {Function}  A new, throttled, function.
   */

  function throttle(delay, noTrailing, callback, debounceMode) {
    /*
     * After wrapper has stopped being called, this timeout ensures that
     * `callback` is executed at the proper times in `throttle` and `end`
     * debounce modes.
     */
    var timeoutID;
    var cancelled = false; // Keep track of the last time `callback` was executed.

    var lastExec = 0; // Function to clear existing timeout

    function clearExistingTimeout() {
      if (timeoutID) {
        clearTimeout(timeoutID);
      }
    } // Function to cancel next exec


    function cancel() {
      clearExistingTimeout();
      cancelled = true;
    } // `noTrailing` defaults to falsy.


    if (typeof noTrailing !== 'boolean') {
      debounceMode = callback;
      callback = noTrailing;
      noTrailing = undefined;
    }
    /*
     * The `wrapper` function encapsulates all of the throttling / debouncing
     * functionality and when executed will limit the rate at which `callback`
     * is executed.
     */


    function wrapper() {
      var self = this;
      var elapsed = Date.now() - lastExec;
      var args = arguments;

      if (cancelled) {
        return;
      } // Execute `callback` and update the `lastExec` timestamp.


      function exec() {
        lastExec = Date.now();
        callback.apply(self, args);
      }
      /*
       * If `debounceMode` is true (at begin) this is used to clear the flag
       * to allow future `callback` executions.
       */


      function clear() {
        timeoutID = undefined;
      }

      if (debounceMode && !timeoutID) {
        /*
         * Since `wrapper` is being called for the first time and
         * `debounceMode` is true (at begin), execute `callback`.
         */
        exec();
      }

      clearExistingTimeout();

      if (debounceMode === undefined && elapsed > delay) {
        /*
         * In throttle mode, if `delay` time has been exceeded, execute
         * `callback`.
         */
        exec();
      } else if (noTrailing !== true) {
        /*
         * In trailing throttle mode, since `delay` time has not been
         * exceeded, schedule `callback` to execute `delay` ms after most
         * recent execution.
         *
         * If `debounceMode` is true (at begin), schedule `clear` to execute
         * after `delay` ms.
         *
         * If `debounceMode` is false (at end), schedule `callback` to
         * execute after `delay` ms.
         */
        timeoutID = setTimeout(debounceMode ? clear : exec, debounceMode === undefined ? delay - elapsed : delay);
      }
    }

    wrapper.cancel = cancel; // Return the wrapper function.

    return wrapper;
  }
  /* eslint-disable no-undefined */

  /**
   * Debounce execution of a function. Debouncing, unlike throttling,
   * guarantees that a function is only executed a single time, either at the
   * very beginning of a series of calls, or at the very end.
   *
   * @param  {Number}   delay         A zero-or-greater delay in milliseconds. For event callbacks, values around 100 or 250 (or even higher) are most useful.
   * @param  {Boolean}  [atBegin]     Optional, defaults to false. If atBegin is false or unspecified, callback will only be executed `delay` milliseconds
   *                                  after the last debounced-function call. If atBegin is true, callback will be executed only at the first debounced-function call.
   *                                  (After the throttled-function has not been called for `delay` milliseconds, the internal counter is reset).
   * @param  {Function} callback      A function to be executed after delay milliseconds. The `this` context and all arguments are passed through, as-is,
   *                                  to `callback` when the debounced-function is executed.
   *
   * @return {Function} A new, debounced function.
   */


  function debounce(delay, atBegin, callback) {
    return callback === undefined ? throttle(delay, atBegin, false) : throttle(delay, callback, atBegin !== false);
  }

  var index_esm =
  /*#__PURE__*/
  Object.freeze({
    throttle: throttle,
    debounce: debounce
  }); //

  var shallowequal = function shallowEqual(objA, objB, compare, compareContext) {
    var ret = compare ? compare.call(compareContext, objA, objB) : void 0;

    if (ret !== void 0) {
      return !!ret;
    }

    if (objA === objB) {
      return true;
    }

    if (typeof objA !== "object" || !objA || typeof objB !== "object" || !objB) {
      return false;
    }

    var keysA = Object.keys(objA);
    var keysB = Object.keys(objB);

    if (keysA.length !== keysB.length) {
      return false;
    }

    var bHasOwnProperty = Object.prototype.hasOwnProperty.bind(objB); // Test for A's keys different from B.

    for (var idx = 0; idx < keysA.length; idx++) {
      var key = keysA[idx];

      if (!bHasOwnProperty(key)) {
        return false;
      }

      var valueA = objA[key];
      var valueB = objB[key];
      ret = compare ? compare.call(compareContext, valueA, valueB, key) : void 0;

      if (ret === false || ret === void 0 && valueA !== valueB) {
        return false;
      }
    }

    return true;
  };

  function _interopDefault(ex) {
    return ex && typeof ex === 'object' && 'default' in ex ? ex['default'] : ex;
  }

  var createResizeDetector = _interopDefault(elementResizeDetector);

  var React__default = _interopDefault(React__default);

  var PropTypes = _interopDefault(propTypes);

  var ReactDOM = _interopDefault(reactDom);

  var invariant$1 = _interopDefault(invariant_1);

  var isShallowEqual = _interopDefault(shallowequal);

  var instances = {}; // Lazily require to not cause bug
  // https://github.com/ctrlplusb/react-sizeme/issues/6

  function resizeDetector() {
    var strategy = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'scroll';

    if (!instances[strategy]) {
      instances[strategy] = createResizeDetector({
        strategy: strategy
      });
    }

    return instances[strategy];
  }

  var classCallCheck = function classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var inherits = function inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  var objectWithoutProperties = function objectWithoutProperties(obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  };

  var possibleConstructorReturn = function possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };
  /* eslint-disable react/no-multi-comp */


  var errMsg = 'react-sizeme: an error occurred whilst stopping to listen to node size changes';
  var defaultConfig = {
    monitorWidth: true,
    monitorHeight: false,
    monitorPosition: false,
    refreshRate: 16,
    refreshMode: 'throttle',
    noPlaceholder: false,
    resizeDetectorStrategy: 'scroll'
  };

  function getDisplayName(WrappedComponent) {
    return WrappedComponent.displayName || WrappedComponent.name || 'Component';
  }
  /**
   * This is a utility wrapper component that will allow our higher order
   * component to get a ref handle on our wrapped components html.
   * @see https://gist.github.com/jimfb/32b587ee6177665fb4cf
   */


  var ReferenceWrapper = function (_Component) {
    inherits(ReferenceWrapper, _Component);

    function ReferenceWrapper() {
      classCallCheck(this, ReferenceWrapper);
      return possibleConstructorReturn(this, (ReferenceWrapper.__proto__ || Object.getPrototypeOf(ReferenceWrapper)).apply(this, arguments));
    }

    createClass(ReferenceWrapper, [{
      key: 'render',
      value: function render() {
        return React__default.Children.only(this.props.children);
      }
    }]);
    return ReferenceWrapper;
  }(React__default.Component);

  ReferenceWrapper.displayName = 'SizeMeReferenceWrapper';
  ReferenceWrapper.propTypes = {
    children: PropTypes.element.isRequired
  };

  function Placeholder(_ref) {
    var className = _ref.className,
        style = _ref.style; // Lets create the props for the temp element.

    var phProps = {}; // We will use any provided className/style or else make the temp
    // container take the full available space.

    if (!className && !style) {
      phProps.style = {
        width: '100%',
        height: '100%'
      };
    } else {
      if (className) {
        phProps.className = className;
      }

      if (style) {
        phProps.style = style;
      }
    }

    return React__default.createElement('div', phProps);
  }

  Placeholder.displayName = 'SizeMePlaceholder';
  Placeholder.propTypes = {
    className: PropTypes.string,
    style: PropTypes.object
    /**
     * As we need to maintain a ref on the root node that is rendered within our
     * SizeMe component we need to wrap our entire render in a sub component.
     * Without this, we lose the DOM ref after the placeholder is removed from
     * the render and the actual component is rendered.
     * It took me forever to figure this out, so tread extra careful on this one!
     */

  };

  var renderWrapper = function renderWrapper(WrappedComponent) {
    function SizeMeRenderer(props) {
      var explicitRef = props.explicitRef,
          className = props.className,
          style = props.style,
          size = props.size,
          disablePlaceholder = props.disablePlaceholder,
          onSize = props.onSize,
          restProps = objectWithoutProperties(props, ['explicitRef', 'className', 'style', 'size', 'disablePlaceholder', 'onSize']);
      var noSizeData = size == null || size.width == null && size.height == null && size.position == null;
      var renderPlaceholder = noSizeData && !disablePlaceholder;
      var renderProps = {
        className: className,
        style: style
      };

      if (size != null) {
        renderProps.size = size;
      }

      var toRender = renderPlaceholder ? React__default.createElement(Placeholder, {
        className: className,
        style: style
      }) : React__default.createElement(WrappedComponent, _extends({}, renderProps, restProps));
      return React__default.createElement(ReferenceWrapper, {
        ref: explicitRef
      }, toRender);
    }

    SizeMeRenderer.displayName = 'SizeMeRenderer(' + getDisplayName(WrappedComponent) + ')';
    SizeMeRenderer.propTypes = {
      explicitRef: PropTypes.func.isRequired,
      className: PropTypes.string,
      style: PropTypes.object,
      // eslint-disable-line react/forbid-prop-types
      size: PropTypes.shape({
        width: PropTypes.number,
        // eslint-disable-line react/no-unused-prop-types
        height: PropTypes.number // eslint-disable-line react/no-unused-prop-types

      }),
      disablePlaceholder: PropTypes.bool,
      onSize: PropTypes.func
    };
    return SizeMeRenderer;
  };
  /**
   * :: config -> Component -> WrappedComponent
   *
   * Higher order component that allows the wrapped component to become aware
   * of it's size, by receiving it as an object within it's props.
   *
   * @param  monitorWidth
   *   Default true, whether changes in the element's width should be monitored,
   *   causing a size property to be broadcast.
   * @param  monitorHeight
   *   Default false, whether changes in the element's height should be monitored,
   *   causing a size property to be broadcast.
   *
   * @return The wrapped component.
   */


  function withSize() {
    var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultConfig;
    var _config$monitorWidth = config.monitorWidth,
        monitorWidth = _config$monitorWidth === undefined ? defaultConfig.monitorWidth : _config$monitorWidth,
        _config$monitorHeight = config.monitorHeight,
        monitorHeight = _config$monitorHeight === undefined ? defaultConfig.monitorHeight : _config$monitorHeight,
        _config$monitorPositi = config.monitorPosition,
        monitorPosition = _config$monitorPositi === undefined ? defaultConfig.monitorPosition : _config$monitorPositi,
        _config$refreshRate = config.refreshRate,
        refreshRate = _config$refreshRate === undefined ? defaultConfig.refreshRate : _config$refreshRate,
        _config$refreshMode = config.refreshMode,
        refreshMode = _config$refreshMode === undefined ? defaultConfig.refreshMode : _config$refreshMode,
        _config$noPlaceholder = config.noPlaceholder,
        noPlaceholder = _config$noPlaceholder === undefined ? defaultConfig.noPlaceholder : _config$noPlaceholder,
        _config$resizeDetecto = config.resizeDetectorStrategy,
        resizeDetectorStrategy = _config$resizeDetecto === undefined ? defaultConfig.resizeDetectorStrategy : _config$resizeDetecto;
    invariant$1(monitorWidth || monitorHeight || monitorPosition, 'You have to monitor at least one of the width, height, or position when using "sizeMe"');
    invariant$1(refreshRate >= 16, "It is highly recommended that you don't put your refreshRate lower than " + '16 as this may cause layout thrashing.');
    invariant$1(refreshMode === 'throttle' || refreshMode === 'debounce', 'The refreshMode should have a value of "throttle" or "debounce"');
    var refreshDelayStrategy = refreshMode === 'throttle' ? index_esm.throttle : index_esm.debounce;
    return function WrapComponent(WrappedComponent) {
      var SizeMeRenderWrapper = renderWrapper(WrappedComponent);

      var SizeAwareComponent = function (_React$Component) {
        inherits(SizeAwareComponent, _React$Component);

        function SizeAwareComponent() {
          var _ref2;

          var _temp, _this2, _ret;

          classCallCheck(this, SizeAwareComponent);

          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return _ret = (_temp = (_this2 = possibleConstructorReturn(this, (_ref2 = SizeAwareComponent.__proto__ || Object.getPrototypeOf(SizeAwareComponent)).call.apply(_ref2, [this].concat(args))), _this2), _this2.domEl = null, _this2.state = {
            width: undefined,
            height: undefined,
            position: undefined
          }, _this2.uninstall = function () {
            if (_this2.domEl) {
              try {
                _this2.detector.uninstall(_this2.domEl);
              } catch (err) {
                // eslint-disable-next-line no-console
                console.warn(errMsg);
              }

              _this2.domEl = null;
            }
          }, _this2.determineStrategy = function (props) {
            if (props.onSize) {
              if (!_this2.callbackState) {
                _this2.callbackState = _extends({}, _this2.state);
              }

              _this2.strategy = 'callback';
            } else {
              _this2.strategy = 'render';
            }
          }, _this2.strategisedSetState = function (state) {
            if (_this2.strategy === 'callback') {
              _this2.callbackState = state;

              _this2.props.onSize(state);
            }

            _this2.setState(state);
          }, _this2.strategisedGetState = function () {
            return _this2.strategy === 'callback' ? _this2.callbackState : _this2.state;
          }, _this2.refCallback = function (element) {
            _this2.element = element;
          }, _this2.hasSizeChanged = function (current, next) {
            var c = current;
            var n = next;
            var cp = c.position || {};
            var np = n.position || {};
            return monitorWidth && c.width !== n.width || monitorHeight && c.height !== n.height || monitorPosition && (cp.top !== np.top || cp.left !== np.left || cp.bottom !== np.bottom || cp.right !== np.right);
          }, _this2.checkIfSizeChanged = refreshDelayStrategy(refreshRate, function (el) {
            var _el$getBoundingClient = el.getBoundingClientRect(),
                width = _el$getBoundingClient.width,
                height = _el$getBoundingClient.height,
                right = _el$getBoundingClient.right,
                left = _el$getBoundingClient.left,
                top = _el$getBoundingClient.top,
                bottom = _el$getBoundingClient.bottom;

            var next = {
              width: monitorWidth ? width : null,
              height: monitorHeight ? height : null,
              position: monitorPosition ? {
                right: right,
                left: left,
                top: top,
                bottom: bottom
              } : null
            };

            if (_this2.hasSizeChanged(_this2.strategisedGetState(), next)) {
              _this2.strategisedSetState(next);
            }
          }), _temp), possibleConstructorReturn(_this2, _ret);
        }

        createClass(SizeAwareComponent, [{
          key: 'componentDidMount',
          value: function componentDidMount() {
            this.detector = resizeDetector(resizeDetectorStrategy);
            this.determineStrategy(this.props);
            this.handleDOMNode();
          }
        }, {
          key: 'componentDidUpdate',
          value: function componentDidUpdate() {
            this.determineStrategy(this.props);
            this.handleDOMNode();
          }
        }, {
          key: 'componentWillUnmount',
          value: function componentWillUnmount() {
            // Change our size checker to a noop just in case we have some
            // late running events.
            this.hasSizeChanged = function () {
              return undefined;
            };

            this.checkIfSizeChanged = function () {
              return undefined;
            };

            this.uninstall();
          }
        }, {
          key: 'handleDOMNode',
          value: function handleDOMNode() {
            var found = this.element && ReactDOM.findDOMNode(this.element);

            if (!found) {
              // If we previously had a dom node then we need to ensure that
              // we remove any existing listeners to avoid memory leaks.
              this.uninstall();
              return;
            }

            if (!this.domEl) {
              this.domEl = found;
              this.detector.listenTo(this.domEl, this.checkIfSizeChanged);
            } else if (!this.domEl.isSameNode(found)) {
              this.uninstall();
              this.domEl = found;
              this.detector.listenTo(this.domEl, this.checkIfSizeChanged);
            }
          }
        }, {
          key: 'render',
          value: function render() {
            var disablePlaceholder = withSize.enableSSRBehaviour || withSize.noPlaceholders || noPlaceholder || this.strategy === 'callback';

            var size = _extends({}, this.state);

            return React__default.createElement(SizeMeRenderWrapper, _extends({
              explicitRef: this.refCallback,
              size: this.strategy === 'callback' ? null : size,
              disablePlaceholder: disablePlaceholder
            }, this.props));
          }
        }]);
        return SizeAwareComponent;
      }(React__default.Component);

      SizeAwareComponent.displayName = 'SizeMe(' + getDisplayName(WrappedComponent) + ')';
      SizeAwareComponent.propTypes = {
        onSize: PropTypes.func
      };
      SizeAwareComponent.WrappedComponent = WrappedComponent;
      return SizeAwareComponent;
    };
  }
  /**
   * Allow SizeMe to run within SSR environments.  This is a "global" behaviour
   * flag that should be set within the initialisation phase of your application.
   *
   * Warning: don't set this flag unless you need to as using it may cause
   * extra render cycles to happen within your components depending on the logic
   * contained within them around the usage of the `size` data.
   *
   * DEPRECATED: Please use the global noPlaceholders
   */


  withSize.enableSSRBehaviour = false;
  /**
   * Global configuration allowing to disable placeholder rendering for all
   * sizeMe components.
   */

  withSize.noPlaceholders = false;

  var SizeMe = function (_Component) {
    inherits(SizeMe, _Component);

    function SizeMe(props) {
      classCallCheck(this, SizeMe);

      var _this = possibleConstructorReturn(this, (SizeMe.__proto__ || Object.getPrototypeOf(SizeMe)).call(this, props));

      _initialiseProps.call(_this);

      var children = props.children,
          render = props.render,
          sizeMeConfig = objectWithoutProperties(props, ['children', 'render']);

      _this.createComponent(sizeMeConfig);

      _this.state = {
        size: {
          width: undefined,
          height: undefined
        }
      };
      return _this;
    }

    createClass(SizeMe, [{
      key: 'componentDidUpdate',
      value: function componentDidUpdate(prevProps) {
        var _props = this.props,
            prevChildren = _props.children,
            prevRender = _props.render,
            currentSizeMeConfig = objectWithoutProperties(_props, ['children', 'render']);
        var nextChildren = prevProps.children,
            nextRender = prevProps.render,
            prevSizeMeConfig = objectWithoutProperties(prevProps, ['children', 'render']);

        if (!isShallowEqual(currentSizeMeConfig, prevSizeMeConfig)) {
          this.createComponent(currentSizeMeConfig);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var SizeAware = this.SizeAware;
        var render = this.props.children || this.props.render;
        return React__default.createElement(SizeAware, {
          onSize: this.onSize
        }, render({
          size: this.state.size
        }));
      }
    }]);
    return SizeMe;
  }(React__default.Component);

  SizeMe.propTypes = {
    children: PropTypes.func,
    render: PropTypes.func
  };
  SizeMe.defaultProps = {
    children: undefined,
    render: undefined
  };

  var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.createComponent = function (config) {
      _this2.SizeAware = withSize(config)(function (_ref) {
        var children = _ref.children;
        return children;
      });
    };

    this.onSize = function (size) {
      return _this2.setState({
        size: size
      });
    };
  };

  withSize.SizeMe = SizeMe;
  withSize.withSize = withSize;
  var reactSizeme = withSize;

  function styleInject(css, ref) {
    if (ref === void 0) ref = {};
    var insertAt = ref.insertAt;

    if (!css || typeof document === 'undefined') {
      return;
    }

    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');
    style.type = 'text/css';

    if (insertAt === 'top') {
      if (head.firstChild) {
        head.insertBefore(style, head.firstChild);
      } else {
        head.appendChild(style);
      }
    } else {
      head.appendChild(style);
    }

    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }
  }

  var css = ".ui-module_container__257hB {\n  width: 100%;\n  padding: 0 20px;\n}\n.ui-module_actions__glWsk {\n  margin: 0 auto 24px;\n}\n.ui-module_output__og6ar {\n  display: inline-block;\n}\n.ui-module_output__og6ar:hover {\n  color: #fff;\n}\n.ui-module_row__3ZzEB {\n  height: 64px;\n  line-height: 64px;\n}\n.ui-module_normal__caA2b {\n  overflow: hidden;\n}\n.ui-module_buttonGroup__3CJiG > button {\n  margin-right: 8px;\n}\n.ui-module_formatGroup__2hCII {\n  text-align: right;\n}\n.ui-module_logContainer__3JQQL {\n  margin-top: 12px;\n  height: 90%;\n  overflow: hidden;\n}\n.ui-module_title__14x9F {\n  font-size: 16px;\n  color: rgba(255, 255, 255, 0.85);\n  line-height: 24px;\n  margin-top: 16px;\n  margin-bottom: 8px;\n}\n.ui-module_confirmMessage__3Lwxs {\n  margin-bottom: 24px;\n}\n.ui-module_modalContainer__3MMTO .ant-form-vertical .ant-form-item-label {\n  padding: 0 0 12px;\n}\n.ui-module_modleLableTitle__3SUA0 {\n  font-size: 14px;\n  color: rgba(255, 255, 255, 0.85);\n  line-height: 22px;\n  margin-bottom: 2px;\n}\n.ui-module_modleLableDesc__2gtyc {\n  font-size: 14px;\n  color: rgba(255, 255, 255, 0.45);\n  line-height: 22px;\n}\n";
  var styles = {
    "container": "ui-module_container__257hB",
    "actions": "ui-module_actions__glWsk",
    "output": "ui-module_output__og6ar",
    "row": "ui-module_row__3ZzEB",
    "normal": "ui-module_normal__caA2b",
    "buttonGroup": "ui-module_buttonGroup__3CJiG",
    "formatGroup": "ui-module_formatGroup__2hCII",
    "logContainer": "ui-module_logContainer__3JQQL",
    "title": "ui-module_title__14x9F",
    "confirmMessage": "ui-module_confirmMessage__3Lwxs",
    "modalContainer": "ui-module_modalContainer__3MMTO",
    "modleLableTitle": "ui-module_modleLableTitle__3SUA0",
    "modleLableDesc": "ui-module_modleLableDesc__2gtyc"
  };
  styleInject(css);
  var TaskState;

  (function (TaskState) {
    TaskState["INIT"] = "INIT";
    TaskState["ING"] = "ING";
    TaskState["SUCCESS"] = "SUCCESS";
    TaskState["FAIL"] = "FAIL";
  })(TaskState || (TaskState = {}));

  var TaskType;

  (function (TaskType) {
    TaskType["BUILD"] = "BUILD";
    TaskType["DEV"] = "DEV";
    TaskType["TEST"] = "TEST";
    TaskType["LINT"] = "LINT";
    TaskType["INSTALL"] = "INSTALL";
  })(TaskType || (TaskType = {}));

  var TaskEventType;

  (function (TaskEventType) {
    TaskEventType["STD_OUT_DATA"] = "STD_OUT_DATA";
    TaskEventType["STD_ERR_DATA"] = "STD_ERR_DATA";
    TaskEventType["STATE_EVENT"] = "STATE_EVENT";
  })(TaskEventType || (TaskEventType = {}));

  var LogType;

  (function (LogType) {
    LogType["STD_OUT"] = "STD_OUT";
    LogType["STD_ERR"] = "STD_ERR";
  })(LogType || (LogType = {}));

  var NpmClient;

  (function (NpmClient) {
    NpmClient["tnpm"] = "tnpm";
    NpmClient["cnpm"] = "cnpm";
    NpmClient["npm"] = "npm";
    NpmClient["ayarn"] = "ayarn";
    NpmClient["yarn"] = "yarn";
    NpmClient["pnpm"] = "pnpm";
  })(NpmClient || (NpmClient = {}));

  var TriggerState;

  (function (TriggerState) {
    TriggerState["SUCCESS"] = "SUCCESS";
    TriggerState["FAIL"] = "FAIL";
  })(TriggerState || (TriggerState = {}));

  var runTask =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(taskType, env) {
      var result, errMsg, triggerState;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              result = {};
              errMsg = '';
              triggerState = TriggerState.SUCCESS;
              _context.prev = 3;
              _context.next = 6;
              return callRemote({
                type: 'tasks/run',
                payload: {
                  type: taskType,
                  env: env ? env : {}
                }
              });

            case 6:
              result = _context.sent;
              _context.next = 13;
              break;

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](3);
              errMsg = _context.t0.message;
              triggerState = TriggerState.FAIL;

            case 13:
              return _context.abrupt("return", {
                triggerState: triggerState,
                result: result,
                errMsg: errMsg
              });

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[3, 9]]);
    }));

    return function runTask(_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  var cancelTask =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(taskType) {
      var result, errMsg, triggerState;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              result = {};
              errMsg = '';
              triggerState = TriggerState.SUCCESS;
              _context2.prev = 3;
              _context2.next = 6;
              return callRemote({
                type: 'tasks/cancel',
                payload: {
                  type: taskType
                }
              });

            case 6:
              result = _context2.sent;
              _context2.next = 13;
              break;

            case 9:
              _context2.prev = 9;
              _context2.t0 = _context2["catch"](3);
              errMsg = _context2.t0.stack;
              triggerState = TriggerState.FAIL;

            case 13:
              return _context2.abrupt("return", {
                triggerState: triggerState,
                result: result,
                errMsg: errMsg
              });

            case 14:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[3, 9]]);
    }));

    return function cancelTask(_x3) {
      return _ref2.apply(this, arguments);
    };
  }();

  var getTaskDetail =
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(taskType) {
      var result, errMsg, triggerState;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              result = {};
              errMsg = '';
              triggerState = TriggerState.SUCCESS;
              _context3.prev = 3;
              _context3.next = 6;
              return callRemote({
                type: 'tasks/detail',
                payload: {
                  type: taskType
                }
              });

            case 6:
              result = _context3.sent;
              _context3.next = 13;
              break;

            case 9:
              _context3.prev = 9;
              _context3.t0 = _context3["catch"](3);
              errMsg = _context3.t0.message;
              triggerState = TriggerState.FAIL;

            case 13:
              return _context3.abrupt("return", {
                triggerState: triggerState,
                result: result,
                errMsg: errMsg
              });

            case 14:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[3, 9]]);
    }));

    return function getTaskDetail(_x4) {
      return _ref3.apply(this, arguments);
    };
  }();

  var exec =
  /*#__PURE__*/
  function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(taskType, env) {
      var _ref5, runTaskTriggerState, errMsg;

      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return runTask(taskType, env);

            case 2:
              _ref5 = _context4.sent;
              runTaskTriggerState = _ref5.triggerState;
              errMsg = _ref5.errMsg;

              if (!(runTaskTriggerState === TriggerState.FAIL)) {
                _context4.next = 7;
                break;
              }

              return _context4.abrupt("return", {
                triggerState: TriggerState.FAIL,
                errMsg: errMsg,
                result: null
              });

            case 7:
              return _context4.abrupt("return", {
                triggerState: TriggerState.SUCCESS,
                errMsg: ''
              });

            case 8:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function exec(_x5, _x6) {
      return _ref4.apply(this, arguments);
    };
  }();

  var cancel =
  /*#__PURE__*/
  function () {
    var _ref6 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(taskType) {
      var _ref7, runTaskTriggerState, errMsg;

      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return cancelTask(taskType);

            case 2:
              _ref7 = _context5.sent;
              runTaskTriggerState = _ref7.triggerState;
              errMsg = _ref7.errMsg;

              if (!(runTaskTriggerState === TriggerState.FAIL)) {
                _context5.next = 7;
                break;
              }

              return _context5.abrupt("return", {
                triggerState: TriggerState.FAIL,
                errMsg: errMsg,
                result: null
              });

            case 7:
              return _context5.abrupt("return", {
                triggerState: TriggerState.SUCCESS,
                errMsg: ''
              });

            case 8:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function cancel(_x7) {
      return _ref6.apply(this, arguments);
    };
  }();

  var clearLog =
  /*#__PURE__*/
  function () {
    var _ref8 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(taskType) {
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return callRemote({
                type: 'tasks/clearLog',
                payload: {
                  type: taskType
                }
              });

            case 2:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));

    return function clearLog(_x8) {
      return _ref8.apply(this, arguments);
    };
  }();

  var xtermAddonWebLinks = createCommonjsModule(function (module, exports) {
    !function (e, t) {
      module.exports = t();
    }(window, function () {
      return function (e) {
        var t = {};

        function n(o) {
          if (t[o]) return t[o].exports;
          var r = t[o] = {
            i: o,
            l: !1,
            exports: {}
          };
          return e[o].call(r.exports, r, r.exports, n), r.l = !0, r.exports;
        }

        return n.m = e, n.c = t, n.d = function (e, t, o) {
          n.o(e, t) || Object.defineProperty(e, t, {
            enumerable: !0,
            get: o
          });
        }, n.r = function (e) {
          "undefined" != typeof Symbol && Symbol.toStringTag && Object.defineProperty(e, Symbol.toStringTag, {
            value: "Module"
          }), Object.defineProperty(e, "__esModule", {
            value: !0
          });
        }, n.t = function (e, t) {
          if (1 & t && (e = n(e)), 8 & t) return e;
          if (4 & t && "object" == typeof e && e && e.__esModule) return e;
          var o = Object.create(null);
          if (n.r(o), Object.defineProperty(o, "default", {
            enumerable: !0,
            value: e
          }), 2 & t && "string" != typeof e) for (var r in e) n.d(o, r, function (t) {
            return e[t];
          }.bind(null, r));
          return o;
        }, n.n = function (e) {
          var t = e && e.__esModule ? function () {
            return e.default;
          } : function () {
            return e;
          };
          return n.d(t, "a", t), t;
        }, n.o = function (e, t) {
          return Object.prototype.hasOwnProperty.call(e, t);
        }, n.p = "", n(n.s = 0);
      }([function (e, t, n) {
        Object.defineProperty(t, "__esModule", {
          value: !0
        });
        var o = new RegExp("(?:^|[^\\da-z\\.-]+)((https?:\\/\\/)((([\\da-z\\.-]+)\\.([a-z\\.]{2,6}))|((\\d{1,3}\\.){3}\\d{1,3})|(localhost))(:\\d{1,5})?((\\/[\\/\\w\\.\\-%~:+]*)*([^:\"'\\s]))?(\\?[0-9\\w\\[\\]\\(\\)\\/\\?\\!#@$%&'*+,:;~\\=\\.\\-]*)?(#[0-9\\w\\[\\]\\(\\)\\/\\?\\!#@$%&'*+,:;~\\=\\.\\-]*)?)($|[^\\/\\w\\.\\-%]+)");

        function r(e, t) {
          window.open(t, "_blank");
        }

        var i = function () {
          function e(e, t) {
            void 0 === e && (e = r), void 0 === t && (t = {}), this._handler = e, this._options = t, this._options.matchIndex = 1;
          }

          return e.prototype.activate = function (e) {
            this._terminal = e, this._linkMatcherId = this._terminal.registerLinkMatcher(o, this._handler, this._options);
          }, e.prototype.dispose = function () {
            void 0 !== this._linkMatcherId && void 0 !== this._terminal && this._terminal.deregisterLinkMatcher(this._linkMatcherId);
          }, e;
        }();

        t.WebLinksAddon = i;
      }]);
    });
  });
  unwrapExports(xtermAddonWebLinks);
  var xtermAddonWebLinks_1 = xtermAddonWebLinks.WebLinksAddon;
  var _window = window,
      fit = _window.fit,
      Terminal = _window.Terminal;

  function initTerminal() {
    Terminal.applyAddon(fit);
    var terminal = new Terminal({
      allowTransparency: true,
      theme: {
        background: '#15171C',
        foreground: '#ffffff73'
      },
      cursorBlink: false,
      cursorStyle: 'bar',
      disableStdin: true
    });
    terminal.loadAddon(new xtermAddonWebLinks_1());
    return terminal;
  }

  var TASKS = [TaskType.BUILD, TaskType.DEV, TaskType.LINT, TaskType.TEST, TaskType.INSTALL];
  var TERMINAL_MAPS = {};
  TASKS.forEach(function (taskType) {
    TERMINAL_MAPS[taskType] = initTerminal();
  });

  var getTerminalIns = function getTerminalIns(taskType) {
    return TERMINAL_MAPS[taskType];
  };

  var _TASK_TYPE_TEXT_MAP, _TASK_STATE_TEXT_MAP, _TaskType$BUILD, _TaskType$DEV, _TaskType$TEST, _TaskType$LINT, _TaskType$INSTALL, _NOTICE_MESSAGE_MAP;

  var TASK_TYPE_TEXT_MAP = (_TASK_TYPE_TEXT_MAP = {}, _defineProperty(_TASK_TYPE_TEXT_MAP, TaskType.BUILD, '构建'), _defineProperty(_TASK_TYPE_TEXT_MAP, TaskType.DEV, '本地开发'), _defineProperty(_TASK_TYPE_TEXT_MAP, TaskType.LINT, 'LINT'), _defineProperty(_TASK_TYPE_TEXT_MAP, TaskType.TEST, '测试'), _TASK_TYPE_TEXT_MAP);
  var TASK_STATE_TEXT_MAP = (_TASK_STATE_TEXT_MAP = {}, _defineProperty(_TASK_STATE_TEXT_MAP, TaskState.INIT, '初始化'), _defineProperty(_TASK_STATE_TEXT_MAP, TaskState.ING, '执行中'), _defineProperty(_TASK_STATE_TEXT_MAP, TaskState.SUCCESS, '执行成功'), _defineProperty(_TASK_STATE_TEXT_MAP, TaskState.FAIL, '执行失败'), _TASK_STATE_TEXT_MAP);

  var isCaredEvent = function isCaredEvent(taskType, caredTaskType) {
    if (!taskType || taskType !== caredTaskType) {
      return false;
    }

    return true;
  };

  var NOTICE_MESSAGE_MAP = (_NOTICE_MESSAGE_MAP = {}, _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.BUILD, (_TaskType$BUILD = {}, _defineProperty(_TaskType$BUILD, TaskState.SUCCESS, {
    title: '构建成功',
    message: '成功'
  }), _defineProperty(_TaskType$BUILD, TaskState.FAIL, {
    title: '构建失败',
    message: '失败'
  }), _TaskType$BUILD)), _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.DEV, (_TaskType$DEV = {}, _defineProperty(_TaskType$DEV, TaskState.SUCCESS, {
    title: '启动成功',
    message: '成功'
  }), _defineProperty(_TaskType$DEV, TaskState.FAIL, {
    title: '启动失败',
    message: '失败'
  }), _TaskType$DEV)), _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.TEST, (_TaskType$TEST = {}, _defineProperty(_TaskType$TEST, TaskState.SUCCESS, {
    title: '测试成功',
    message: '成功'
  }), _defineProperty(_TaskType$TEST, TaskState.FAIL, {
    title: '测试失败',
    message: '失败'
  }), _TaskType$TEST)), _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.LINT, (_TaskType$LINT = {}, _defineProperty(_TaskType$LINT, TaskState.SUCCESS, {
    title: '代码风格检查成功',
    message: '成功'
  }), _defineProperty(_TaskType$LINT, TaskState.FAIL, {
    title: '执行代码风格检查失败',
    message: '失败'
  }), _TaskType$LINT)), _defineProperty(_NOTICE_MESSAGE_MAP, TaskType.INSTALL, (_TaskType$INSTALL = {}, _defineProperty(_TaskType$INSTALL, TaskState.SUCCESS, {
    title: '安装依赖成功',
    message: '成功'
  }), _defineProperty(_TaskType$INSTALL, TaskState.FAIL, {
    title: '安装依赖失败',
    message: '失败'
  }), _TaskType$INSTALL)), _NOTICE_MESSAGE_MAP);

  function getNoticeMessage(taskType, state) {
    return _objectSpread2({
      type: state === TaskState.SUCCESS ? 'success' : 'error'
    }, NOTICE_MESSAGE_MAP[taskType][state]);
  }

  var callRemote;

  function initApiToGloal(api) {
    callRemote = api.callRemote; // eslint-disable-line
  }

  var useTaskDetail = function useTaskDetail(taskType) {
    var _useState = React.useState(true),
        _useState2 = _slicedToArray(_useState, 2),
        loading = _useState2[0],
        setLoading = _useState2[1];

    var _useState3 = React.useState({}),
        _useState4 = _slicedToArray(_useState3, 2),
        detail = _useState4[0],
        setDetail = _useState4[1];

    React.useEffect(function () {
      _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref2, result;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return getTaskDetail(taskType);

              case 3:
                _ref2 = _context.sent;
                result = _ref2.result;
                setLoading(false);
                setDetail(result);
                _context.next = 12;
                break;

              case 9:
                _context.prev = 9;
                _context.t0 = _context["catch"](0);
                setLoading(false);

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[0, 9]]);
      }))();
    }, []);
    return {
      loading: loading,
      detail: detail
    };
  };

  var useTerminal = function useTerminal(_ref) {
    var terminal = _ref.terminal,
        container = _ref.ref;
    React.useEffect(function () {
      if (!container) {
        return;
      }

      terminal.open(container);
      terminal.fit();
    }, [container]);
  };

  var usePrevious = function usePrevious(value) {
    var ref = React.useRef();
    React.useEffect(function () {
      ref.current = value;
    }, [value]);
    return ref.current;
  };

  var classnames = createCommonjsModule(function (module) {
    /*!
      Copyright (c) 2017 Jed Watson.
      Licensed under the MIT License (MIT), see
      http://jedwatson.github.io/classnames
    */

    /* global define */
    (function () {
      var hasOwn = {}.hasOwnProperty;

      function classNames() {
        var classes = [];

        for (var i = 0; i < arguments.length; i++) {
          var arg = arguments[i];
          if (!arg) continue;
          var argType = typeof arg;

          if (argType === 'string' || argType === 'number') {
            classes.push(arg);
          } else if (Array.isArray(arg) && arg.length) {
            var inner = classNames.apply(null, arg);

            if (inner) {
              classes.push(inner);
            }
          } else if (argType === 'object') {
            for (var key in arg) {
              if (hasOwn.call(arg, key) && arg[key]) {
                classes.push(key);
              }
            }
          }
        }

        return classes.join(' ');
      }

      if (module.exports) {
        classNames.default = classNames;
        module.exports = classNames;
      } else {
        window.classNames = classNames;
      }
    })();
  });
  var tinycolor = createCommonjsModule(function (module) {
    // TinyColor v1.4.1
    // https://github.com/bgrins/TinyColor
    // Brian Grinstead, MIT License
    (function (Math) {
      var trimLeft = /^\s+/,
          trimRight = /\s+$/,
          tinyCounter = 0,
          mathRound = Math.round,
          mathMin = Math.min,
          mathMax = Math.max,
          mathRandom = Math.random;

      function tinycolor(color, opts) {
        color = color ? color : '';
        opts = opts || {}; // If input is already a tinycolor, return itself

        if (color instanceof tinycolor) {
          return color;
        } // If we are called as a function, call using new instead


        if (!(this instanceof tinycolor)) {
          return new tinycolor(color, opts);
        }

        var rgb = inputToRGB(color);
        this._originalInput = color, this._r = rgb.r, this._g = rgb.g, this._b = rgb.b, this._a = rgb.a, this._roundA = mathRound(100 * this._a) / 100, this._format = opts.format || rgb.format;
        this._gradientType = opts.gradientType; // Don't let the range of [0,255] come back in [0,1].
        // Potentially lose a little bit of precision here, but will fix issues where
        // .5 gets interpreted as half of the total, instead of half of 1
        // If it was supposed to be 128, this was already taken care of by `inputToRgb`

        if (this._r < 1) {
          this._r = mathRound(this._r);
        }

        if (this._g < 1) {
          this._g = mathRound(this._g);
        }

        if (this._b < 1) {
          this._b = mathRound(this._b);
        }

        this._ok = rgb.ok;
        this._tc_id = tinyCounter++;
      }

      tinycolor.prototype = {
        isDark: function isDark() {
          return this.getBrightness() < 128;
        },
        isLight: function isLight() {
          return !this.isDark();
        },
        isValid: function isValid() {
          return this._ok;
        },
        getOriginalInput: function getOriginalInput() {
          return this._originalInput;
        },
        getFormat: function getFormat() {
          return this._format;
        },
        getAlpha: function getAlpha() {
          return this._a;
        },
        getBrightness: function getBrightness() {
          //http://www.w3.org/TR/AERT#color-contrast
          var rgb = this.toRgb();
          return (rgb.r * 299 + rgb.g * 587 + rgb.b * 114) / 1000;
        },
        getLuminance: function getLuminance() {
          //http://www.w3.org/TR/2008/REC-WCAG20-20081211/#relativeluminancedef
          var rgb = this.toRgb();
          var RsRGB, GsRGB, BsRGB, R, G, B;
          RsRGB = rgb.r / 255;
          GsRGB = rgb.g / 255;
          BsRGB = rgb.b / 255;

          if (RsRGB <= 0.03928) {
            R = RsRGB / 12.92;
          } else {
            R = Math.pow((RsRGB + 0.055) / 1.055, 2.4);
          }

          if (GsRGB <= 0.03928) {
            G = GsRGB / 12.92;
          } else {
            G = Math.pow((GsRGB + 0.055) / 1.055, 2.4);
          }

          if (BsRGB <= 0.03928) {
            B = BsRGB / 12.92;
          } else {
            B = Math.pow((BsRGB + 0.055) / 1.055, 2.4);
          }

          return 0.2126 * R + 0.7152 * G + 0.0722 * B;
        },
        setAlpha: function setAlpha(value) {
          this._a = boundAlpha(value);
          this._roundA = mathRound(100 * this._a) / 100;
          return this;
        },
        toHsv: function toHsv() {
          var hsv = rgbToHsv(this._r, this._g, this._b);
          return {
            h: hsv.h * 360,
            s: hsv.s,
            v: hsv.v,
            a: this._a
          };
        },
        toHsvString: function toHsvString() {
          var hsv = rgbToHsv(this._r, this._g, this._b);
          var h = mathRound(hsv.h * 360),
              s = mathRound(hsv.s * 100),
              v = mathRound(hsv.v * 100);
          return this._a == 1 ? "hsv(" + h + ", " + s + "%, " + v + "%)" : "hsva(" + h + ", " + s + "%, " + v + "%, " + this._roundA + ")";
        },
        toHsl: function toHsl() {
          var hsl = rgbToHsl(this._r, this._g, this._b);
          return {
            h: hsl.h * 360,
            s: hsl.s,
            l: hsl.l,
            a: this._a
          };
        },
        toHslString: function toHslString() {
          var hsl = rgbToHsl(this._r, this._g, this._b);
          var h = mathRound(hsl.h * 360),
              s = mathRound(hsl.s * 100),
              l = mathRound(hsl.l * 100);
          return this._a == 1 ? "hsl(" + h + ", " + s + "%, " + l + "%)" : "hsla(" + h + ", " + s + "%, " + l + "%, " + this._roundA + ")";
        },
        toHex: function toHex(allow3Char) {
          return rgbToHex(this._r, this._g, this._b, allow3Char);
        },
        toHexString: function toHexString(allow3Char) {
          return '#' + this.toHex(allow3Char);
        },
        toHex8: function toHex8(allow4Char) {
          return rgbaToHex(this._r, this._g, this._b, this._a, allow4Char);
        },
        toHex8String: function toHex8String(allow4Char) {
          return '#' + this.toHex8(allow4Char);
        },
        toRgb: function toRgb() {
          return {
            r: mathRound(this._r),
            g: mathRound(this._g),
            b: mathRound(this._b),
            a: this._a
          };
        },
        toRgbString: function toRgbString() {
          return this._a == 1 ? "rgb(" + mathRound(this._r) + ", " + mathRound(this._g) + ", " + mathRound(this._b) + ")" : "rgba(" + mathRound(this._r) + ", " + mathRound(this._g) + ", " + mathRound(this._b) + ", " + this._roundA + ")";
        },
        toPercentageRgb: function toPercentageRgb() {
          return {
            r: mathRound(bound01(this._r, 255) * 100) + "%",
            g: mathRound(bound01(this._g, 255) * 100) + "%",
            b: mathRound(bound01(this._b, 255) * 100) + "%",
            a: this._a
          };
        },
        toPercentageRgbString: function toPercentageRgbString() {
          return this._a == 1 ? "rgb(" + mathRound(bound01(this._r, 255) * 100) + "%, " + mathRound(bound01(this._g, 255) * 100) + "%, " + mathRound(bound01(this._b, 255) * 100) + "%)" : "rgba(" + mathRound(bound01(this._r, 255) * 100) + "%, " + mathRound(bound01(this._g, 255) * 100) + "%, " + mathRound(bound01(this._b, 255) * 100) + "%, " + this._roundA + ")";
        },
        toName: function toName() {
          if (this._a === 0) {
            return "transparent";
          }

          if (this._a < 1) {
            return false;
          }

          return hexNames[rgbToHex(this._r, this._g, this._b, true)] || false;
        },
        toFilter: function toFilter(secondColor) {
          var hex8String = '#' + rgbaToArgbHex(this._r, this._g, this._b, this._a);
          var secondHex8String = hex8String;
          var gradientType = this._gradientType ? "GradientType = 1, " : "";

          if (secondColor) {
            var s = tinycolor(secondColor);
            secondHex8String = '#' + rgbaToArgbHex(s._r, s._g, s._b, s._a);
          }

          return "progid:DXImageTransform.Microsoft.gradient(" + gradientType + "startColorstr=" + hex8String + ",endColorstr=" + secondHex8String + ")";
        },
        toString: function toString(format) {
          var formatSet = !!format;
          format = format || this._format;
          var formattedString = false;
          var hasAlpha = this._a < 1 && this._a >= 0;
          var needsAlphaFormat = !formatSet && hasAlpha && (format === "hex" || format === "hex6" || format === "hex3" || format === "hex4" || format === "hex8" || format === "name");

          if (needsAlphaFormat) {
            // Special case for "transparent", all other non-alpha formats
            // will return rgba when there is transparency.
            if (format === "name" && this._a === 0) {
              return this.toName();
            }

            return this.toRgbString();
          }

          if (format === "rgb") {
            formattedString = this.toRgbString();
          }

          if (format === "prgb") {
            formattedString = this.toPercentageRgbString();
          }

          if (format === "hex" || format === "hex6") {
            formattedString = this.toHexString();
          }

          if (format === "hex3") {
            formattedString = this.toHexString(true);
          }

          if (format === "hex4") {
            formattedString = this.toHex8String(true);
          }

          if (format === "hex8") {
            formattedString = this.toHex8String();
          }

          if (format === "name") {
            formattedString = this.toName();
          }

          if (format === "hsl") {
            formattedString = this.toHslString();
          }

          if (format === "hsv") {
            formattedString = this.toHsvString();
          }

          return formattedString || this.toHexString();
        },
        clone: function clone() {
          return tinycolor(this.toString());
        },
        _applyModification: function _applyModification(fn, args) {
          var color = fn.apply(null, [this].concat([].slice.call(args)));
          this._r = color._r;
          this._g = color._g;
          this._b = color._b;
          this.setAlpha(color._a);
          return this;
        },
        lighten: function lighten() {
          return this._applyModification(_lighten, arguments);
        },
        brighten: function brighten() {
          return this._applyModification(_brighten, arguments);
        },
        darken: function darken() {
          return this._applyModification(_darken, arguments);
        },
        desaturate: function desaturate() {
          return this._applyModification(_desaturate, arguments);
        },
        saturate: function saturate() {
          return this._applyModification(_saturate, arguments);
        },
        greyscale: function greyscale() {
          return this._applyModification(_greyscale, arguments);
        },
        spin: function spin() {
          return this._applyModification(_spin, arguments);
        },
        _applyCombination: function _applyCombination(fn, args) {
          return fn.apply(null, [this].concat([].slice.call(args)));
        },
        analogous: function analogous() {
          return this._applyCombination(_analogous, arguments);
        },
        complement: function complement() {
          return this._applyCombination(_complement, arguments);
        },
        monochromatic: function monochromatic() {
          return this._applyCombination(_monochromatic, arguments);
        },
        splitcomplement: function splitcomplement() {
          return this._applyCombination(_splitcomplement, arguments);
        },
        triad: function triad() {
          return this._applyCombination(_triad, arguments);
        },
        tetrad: function tetrad() {
          return this._applyCombination(_tetrad, arguments);
        }
      }; // If input is an object, force 1 into "1.0" to handle ratios properly
      // String input requires "1.0" as input, so 1 will be treated as 1

      tinycolor.fromRatio = function (color, opts) {
        if (typeof color == "object") {
          var newColor = {};

          for (var i in color) {
            if (color.hasOwnProperty(i)) {
              if (i === "a") {
                newColor[i] = color[i];
              } else {
                newColor[i] = convertToPercentage(color[i]);
              }
            }
          }

          color = newColor;
        }

        return tinycolor(color, opts);
      }; // Given a string or object, convert that input to RGB
      // Possible string inputs:
      //
      //     "red"
      //     "#f00" or "f00"
      //     "#ff0000" or "ff0000"
      //     "#ff000000" or "ff000000"
      //     "rgb 255 0 0" or "rgb (255, 0, 0)"
      //     "rgb 1.0 0 0" or "rgb (1, 0, 0)"
      //     "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
      //     "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
      //     "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
      //     "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
      //     "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
      //


      function inputToRGB(color) {
        var rgb = {
          r: 0,
          g: 0,
          b: 0
        };
        var a = 1;
        var s = null;
        var v = null;
        var l = null;
        var ok = false;
        var format = false;

        if (typeof color == "string") {
          color = stringInputToObject(color);
        }

        if (typeof color == "object") {
          if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
            rgb = rgbToRgb(color.r, color.g, color.b);
            ok = true;
            format = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
          } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
            s = convertToPercentage(color.s);
            v = convertToPercentage(color.v);
            rgb = hsvToRgb(color.h, s, v);
            ok = true;
            format = "hsv";
          } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
            s = convertToPercentage(color.s);
            l = convertToPercentage(color.l);
            rgb = hslToRgb(color.h, s, l);
            ok = true;
            format = "hsl";
          }

          if (color.hasOwnProperty("a")) {
            a = color.a;
          }
        }

        a = boundAlpha(a);
        return {
          ok: ok,
          format: color.format || format,
          r: mathMin(255, mathMax(rgb.r, 0)),
          g: mathMin(255, mathMax(rgb.g, 0)),
          b: mathMin(255, mathMax(rgb.b, 0)),
          a: a
        };
      } // Conversion Functions
      // --------------------
      // `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
      // <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>
      // `rgbToRgb`
      // Handle bounds / percentage checking to conform to CSS color spec
      // <http://www.w3.org/TR/css3-color/>
      // *Assumes:* r, g, b in [0, 255] or [0, 1]
      // *Returns:* { r, g, b } in [0, 255]


      function rgbToRgb(r, g, b) {
        return {
          r: bound01(r, 255) * 255,
          g: bound01(g, 255) * 255,
          b: bound01(b, 255) * 255
        };
      } // `rgbToHsl`
      // Converts an RGB color value to HSL.
      // *Assumes:* r, g, and b are contained in [0, 255] or [0, 1]
      // *Returns:* { h, s, l } in [0,1]


      function rgbToHsl(r, g, b) {
        r = bound01(r, 255);
        g = bound01(g, 255);
        b = bound01(b, 255);
        var max = mathMax(r, g, b),
            min = mathMin(r, g, b);
        var h,
            s,
            l = (max + min) / 2;

        if (max == min) {
          h = s = 0; // achromatic
        } else {
          var d = max - min;
          s = l > 0.5 ? d / (2 - max - min) : d / (max + min);

          switch (max) {
            case r:
              h = (g - b) / d + (g < b ? 6 : 0);
              break;

            case g:
              h = (b - r) / d + 2;
              break;

            case b:
              h = (r - g) / d + 4;
              break;
          }

          h /= 6;
        }

        return {
          h: h,
          s: s,
          l: l
        };
      } // `hslToRgb`
      // Converts an HSL color value to RGB.
      // *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
      // *Returns:* { r, g, b } in the set [0, 255]


      function hslToRgb(h, s, l) {
        var r, g, b;
        h = bound01(h, 360);
        s = bound01(s, 100);
        l = bound01(l, 100);

        function hue2rgb(p, q, t) {
          if (t < 0) t += 1;
          if (t > 1) t -= 1;
          if (t < 1 / 6) return p + (q - p) * 6 * t;
          if (t < 1 / 2) return q;
          if (t < 2 / 3) return p + (q - p) * (2 / 3 - t) * 6;
          return p;
        }

        if (s === 0) {
          r = g = b = l; // achromatic
        } else {
          var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
          var p = 2 * l - q;
          r = hue2rgb(p, q, h + 1 / 3);
          g = hue2rgb(p, q, h);
          b = hue2rgb(p, q, h - 1 / 3);
        }

        return {
          r: r * 255,
          g: g * 255,
          b: b * 255
        };
      } // `rgbToHsv`
      // Converts an RGB color value to HSV
      // *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
      // *Returns:* { h, s, v } in [0,1]


      function rgbToHsv(r, g, b) {
        r = bound01(r, 255);
        g = bound01(g, 255);
        b = bound01(b, 255);
        var max = mathMax(r, g, b),
            min = mathMin(r, g, b);
        var h,
            s,
            v = max;
        var d = max - min;
        s = max === 0 ? 0 : d / max;

        if (max == min) {
          h = 0; // achromatic
        } else {
          switch (max) {
            case r:
              h = (g - b) / d + (g < b ? 6 : 0);
              break;

            case g:
              h = (b - r) / d + 2;
              break;

            case b:
              h = (r - g) / d + 4;
              break;
          }

          h /= 6;
        }

        return {
          h: h,
          s: s,
          v: v
        };
      } // `hsvToRgb`
      // Converts an HSV color value to RGB.
      // *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
      // *Returns:* { r, g, b } in the set [0, 255]


      function hsvToRgb(h, s, v) {
        h = bound01(h, 360) * 6;
        s = bound01(s, 100);
        v = bound01(v, 100);
        var i = Math.floor(h),
            f = h - i,
            p = v * (1 - s),
            q = v * (1 - f * s),
            t = v * (1 - (1 - f) * s),
            mod = i % 6,
            r = [v, q, p, p, t, v][mod],
            g = [t, v, v, q, p, p][mod],
            b = [p, p, t, v, v, q][mod];
        return {
          r: r * 255,
          g: g * 255,
          b: b * 255
        };
      } // `rgbToHex`
      // Converts an RGB color to hex
      // Assumes r, g, and b are contained in the set [0, 255]
      // Returns a 3 or 6 character hex


      function rgbToHex(r, g, b, allow3Char) {
        var hex = [pad2(mathRound(r).toString(16)), pad2(mathRound(g).toString(16)), pad2(mathRound(b).toString(16))]; // Return a 3 character hex if possible

        if (allow3Char && hex[0].charAt(0) == hex[0].charAt(1) && hex[1].charAt(0) == hex[1].charAt(1) && hex[2].charAt(0) == hex[2].charAt(1)) {
          return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
        }

        return hex.join("");
      } // `rgbaToHex`
      // Converts an RGBA color plus alpha transparency to hex
      // Assumes r, g, b are contained in the set [0, 255] and
      // a in [0, 1]. Returns a 4 or 8 character rgba hex


      function rgbaToHex(r, g, b, a, allow4Char) {
        var hex = [pad2(mathRound(r).toString(16)), pad2(mathRound(g).toString(16)), pad2(mathRound(b).toString(16)), pad2(convertDecimalToHex(a))]; // Return a 4 character hex if possible

        if (allow4Char && hex[0].charAt(0) == hex[0].charAt(1) && hex[1].charAt(0) == hex[1].charAt(1) && hex[2].charAt(0) == hex[2].charAt(1) && hex[3].charAt(0) == hex[3].charAt(1)) {
          return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0) + hex[3].charAt(0);
        }

        return hex.join("");
      } // `rgbaToArgbHex`
      // Converts an RGBA color to an ARGB Hex8 string
      // Rarely used, but required for "toFilter()"


      function rgbaToArgbHex(r, g, b, a) {
        var hex = [pad2(convertDecimalToHex(a)), pad2(mathRound(r).toString(16)), pad2(mathRound(g).toString(16)), pad2(mathRound(b).toString(16))];
        return hex.join("");
      } // `equals`
      // Can be called with any tinycolor input


      tinycolor.equals = function (color1, color2) {
        if (!color1 || !color2) {
          return false;
        }

        return tinycolor(color1).toRgbString() == tinycolor(color2).toRgbString();
      };

      tinycolor.random = function () {
        return tinycolor.fromRatio({
          r: mathRandom(),
          g: mathRandom(),
          b: mathRandom()
        });
      }; // Modification Functions
      // ----------------------
      // Thanks to less.js for some of the basics here
      // <https://github.com/cloudhead/less.js/blob/master/lib/less/functions.js>


      function _desaturate(color, amount) {
        amount = amount === 0 ? 0 : amount || 10;
        var hsl = tinycolor(color).toHsl();
        hsl.s -= amount / 100;
        hsl.s = clamp01(hsl.s);
        return tinycolor(hsl);
      }

      function _saturate(color, amount) {
        amount = amount === 0 ? 0 : amount || 10;
        var hsl = tinycolor(color).toHsl();
        hsl.s += amount / 100;
        hsl.s = clamp01(hsl.s);
        return tinycolor(hsl);
      }

      function _greyscale(color) {
        return tinycolor(color).desaturate(100);
      }

      function _lighten(color, amount) {
        amount = amount === 0 ? 0 : amount || 10;
        var hsl = tinycolor(color).toHsl();
        hsl.l += amount / 100;
        hsl.l = clamp01(hsl.l);
        return tinycolor(hsl);
      }

      function _brighten(color, amount) {
        amount = amount === 0 ? 0 : amount || 10;
        var rgb = tinycolor(color).toRgb();
        rgb.r = mathMax(0, mathMin(255, rgb.r - mathRound(255 * -(amount / 100))));
        rgb.g = mathMax(0, mathMin(255, rgb.g - mathRound(255 * -(amount / 100))));
        rgb.b = mathMax(0, mathMin(255, rgb.b - mathRound(255 * -(amount / 100))));
        return tinycolor(rgb);
      }

      function _darken(color, amount) {
        amount = amount === 0 ? 0 : amount || 10;
        var hsl = tinycolor(color).toHsl();
        hsl.l -= amount / 100;
        hsl.l = clamp01(hsl.l);
        return tinycolor(hsl);
      } // Spin takes a positive or negative amount within [-360, 360] indicating the change of hue.
      // Values outside of this range will be wrapped into this range.


      function _spin(color, amount) {
        var hsl = tinycolor(color).toHsl();
        var hue = (hsl.h + amount) % 360;
        hsl.h = hue < 0 ? 360 + hue : hue;
        return tinycolor(hsl);
      } // Combination Functions
      // ---------------------
      // Thanks to jQuery xColor for some of the ideas behind these
      // <https://github.com/infusion/jQuery-xcolor/blob/master/jquery.xcolor.js>


      function _complement(color) {
        var hsl = tinycolor(color).toHsl();
        hsl.h = (hsl.h + 180) % 360;
        return tinycolor(hsl);
      }

      function _triad(color) {
        var hsl = tinycolor(color).toHsl();
        var h = hsl.h;
        return [tinycolor(color), tinycolor({
          h: (h + 120) % 360,
          s: hsl.s,
          l: hsl.l
        }), tinycolor({
          h: (h + 240) % 360,
          s: hsl.s,
          l: hsl.l
        })];
      }

      function _tetrad(color) {
        var hsl = tinycolor(color).toHsl();
        var h = hsl.h;
        return [tinycolor(color), tinycolor({
          h: (h + 90) % 360,
          s: hsl.s,
          l: hsl.l
        }), tinycolor({
          h: (h + 180) % 360,
          s: hsl.s,
          l: hsl.l
        }), tinycolor({
          h: (h + 270) % 360,
          s: hsl.s,
          l: hsl.l
        })];
      }

      function _splitcomplement(color) {
        var hsl = tinycolor(color).toHsl();
        var h = hsl.h;
        return [tinycolor(color), tinycolor({
          h: (h + 72) % 360,
          s: hsl.s,
          l: hsl.l
        }), tinycolor({
          h: (h + 216) % 360,
          s: hsl.s,
          l: hsl.l
        })];
      }

      function _analogous(color, results, slices) {
        results = results || 6;
        slices = slices || 30;
        var hsl = tinycolor(color).toHsl();
        var part = 360 / slices;
        var ret = [tinycolor(color)];

        for (hsl.h = (hsl.h - (part * results >> 1) + 720) % 360; --results;) {
          hsl.h = (hsl.h + part) % 360;
          ret.push(tinycolor(hsl));
        }

        return ret;
      }

      function _monochromatic(color, results) {
        results = results || 6;
        var hsv = tinycolor(color).toHsv();
        var h = hsv.h,
            s = hsv.s,
            v = hsv.v;
        var ret = [];
        var modification = 1 / results;

        while (results--) {
          ret.push(tinycolor({
            h: h,
            s: s,
            v: v
          }));
          v = (v + modification) % 1;
        }

        return ret;
      } // Utility Functions
      // ---------------------


      tinycolor.mix = function (color1, color2, amount) {
        amount = amount === 0 ? 0 : amount || 50;
        var rgb1 = tinycolor(color1).toRgb();
        var rgb2 = tinycolor(color2).toRgb();
        var p = amount / 100;
        var rgba = {
          r: (rgb2.r - rgb1.r) * p + rgb1.r,
          g: (rgb2.g - rgb1.g) * p + rgb1.g,
          b: (rgb2.b - rgb1.b) * p + rgb1.b,
          a: (rgb2.a - rgb1.a) * p + rgb1.a
        };
        return tinycolor(rgba);
      }; // Readability Functions
      // ---------------------
      // <http://www.w3.org/TR/2008/REC-WCAG20-20081211/#contrast-ratiodef (WCAG Version 2)
      // `contrast`
      // Analyze the 2 colors and returns the color contrast defined by (WCAG Version 2)


      tinycolor.readability = function (color1, color2) {
        var c1 = tinycolor(color1);
        var c2 = tinycolor(color2);
        return (Math.max(c1.getLuminance(), c2.getLuminance()) + 0.05) / (Math.min(c1.getLuminance(), c2.getLuminance()) + 0.05);
      }; // `isReadable`
      // Ensure that foreground and background color combinations meet WCAG2 guidelines.
      // The third argument is an optional Object.
      //      the 'level' property states 'AA' or 'AAA' - if missing or invalid, it defaults to 'AA';
      //      the 'size' property states 'large' or 'small' - if missing or invalid, it defaults to 'small'.
      // If the entire object is absent, isReadable defaults to {level:"AA",size:"small"}.
      // *Example*
      //    tinycolor.isReadable("#000", "#111") => false
      //    tinycolor.isReadable("#000", "#111",{level:"AA",size:"large"}) => false


      tinycolor.isReadable = function (color1, color2, wcag2) {
        var readability = tinycolor.readability(color1, color2);
        var wcag2Parms, out;
        out = false;
        wcag2Parms = validateWCAG2Parms(wcag2);

        switch (wcag2Parms.level + wcag2Parms.size) {
          case "AAsmall":
          case "AAAlarge":
            out = readability >= 4.5;
            break;

          case "AAlarge":
            out = readability >= 3;
            break;

          case "AAAsmall":
            out = readability >= 7;
            break;
        }

        return out;
      }; // `mostReadable`
      // Given a base color and a list of possible foreground or background
      // colors for that base, returns the most readable color.
      // Optionally returns Black or White if the most readable color is unreadable.
      // *Example*
      //    tinycolor.mostReadable(tinycolor.mostReadable("#123", ["#124", "#125"],{includeFallbackColors:false}).toHexString(); // "#112255"
      //    tinycolor.mostReadable(tinycolor.mostReadable("#123", ["#124", "#125"],{includeFallbackColors:true}).toHexString();  // "#ffffff"
      //    tinycolor.mostReadable("#a8015a", ["#faf3f3"],{includeFallbackColors:true,level:"AAA",size:"large"}).toHexString(); // "#faf3f3"
      //    tinycolor.mostReadable("#a8015a", ["#faf3f3"],{includeFallbackColors:true,level:"AAA",size:"small"}).toHexString(); // "#ffffff"


      tinycolor.mostReadable = function (baseColor, colorList, args) {
        var bestColor = null;
        var bestScore = 0;
        var readability;
        var includeFallbackColors, level, size;
        args = args || {};
        includeFallbackColors = args.includeFallbackColors;
        level = args.level;
        size = args.size;

        for (var i = 0; i < colorList.length; i++) {
          readability = tinycolor.readability(baseColor, colorList[i]);

          if (readability > bestScore) {
            bestScore = readability;
            bestColor = tinycolor(colorList[i]);
          }
        }

        if (tinycolor.isReadable(baseColor, bestColor, {
          "level": level,
          "size": size
        }) || !includeFallbackColors) {
          return bestColor;
        } else {
          args.includeFallbackColors = false;
          return tinycolor.mostReadable(baseColor, ["#fff", "#000"], args);
        }
      }; // Big List of Colors
      // ------------------
      // <http://www.w3.org/TR/css3-color/#svg-color>


      var names = tinycolor.names = {
        aliceblue: "f0f8ff",
        antiquewhite: "faebd7",
        aqua: "0ff",
        aquamarine: "7fffd4",
        azure: "f0ffff",
        beige: "f5f5dc",
        bisque: "ffe4c4",
        black: "000",
        blanchedalmond: "ffebcd",
        blue: "00f",
        blueviolet: "8a2be2",
        brown: "a52a2a",
        burlywood: "deb887",
        burntsienna: "ea7e5d",
        cadetblue: "5f9ea0",
        chartreuse: "7fff00",
        chocolate: "d2691e",
        coral: "ff7f50",
        cornflowerblue: "6495ed",
        cornsilk: "fff8dc",
        crimson: "dc143c",
        cyan: "0ff",
        darkblue: "00008b",
        darkcyan: "008b8b",
        darkgoldenrod: "b8860b",
        darkgray: "a9a9a9",
        darkgreen: "006400",
        darkgrey: "a9a9a9",
        darkkhaki: "bdb76b",
        darkmagenta: "8b008b",
        darkolivegreen: "556b2f",
        darkorange: "ff8c00",
        darkorchid: "9932cc",
        darkred: "8b0000",
        darksalmon: "e9967a",
        darkseagreen: "8fbc8f",
        darkslateblue: "483d8b",
        darkslategray: "2f4f4f",
        darkslategrey: "2f4f4f",
        darkturquoise: "00ced1",
        darkviolet: "9400d3",
        deeppink: "ff1493",
        deepskyblue: "00bfff",
        dimgray: "696969",
        dimgrey: "696969",
        dodgerblue: "1e90ff",
        firebrick: "b22222",
        floralwhite: "fffaf0",
        forestgreen: "228b22",
        fuchsia: "f0f",
        gainsboro: "dcdcdc",
        ghostwhite: "f8f8ff",
        gold: "ffd700",
        goldenrod: "daa520",
        gray: "808080",
        green: "008000",
        greenyellow: "adff2f",
        grey: "808080",
        honeydew: "f0fff0",
        hotpink: "ff69b4",
        indianred: "cd5c5c",
        indigo: "4b0082",
        ivory: "fffff0",
        khaki: "f0e68c",
        lavender: "e6e6fa",
        lavenderblush: "fff0f5",
        lawngreen: "7cfc00",
        lemonchiffon: "fffacd",
        lightblue: "add8e6",
        lightcoral: "f08080",
        lightcyan: "e0ffff",
        lightgoldenrodyellow: "fafad2",
        lightgray: "d3d3d3",
        lightgreen: "90ee90",
        lightgrey: "d3d3d3",
        lightpink: "ffb6c1",
        lightsalmon: "ffa07a",
        lightseagreen: "20b2aa",
        lightskyblue: "87cefa",
        lightslategray: "789",
        lightslategrey: "789",
        lightsteelblue: "b0c4de",
        lightyellow: "ffffe0",
        lime: "0f0",
        limegreen: "32cd32",
        linen: "faf0e6",
        magenta: "f0f",
        maroon: "800000",
        mediumaquamarine: "66cdaa",
        mediumblue: "0000cd",
        mediumorchid: "ba55d3",
        mediumpurple: "9370db",
        mediumseagreen: "3cb371",
        mediumslateblue: "7b68ee",
        mediumspringgreen: "00fa9a",
        mediumturquoise: "48d1cc",
        mediumvioletred: "c71585",
        midnightblue: "191970",
        mintcream: "f5fffa",
        mistyrose: "ffe4e1",
        moccasin: "ffe4b5",
        navajowhite: "ffdead",
        navy: "000080",
        oldlace: "fdf5e6",
        olive: "808000",
        olivedrab: "6b8e23",
        orange: "ffa500",
        orangered: "ff4500",
        orchid: "da70d6",
        palegoldenrod: "eee8aa",
        palegreen: "98fb98",
        paleturquoise: "afeeee",
        palevioletred: "db7093",
        papayawhip: "ffefd5",
        peachpuff: "ffdab9",
        peru: "cd853f",
        pink: "ffc0cb",
        plum: "dda0dd",
        powderblue: "b0e0e6",
        purple: "800080",
        rebeccapurple: "663399",
        red: "f00",
        rosybrown: "bc8f8f",
        royalblue: "4169e1",
        saddlebrown: "8b4513",
        salmon: "fa8072",
        sandybrown: "f4a460",
        seagreen: "2e8b57",
        seashell: "fff5ee",
        sienna: "a0522d",
        silver: "c0c0c0",
        skyblue: "87ceeb",
        slateblue: "6a5acd",
        slategray: "708090",
        slategrey: "708090",
        snow: "fffafa",
        springgreen: "00ff7f",
        steelblue: "4682b4",
        tan: "d2b48c",
        teal: "008080",
        thistle: "d8bfd8",
        tomato: "ff6347",
        turquoise: "40e0d0",
        violet: "ee82ee",
        wheat: "f5deb3",
        white: "fff",
        whitesmoke: "f5f5f5",
        yellow: "ff0",
        yellowgreen: "9acd32"
      }; // Make it easy to access colors via `hexNames[hex]`

      var hexNames = tinycolor.hexNames = flip(names); // Utilities
      // ---------
      // `{ 'name1': 'val1' }` becomes `{ 'val1': 'name1' }`

      function flip(o) {
        var flipped = {};

        for (var i in o) {
          if (o.hasOwnProperty(i)) {
            flipped[o[i]] = i;
          }
        }

        return flipped;
      } // Return a valid alpha value [0,1] with all invalid values being set to 1


      function boundAlpha(a) {
        a = parseFloat(a);

        if (isNaN(a) || a < 0 || a > 1) {
          a = 1;
        }

        return a;
      } // Take input from [0, n] and return it as [0, 1]


      function bound01(n, max) {
        if (isOnePointZero(n)) {
          n = "100%";
        }

        var processPercent = isPercentage(n);
        n = mathMin(max, mathMax(0, parseFloat(n))); // Automatically convert percentage into number

        if (processPercent) {
          n = parseInt(n * max, 10) / 100;
        } // Handle floating point rounding errors


        if (Math.abs(n - max) < 0.000001) {
          return 1;
        } // Convert into [0, 1] range if it isn't already


        return n % max / parseFloat(max);
      } // Force a number between 0 and 1


      function clamp01(val) {
        return mathMin(1, mathMax(0, val));
      } // Parse a base-16 hex value into a base-10 integer


      function parseIntFromHex(val) {
        return parseInt(val, 16);
      } // Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
      // <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>


      function isOnePointZero(n) {
        return typeof n == "string" && n.indexOf('.') != -1 && parseFloat(n) === 1;
      } // Check to see if string passed in is a percentage


      function isPercentage(n) {
        return typeof n === "string" && n.indexOf('%') != -1;
      } // Force a hex value to have 2 characters


      function pad2(c) {
        return c.length == 1 ? '0' + c : '' + c;
      } // Replace a decimal with it's percentage value


      function convertToPercentage(n) {
        if (n <= 1) {
          n = n * 100 + "%";
        }

        return n;
      } // Converts a decimal to a hex value


      function convertDecimalToHex(d) {
        return Math.round(parseFloat(d) * 255).toString(16);
      } // Converts a hex value to a decimal


      function convertHexToDecimal(h) {
        return parseIntFromHex(h) / 255;
      }

      var matchers = function () {
        // <http://www.w3.org/TR/css3-values/#integers>
        var CSS_INTEGER = "[-\\+]?\\d+%?"; // <http://www.w3.org/TR/css3-values/#number-value>

        var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?"; // Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.

        var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")"; // Actual matching.
        // Parentheses and commas are optional, but not required.
        // Whitespace can take the place of commas or opening paren

        var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
        var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
        return {
          CSS_UNIT: new RegExp(CSS_UNIT),
          rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
          rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
          hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
          hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
          hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
          hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
          hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
          hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
          hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
          hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
        };
      }(); // `isValidCSSUnit`
      // Take in a single string / number and check to see if it looks like a CSS unit
      // (see `matchers` above for definition).


      function isValidCSSUnit(color) {
        return !!matchers.CSS_UNIT.exec(color);
      } // `stringInputToObject`
      // Permissive string parsing.  Take in a number of formats, and output an object
      // based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`


      function stringInputToObject(color) {
        color = color.replace(trimLeft, '').replace(trimRight, '').toLowerCase();
        var named = false;

        if (names[color]) {
          color = names[color];
          named = true;
        } else if (color == 'transparent') {
          return {
            r: 0,
            g: 0,
            b: 0,
            a: 0,
            format: "name"
          };
        } // Try to match string input using regular expressions.
        // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
        // Just return an object and let the conversion functions handle that.
        // This way the result will be the same whether the tinycolor is initialized with string or object.


        var match;

        if (match = matchers.rgb.exec(color)) {
          return {
            r: match[1],
            g: match[2],
            b: match[3]
          };
        }

        if (match = matchers.rgba.exec(color)) {
          return {
            r: match[1],
            g: match[2],
            b: match[3],
            a: match[4]
          };
        }

        if (match = matchers.hsl.exec(color)) {
          return {
            h: match[1],
            s: match[2],
            l: match[3]
          };
        }

        if (match = matchers.hsla.exec(color)) {
          return {
            h: match[1],
            s: match[2],
            l: match[3],
            a: match[4]
          };
        }

        if (match = matchers.hsv.exec(color)) {
          return {
            h: match[1],
            s: match[2],
            v: match[3]
          };
        }

        if (match = matchers.hsva.exec(color)) {
          return {
            h: match[1],
            s: match[2],
            v: match[3],
            a: match[4]
          };
        }

        if (match = matchers.hex8.exec(color)) {
          return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            a: convertHexToDecimal(match[4]),
            format: named ? "name" : "hex8"
          };
        }

        if (match = matchers.hex6.exec(color)) {
          return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            format: named ? "name" : "hex"
          };
        }

        if (match = matchers.hex4.exec(color)) {
          return {
            r: parseIntFromHex(match[1] + '' + match[1]),
            g: parseIntFromHex(match[2] + '' + match[2]),
            b: parseIntFromHex(match[3] + '' + match[3]),
            a: convertHexToDecimal(match[4] + '' + match[4]),
            format: named ? "name" : "hex8"
          };
        }

        if (match = matchers.hex3.exec(color)) {
          return {
            r: parseIntFromHex(match[1] + '' + match[1]),
            g: parseIntFromHex(match[2] + '' + match[2]),
            b: parseIntFromHex(match[3] + '' + match[3]),
            format: named ? "name" : "hex"
          };
        }

        return false;
      }

      function validateWCAG2Parms(parms) {
        // return valid WCAG2 parms for isReadable.
        // If input parms are invalid, return {"level":"AA", "size":"small"}
        var level, size;
        parms = parms || {
          "level": "AA",
          "size": "small"
        };
        level = (parms.level || "AA").toUpperCase();
        size = (parms.size || "small").toLowerCase();

        if (level !== "AA" && level !== "AAA") {
          level = "AA";
        }

        if (size !== "small" && size !== "large") {
          size = "small";
        }

        return {
          "level": level,
          "size": size
        };
      } // Node: Export function


      if (module.exports) {
        module.exports = tinycolor;
      } // AMD/requirejs: Define the module
      else {
          window.tinycolor = tinycolor;
        }
    })(Math);
  });
  var generate_1 = createCommonjsModule(function (module, exports) {
    var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || function (mod) {
      return mod && mod.__esModule ? mod : {
        "default": mod
      };
    };

    Object.defineProperty(exports, "__esModule", {
      value: true
    });

    var tinycolor2_1 = __importDefault(tinycolor);

    var hueStep = 2; // 色相阶梯

    var saturationStep = 16; // 饱和度阶梯，浅色部分

    var saturationStep2 = 5; // 饱和度阶梯，深色部分

    var brightnessStep1 = 5; // 亮度阶梯，浅色部分

    var brightnessStep2 = 15; // 亮度阶梯，深色部分

    var lightColorCount = 5; // 浅色数量，主色上

    var darkColorCount = 4; // 深色数量，主色下

    function getHue(hsv, i, light) {
      var hue; // 根据色相不同，色相转向不同

      if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
        hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
      } else {
        hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
      }

      if (hue < 0) {
        hue += 360;
      } else if (hue >= 360) {
        hue -= 360;
      }

      return hue;
    }

    function getSaturation(hsv, i, light) {
      // grey color don't change saturation
      if (hsv.h === 0 && hsv.s === 0) {
        return hsv.s;
      }

      var saturation;

      if (light) {
        saturation = Math.round(hsv.s * 100) - saturationStep * i;
      } else if (i === darkColorCount) {
        saturation = Math.round(hsv.s * 100) + saturationStep;
      } else {
        saturation = Math.round(hsv.s * 100) + saturationStep2 * i;
      } // 边界值修正


      if (saturation > 100) {
        saturation = 100;
      } // 第一格的 s 限制在 6-10 之间


      if (light && i === lightColorCount && saturation > 10) {
        saturation = 10;
      }

      if (saturation < 6) {
        saturation = 6;
      }

      return saturation;
    }

    function getValue(hsv, i, light) {
      if (light) {
        return Math.round(hsv.v * 100) + brightnessStep1 * i;
      }

      return Math.round(hsv.v * 100) - brightnessStep2 * i;
    }

    function generate(color) {
      var patterns = [];
      var pColor = tinycolor2_1.default(color);

      for (var i = lightColorCount; i > 0; i -= 1) {
        var hsv = pColor.toHsv();
        var colorString = tinycolor2_1.default({
          h: getHue(hsv, i, true),
          s: getSaturation(hsv, i, true),
          v: getValue(hsv, i, true)
        }).toHexString();
        patterns.push(colorString);
      }

      patterns.push(pColor.toHexString());

      for (var i = 1; i <= darkColorCount; i += 1) {
        var hsv = pColor.toHsv();
        var colorString = tinycolor2_1.default({
          h: getHue(hsv, i),
          s: getSaturation(hsv, i),
          v: getValue(hsv, i)
        }).toHexString();
        patterns.push(colorString);
      }

      return patterns;
    }

    exports.default = generate;
  });
  unwrapExports(generate_1);
  var lib = createCommonjsModule(function (module, exports) {
    var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || function (mod) {
      return mod && mod.__esModule ? mod : {
        "default": mod
      };
    };

    Object.defineProperty(exports, "__esModule", {
      value: true
    });

    var generate_1$1 = __importDefault(generate_1);

    exports.generate = generate_1$1.default;
    var presetPrimaryColors = {
      red: '#F5222D',
      volcano: '#FA541C',
      orange: '#FA8C16',
      gold: '#FAAD14',
      yellow: '#FADB14',
      lime: '#A0D911',
      green: '#52C41A',
      cyan: '#13C2C2',
      blue: '#1890FF',
      geekblue: '#2F54EB',
      purple: '#722ED1',
      magenta: '#EB2F96',
      grey: '#666666'
    };
    exports.presetPrimaryColors = presetPrimaryColors;
    var presetPalettes = {};
    exports.presetPalettes = presetPalettes;
    Object.keys(presetPrimaryColors).forEach(function (key) {
      presetPalettes[key] = generate_1$1.default(presetPrimaryColors[key]);
      presetPalettes[key].primary = presetPalettes[key][6];
    });
    var red = presetPalettes.red;
    exports.red = red;
    var volcano = presetPalettes.volcano;
    exports.volcano = volcano;
    var gold = presetPalettes.gold;
    exports.gold = gold;
    var yellow = presetPalettes.yellow;
    exports.yellow = yellow;
    var lime = presetPalettes.lime;
    exports.lime = lime;
    var green = presetPalettes.green;
    exports.green = green;
    var cyan = presetPalettes.cyan;
    exports.cyan = cyan;
    var blue = presetPalettes.blue;
    exports.blue = blue;
    var geekblue = presetPalettes.geekblue;
    exports.geekblue = geekblue;
    var purple = presetPalettes.purple;
    exports.purple = purple;
    var magenta = presetPalettes.magenta;
    exports.magenta = magenta;
    var grey = presetPalettes.grey;
    exports.grey = grey;
  });
  unwrapExports(lib);
  var lib_1 = lib.generate;
  var lib_2 = lib.presetPrimaryColors;
  var lib_3 = lib.presetPalettes;
  var lib_4 = lib.red;
  var lib_5 = lib.volcano;
  var lib_6 = lib.gold;
  var lib_7 = lib.yellow;
  var lib_8 = lib.lime;
  var lib_9 = lib.green;
  var lib_10 = lib.cyan;
  var lib_11 = lib.blue;
  var lib_12 = lib.geekblue;
  var lib_13 = lib.purple;
  var lib_14 = lib.magenta;
  var lib_15 = lib.grey;
  /* eslint-disable no-console */

  var warned = {};

  function warning(valid, message) {
    // Support uglify
    if (!valid && console !== undefined) {
      console.error("Warning: ".concat(message));
    }
  }

  function call(method, valid, message) {
    if (!valid && !warned[message]) {
      method(false, message);
      warned[message] = true;
    }
  }

  function warningOnce(valid, message) {
    call(warning, valid, message);
  }
  /* eslint-enable */


  var containers = []; // will store container HTMLElement references

  var styleElements = []; // will store {prepend: HTMLElement, append: HTMLElement}

  var usage = 'insert-css: You need to provide a CSS string. Usage: insertCss(cssString[, options]).';

  function insertCss(css, options) {
    options = options || {};

    if (css === undefined) {
      throw new Error(usage);
    }

    var position = options.prepend === true ? 'prepend' : 'append';
    var container = options.container !== undefined ? options.container : document.querySelector('head');
    var containerId = containers.indexOf(container); // first time we see this container, create the necessary entries

    if (containerId === -1) {
      containerId = containers.push(container) - 1;
      styleElements[containerId] = {};
    } // try to get the correponding container + position styleElement, create it otherwise


    var styleElement;

    if (styleElements[containerId] !== undefined && styleElements[containerId][position] !== undefined) {
      styleElement = styleElements[containerId][position];
    } else {
      styleElement = styleElements[containerId][position] = createStyleElement();

      if (position === 'prepend') {
        container.insertBefore(styleElement, container.childNodes[0]);
      } else {
        container.appendChild(styleElement);
      }
    } // strip potential UTF-8 BOM if css was read from a file


    if (css.charCodeAt(0) === 0xFEFF) {
      css = css.substr(1, css.length);
    } // actually add the stylesheet


    if (styleElement.styleSheet) {
      styleElement.styleSheet.cssText += css;
    } else {
      styleElement.textContent += css;
    }

    return styleElement;
  }

  function createStyleElement() {
    var styleElement = document.createElement('style');
    styleElement.setAttribute('type', 'text/css');
    return styleElement;
  }

  var insertCss_1 = insertCss;
  var insertCss_2 = insertCss;
  insertCss_1.insertCss = insertCss_2;

  function ownKeys$1(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys$1(source, true).forEach(function (key) {
          _defineProperty$1(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys$1(source).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _defineProperty$1(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function warning$1(valid, message) {
    warningOnce(valid, "[@ant-design/icons] ".concat(message));
  }

  function isIconDefinition(target) {
    return _typeof(target) === 'object' && typeof target.name === 'string' && typeof target.theme === 'string' && (_typeof(target.icon) === 'object' || typeof target.icon === 'function');
  }

  function normalizeAttrs() {
    var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return Object.keys(attrs).reduce(function (acc, key) {
      var val = attrs[key];

      switch (key) {
        case 'class':
          acc.className = val;
          delete acc.class;
          break;

        default:
          acc[key] = val;
      }

      return acc;
    }, {});
  }

  function generate(node, key, rootProps) {
    if (!rootProps) {
      return React__default.createElement(node.tag, _objectSpread({
        key: key
      }, normalizeAttrs(node.attrs)), (node.children || []).map(function (child, index) {
        return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
      }));
    }

    return React__default.createElement(node.tag, _objectSpread({
      key: key
    }, normalizeAttrs(node.attrs), {}, rootProps), (node.children || []).map(function (child, index) {
      return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
    }));
  }

  function getSecondaryColor(primaryColor) {
    // choose the second color
    return lib_1(primaryColor)[0];
  } // These props make sure that the SVG behaviours like general text.


  var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
  var cssInjectedFlag = false;

  var useInsertStyles = function useInsertStyles() {
    var styleStr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : iconStyles;
    React.useEffect(function () {
      if (!cssInjectedFlag) {
        insertCss_2(styleStr);
        cssInjectedFlag = true;
      }
    }, []);
  };

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function ownKeys$2(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread$1(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys$2(source, true).forEach(function (key) {
          _defineProperty$2(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys$2(source).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _defineProperty$2(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  var twoToneColorPalette = {
    primaryColor: '#333',
    secondaryColor: '#E6E6E6'
  };

  function setTwoToneColors(_ref) {
    var primaryColor = _ref.primaryColor,
        secondaryColor = _ref.secondaryColor;
    twoToneColorPalette.primaryColor = primaryColor;
    twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  }

  function getTwoToneColors() {
    return _objectSpread$1({}, twoToneColorPalette);
  }

  var IconBase = function IconBase(props) {
    var icon = props.icon,
        className = props.className,
        onClick = props.onClick,
        style = props.style,
        primaryColor = props.primaryColor,
        secondaryColor = props.secondaryColor,
        restProps = _objectWithoutProperties(props, ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"]);

    var colors = twoToneColorPalette;

    if (primaryColor) {
      colors = {
        primaryColor: primaryColor,
        secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
      };
    }

    useInsertStyles();
    warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));

    if (!isIconDefinition(icon)) {
      return null;
    }

    var target = icon;

    if (target && typeof target.icon === 'function') {
      target = _objectSpread$1({}, target, {
        icon: target.icon(colors.primaryColor, colors.secondaryColor)
      });
    }

    return generate(target.icon, "svg-".concat(target.name), _objectSpread$1({
      className: className,
      onClick: onClick,
      style: style,
      'data-icon': target.name,
      width: '1em',
      height: '1em',
      fill: 'currentColor',
      'aria-hidden': 'true'
    }, restProps));
  };

  IconBase.displayName = 'IconReact';
  IconBase.getTwoToneColors = getTwoToneColors;
  IconBase.setTwoToneColors = setTwoToneColors;

  function setTwoToneColor(primaryColor) {
    return IconBase.setTwoToneColors({
      primaryColor: primaryColor
    });
  }

  function getTwoToneColor() {
    var colors = IconBase.getTwoToneColors();
    return colors.primaryColor;
  }

  function _extends$1() {
    _extends$1 = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends$1.apply(this, arguments);
  }

  function _defineProperty$3(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectWithoutProperties$1(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose$1(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _objectWithoutPropertiesLoose$1(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  setTwoToneColor('#1890ff');

  var Icon = function Icon(props) {
    var className = props.className,
        icon = props.icon,
        spin = props.spin,
        rotate = props.rotate,
        tabIndex = props.tabIndex,
        onClick = props.onClick,
        twoToneColor = props.twoToneColor,
        restProps = _objectWithoutProperties$1(props, ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"]);

    var classString = classnames('anticon', _defineProperty$3({}, "anticon-".concat(icon.name), Boolean(icon.name)), className);
    var svgClassString = classnames({
      'anticon-spin': !!spin || icon.name === 'loading'
    });
    var iconTabIndex = tabIndex;

    if (iconTabIndex === undefined && onClick) {
      iconTabIndex = -1;
    }

    var svgStyle = rotate ? {
      msTransform: "rotate(".concat(rotate, "deg)"),
      transform: "rotate(".concat(rotate, "deg)")
    } : undefined;
    return React__default.createElement("span", _extends$1({
      role: "img",
      "aria-label": icon.name
    }, restProps, {
      tabIndex: iconTabIndex,
      onClick: onClick,
      className: classString
    }), React__default.createElement(IconBase, {
      className: svgClassString,
      icon: icon,
      primaryColor: twoToneColor,
      style: svgStyle
    }));
  };

  Icon.displayName = 'AntdIcon';
  Icon.getTwoToneColor = getTwoToneColor;
  Icon.setTwoToneColor = setTwoToneColor;
  var DeleteOutline_1 = createCommonjsModule(function (module, exports) {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    var DeleteOutline = {
      name: 'delete',
      theme: 'outline',
      icon: {
        tag: 'svg',
        attrs: {
          viewBox: '64 64 896 896',
          focusable: 'false'
        },
        children: [{
          tag: 'path',
          attrs: {
            d: 'M360 184h-8c4.4 0 8-3.6 8-8v8h304v-8c0 4.4 3.6 8 8 8h-8v72h72v-80c0-35.3-28.7-64-64-64H352c-35.3 0-64 28.7-64 64v80h72v-72zm504 72H160c-17.7 0-32 14.3-32 32v32c0 4.4 3.6 8 8 8h60.4l24.7 523c1.6 34.1 29.8 61 63.9 61h454c34.2 0 62.3-26.8 63.9-61l24.7-523H888c4.4 0 8-3.6 8-8v-32c0-17.7-14.3-32-32-32zM731.3 840H292.7l-24.2-512h487l-24.2 512z'
          }
        }]
      }
    };
    exports.default = DeleteOutline;
  });
  var DeleteOutlineSvg = unwrapExports(DeleteOutline_1);

  function _extends$2() {
    _extends$2 = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends$2.apply(this, arguments);
  }

  var Delete = function Delete(props) {
    return React__default.createElement(Icon, _extends$2({}, props, {
      icon: DeleteOutlineSvg
    }));
  };

  var EnterOutline_1 = createCommonjsModule(function (module, exports) {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    var EnterOutline = {
      name: 'enter',
      theme: 'outline',
      icon: {
        tag: 'svg',
        attrs: {
          viewBox: '64 64 896 896',
          focusable: 'false'
        },
        children: [{
          tag: 'path',
          attrs: {
            d: 'M864 170h-60c-4.4 0-8 3.6-8 8v518H310v-73c0-6.7-7.8-10.5-13-6.3l-141.9 112a8 8 0 000 12.6l141.9 112c5.3 4.2 13 .4 13-6.3v-75h498c35.3 0 64-28.7 64-64V178c0-4.4-3.6-8-8-8z'
          }
        }]
      }
    };
    exports.default = EnterOutline;
  });
  var EnterOutlineSvg = unwrapExports(EnterOutline_1);

  function _extends$3() {
    _extends$3 = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends$3.apply(this, arguments);
  }

  var Enter = function Enter(props) {
    return React__default.createElement(Icon, _extends$3({}, props, {
      icon: EnterOutlineSvg
    }));
  };

  var css$1 = ".index-module_wrapper__3T5Iw {\n  background-color: #15171c;\n  border-radius: 2px;\n  padding: 12px 16px;\n  font-size: 14px;\n  color: rgba(255, 255, 255, 0.65);\n  line-height: 22px;\n  height: 100%;\n}\n.index-module_titleWrapper__3VnWc {\n  margin-bottom: 8px;\n}\n.index-module_actionGroup__1OHJE {\n  text-align: right;\n}\n.index-module_actionGroup__1OHJE > i {\n  margin-left: 16px;\n}\n.index-module_logContainer__3TKyW {\n  padding: 0;\n  height: 100%;\n  min-width: 600px;\n}\n.index-module_icon__FNyoQ {\n  margin-left: 16px;\n}\n";
  var styles$1 = {
    "wrapper": "index-module_wrapper__3T5Iw",
    "titleWrapper": "index-module_titleWrapper__3VnWc",
    "actionGroup": "index-module_actionGroup__1OHJE",
    "logContainer": "index-module_logContainer__3TKyW",
    "icon": "index-module_icon__FNyoQ"
  };
  styleInject(css$1);

  var TerminalComponent = function TerminalComponent(_ref) {
    var terminal = _ref.terminal,
        log = _ref.log,
        onClear = _ref.onClear,
        _ref$size = _ref.size,
        size = _ref$size === void 0 ? {} : _ref$size,
        api = _ref.api;
    var intl = api.intl;
    var domContainer = React.useRef();

    var _useState = React.useState(false),
        _useState2 = _slicedToArray(_useState, 2),
        setInit = _useState2[1];

    React.useEffect(function () {
      setInit(true);
    }, []);
    useTerminal({
      terminal: terminal,
      ref: domContainer.current
    });
    React.useEffect(function () {
      if (log) {
        terminal.write(log.replace(/\n/g, '\r\n'));
      }
    }, [log]); // mount or updated

    var prevSize = usePrevious(size);
    React.useEffect(function () {
      if (prevSize) {
        if (prevSize.width !== size.width || prevSize.height !== size.height) {
          terminal.fit();
        }
      }
    }, [size.width, size.height]);

    var clear = function clear() {
      terminal.clear();
      onClear && onClear();
    };

    var toBottom = function toBottom() {
      terminal.scrollToBottom();
    };

    return React__default.createElement("div", {
      className: styles$1.wrapper
    }, React__default.createElement(antd.Row, {
      className: styles$1.titleWrapper
    }, React__default.createElement(antd.Col, {
      span: 8,
      className: styles$1.formmatGroup
    }, intl('org.umi.ui.tasks.log.title')), React__default.createElement(antd.Col, {
      span: 4,
      offset: 12,
      className: styles$1.actionGroup
    }, React__default.createElement("span", {
      className: styles$1.icon
    }, React__default.createElement(Delete, {
      onClick: clear
    })), React__default.createElement("span", {
      className: styles$1.icon
    }, React__default.createElement(Enter, {
      onClick: toBottom
    })))), React__default.createElement("div", {
      ref: domContainer,
      className: styles$1.logContainer
    }));
  };

  var SizeMe$1 = reactSizeme.SizeMe;
  var taskType = TaskType.DEV;

  var DevComponent = function DevComponent(_ref) {
    var api = _ref.api;
    var intl = api.intl;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1];

    var _Form$useForm = antd.Form.useForm(),
        _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
        form = _Form$useForm2[0];

    var _useState5 = React.useState(false),
        _useState6 = _slicedToArray(_useState5, 2),
        modalVisible = _useState6[0],
        setModalVisible = _useState6[1];

    var _useState7 = React.useState({
      BABEL_POLYFILL: true,
      HMR: true,
      BABEL_CACHE: true,
      MOCK: true,
      BROWSER: true,
      CLEAR_CONSOLE: true,
      PORT: null,
      FORK_TS_CHECKER: false
    }),
        _useState8 = _slicedToArray(_useState7, 2),
        env = _useState8[0],
        setEnv = _useState8[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail;

    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
    }, [detail]); // Mount: 监听 task state 改变

    React.useEffect(function () {
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]); // UnMount: reset form

    React.useEffect(function () {
      return function () {
        form.resetFields();
        var terminal = getTerminalIns(taskType);
        terminal && terminal.clear();
      };
    }, []);

    function dev() {
      return _dev.apply(this, arguments);
    }

    function _dev() {
      _dev = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType, env);

              case 2:
                _ref4 = _context.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: intl('org.umi.ui.tasks.dev.startError'),
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _dev.apply(this, arguments);
    }

    function cancelDev() {
      return _cancelDev.apply(this, arguments);
    }

    function _cancelDev() {
      _cancelDev = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref5, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType);

              case 2:
                _ref5 = _context2.sent;
                triggerState = _ref5.triggerState;
                errMsg = _ref5.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    title: intl('org.umi.ui.tasks.dev.cancelError'),
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelDev.apply(this, arguments);
    }

    var openModal = function openModal() {
      setModalVisible(true);
    };

    var handleOk = function handleOk() {
      form.validateFields().then(function (values) {
        setEnv(values);
        setModalVisible(false);
      }).catch(function (_) {});
    };

    var handleCancel = function handleCancel() {
      setModalVisible(false);
    };

    var EnvLabel = function EnvLabel(props) {
      return React__default.createElement("div", null, React__default.createElement("div", {
        className: styles.modleLableTitle
      }, intl(props.title)), React__default.createElement("div", {
        className: styles.modleLableDesc
      }, intl(props.desc)));
    };

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, intl('org.umi.ui.tasks.dev')), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelDev : dev,
      loading: loading
    }, isTaskRunning ? intl('org.umi.ui.tasks.dev.cancel') : intl('org.umi.ui.tasks.dev.start')), React__default.createElement(antd.Button, {
      onClick: openModal
    }, intl('org.umi.ui.tasks.envs')), React__default.createElement(antd.Modal, {
      visible: modalVisible,
      title: intl('org.umi.ui.tasks.envs'),
      onOk: handleOk,
      onCancel: handleCancel
    }, React__default.createElement("div", {
      className: styles.modalContainer
    }, React__default.createElement(antd.Form, {
      name: "devEnv",
      form: form,
      initialValues: env,
      layout: "vertical"
    }, React__default.createElement(antd.Form.Item, {
      label: intl('org.umi.ui.tasks.envs.port'),
      name: "PORT"
    }, React__default.createElement(antd.Input, null)), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.babelPolyfill",
        desc: "org.umi.ui.tasks.envs.babelPolyfill.desc"
      }),
      name: "BABEL_POLYFILL",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.hmr",
        desc: "org.umi.ui.tasks.envs.hmr.desc"
      }),
      name: "HMR",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.babelCache",
        desc: "org.umi.ui.tasks.envs.babelCache.desc"
      }),
      name: "BABEL_CACHE",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.mock",
        desc: "org.umi.ui.tasks.envs.mock.desc"
      }),
      name: "MOCK",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.BROWSER",
        desc: "org.umi.ui.tasks.envs.BROWSER.desc"
      }),
      name: "BROWSER",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, null)), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.clear",
        desc: "org.umi.ui.tasks.envs.clear.desc"
      }),
      name: "CLEAR_CONSOLE",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.tsCheck",
        desc: "org.umi.ui.tasks.envs.tsCheck.desc"
      }),
      name: "FORK_TS_CHECKER",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    }))))))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(SizeMe$1, {
      monitorWidth: true,
      monitorHeight: true
    }, function (_ref3) {
      var size = _ref3.size;
      return React__default.createElement(TerminalComponent, {
        api: api,
        size: size,
        terminal: getTerminalIns(taskType),
        log: taskDetail.log,
        onClear: function onClear() {
          clearLog(taskType);
        }
      });
    }))));
  };

  var SizeMe$2 = reactSizeme.SizeMe;
  var taskType$1 = TaskType.BUILD;

  var BuildComponent = function BuildComponent(_ref) {
    var api = _ref.api;
    var intl = api.intl;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType$1,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1];

    var _Form$useForm = antd.Form.useForm(),
        _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
        form = _Form$useForm2[0];

    var _useState5 = React.useState(false),
        _useState6 = _slicedToArray(_useState5, 2),
        modalVisible = _useState6[0],
        setModalVisible = _useState6[1];

    var _useState7 = React.useState({
      BABEL_CACHE: true,
      BABEL_POLYFILL: true,
      COMPRESS: true,
      CSS_COMPRESS: true,
      HTML: true,
      FORK_TS_CHECKER: false
    }),
        _useState8 = _slicedToArray(_useState7, 2),
        env = _useState8[0],
        setEnv = _useState8[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType$1),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail; // Mount: 监听 task state 改变


    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType$1)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]); // UnMount: reset form

    React.useEffect(function () {
      return function () {
        form.resetFields();
        var terminal = getTerminalIns(taskType$1);
        terminal && terminal.clear();
      };
    }, []);

    function build() {
      return _build.apply(this, arguments);
    }

    function _build() {
      _build = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType$1, env);

              case 2:
                _ref4 = _context.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: intl('org.umi.ui.tasks.build.buildError'),
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _build.apply(this, arguments);
    }

    function cancelBuild() {
      return _cancelBuild.apply(this, arguments);
    }

    function _cancelBuild() {
      _cancelBuild = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref5, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType$1);

              case 2:
                _ref5 = _context2.sent;
                triggerState = _ref5.triggerState;
                errMsg = _ref5.errMsg;

                if (!(triggerState === TriggerState.FAIL)) {
                  _context2.next = 8;
                  break;
                }

                api.notify({
                  title: intl('org.umi.ui.tasks.build.cancelError'),
                  message: errMsg
                });
                return _context2.abrupt("return");

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelBuild.apply(this, arguments);
    }

    var openModal = function openModal() {
      setModalVisible(true);
    };

    var handleOk = function handleOk() {
      form.validateFields().then(function (values) {
        setEnv(values);
        setModalVisible(false);
      }).catch(function (info) {
        setModalVisible(false);
      });
    };

    var handleCancel = function handleCancel() {
      setModalVisible(false);
    };

    var EnvLabel = function EnvLabel(props) {
      return React__default.createElement("div", null, React__default.createElement("div", {
        className: styles.modleLableTitle
      }, intl(props.title)), React__default.createElement("div", {
        className: styles.modleLableDesc
      }, intl(props.desc)));
    };

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, intl('org.umi.ui.tasks.build')), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelBuild : build,
      loading: loading
    }, isTaskRunning ? intl('org.umi.ui.tasks.build.cancel') : intl('org.umi.ui.tasks.build.start')), React__default.createElement(antd.Button, {
      onClick: openModal
    }, intl('org.umi.ui.tasks.envs')), React__default.createElement(antd.Modal, {
      visible: modalVisible,
      title: intl('org.umi.ui.tasks.envs'),
      onOk: handleOk,
      onCancel: handleCancel
    }, React__default.createElement("div", {
      className: styles.modalContainer
    }, React__default.createElement(antd.Form, {
      name: "buildEnv",
      form: form,
      initialValues: env,
      layout: "vertical"
    }, React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.compress",
        desc: "org.umi.ui.tasks.envs.compress.desc"
      }),
      name: "COMPRESS",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.cssCompress",
        desc: "org.umi.ui.tasks.envs.cssCompress.desc"
      }),
      name: "CSS_COMPRESS",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.babelPolyfill",
        desc: "org.umi.ui.tasks.envs.babelPolyfill.desc"
      }),
      name: "BABEL_POLYFILL",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.babelCache",
        desc: "org.umi.ui.tasks.envs.babelCache.desc"
      }),
      name: "BABEL_CACHE",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.html",
        desc: "org.umi.ui.tasks.envs.html.desc"
      }),
      name: "HTML",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    })), React__default.createElement(antd.Form.Item, {
      label: React__default.createElement(EnvLabel, {
        title: "org.umi.ui.tasks.envs.tsCheck",
        desc: "org.umi.ui.tasks.envs.tsCheck.desc"
      }),
      name: "FORK_TS_CHECKER",
      valuePropName: "checked"
    }, React__default.createElement(antd.Switch, {
      size: "small"
    }))))))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(SizeMe$2, {
      monitorWidth: true,
      monitorHeight: true
    }, function (_ref3) {
      var size = _ref3.size;
      return React__default.createElement(TerminalComponent, {
        api: api,
        size: size,
        terminal: getTerminalIns(taskType$1),
        log: taskDetail.log,
        onClear: function onClear() {
          clearLog(taskType$1);
        }
      });
    }))));
  };

  var SizeMe$3 = reactSizeme.SizeMe;
  var taskType$2 = TaskType.LINT;

  var LintComponent = function LintComponent(_ref) {
    var api = _ref.api;
    var intl = api.intl;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType$2,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType$2),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail; // Mount: 监听 task state 改变


    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType$2)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]); // UnMount: reset form

    React.useEffect(function () {
      return function () {
        var terminal = getTerminalIns(taskType$2);
        terminal && terminal.clear();
      };
    }, []);

    function lint() {
      return _lint.apply(this, arguments);
    }

    function _lint() {
      _lint = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType$2);

              case 2:
                _ref4 = _context.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: intl('org.umi.ui.tasks.lint.execError'),
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _lint.apply(this, arguments);
    }

    function cancelLint() {
      return _cancelLint.apply(this, arguments);
    }

    function _cancelLint() {
      _cancelLint = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref5, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType$2);

              case 2:
                _ref5 = _context2.sent;
                triggerState = _ref5.triggerState;
                errMsg = _ref5.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    title: intl('org.umi.ui.tasks.lint.cancelError'),
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelLint.apply(this, arguments);
    }

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, intl('org.umi.ui.tasks.lint')), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelLint : lint,
      loading: loading
    }, isTaskRunning ? intl('org.umi.ui.tasks.lint.cancel') : intl('org.umi.ui.tasks.lint.start')))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(SizeMe$3, {
      monitorWidth: true,
      monitorHeight: true
    }, function (_ref3) {
      var size = _ref3.size;
      return React__default.createElement(TerminalComponent, {
        api: api,
        size: size,
        terminal: getTerminalIns(taskType$2),
        log: taskDetail.log,
        onClear: function onClear() {
          clearLog(taskType$2);
        }
      });
    }))));
  };

  var SizeMe$4 = reactSizeme.SizeMe;
  var taskType$3 = TaskType.TEST;

  var TestComponent = function TestComponent(_ref) {
    var api = _ref.api;
    var intl = api.intl;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType$3,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType$3),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail; // Mount: 监听 task state 改变


    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType$3)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]); // UnMount: reset form

    React.useEffect(function () {
      return function () {
        var terminal = getTerminalIns(taskType$3);
        terminal && terminal.clear();
      };
    }, []);

    function test() {
      return _test.apply(this, arguments);
    }

    function _test() {
      _test = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref4, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return exec(taskType$3);

              case 2:
                _ref4 = _context.sent;
                triggerState = _ref4.triggerState;
                errMsg = _ref4.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: intl('org.umi.ui.tasks.test.testError'),
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _test.apply(this, arguments);
    }

    function cancelTest() {
      return _cancelTest.apply(this, arguments);
    }

    function _cancelTest() {
      _cancelTest = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _ref5, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return cancel(taskType$3);

              case 2:
                _ref5 = _context2.sent;
                triggerState = _ref5.triggerState;
                errMsg = _ref5.errMsg;

                if (!(triggerState === TriggerState.FAIL)) {
                  _context2.next = 8;
                  break;
                }

                api.notify({
                  title: intl('org.umi.ui.tasks.test.cancelError'),
                  message: errMsg
                });
                return _context2.abrupt("return");

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _cancelTest.apply(this, arguments);
    }

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, intl('org.umi.ui.tasks.test')), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelTest : test,
      loading: loading
    }, isTaskRunning ? intl('org.umi.ui.tasks.test.cancel') : intl('org.umi.ui.tasks.test.start')))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(SizeMe$4, {
      monitorWidth: true,
      monitorHeight: true
    }, function (_ref3) {
      var size = _ref3.size;
      return React__default.createElement(TerminalComponent, {
        api: api,
        size: size,
        terminal: getTerminalIns(taskType$3),
        log: taskDetail.log,
        onClear: function onClear() {
          clearLog(taskType$3);
        }
      });
    }))));
  };

  var SizeMe$5 = reactSizeme.SizeMe;
  var taskType$4 = TaskType.INSTALL;
  var Option = antd.Select.Option;

  var InstallComponent = function InstallComponent(_ref) {
    var api = _ref.api;
    var intl = api.intl;

    var _useState = React.useState({
      state: TaskState.INIT,
      type: taskType$4,
      log: ''
    }),
        _useState2 = _slicedToArray(_useState, 2),
        taskDetail = _useState2[0],
        setTaskDetail = _useState2[1];

    var _useState3 = React.useState(true),
        _useState4 = _slicedToArray(_useState3, 2),
        loading = _useState4[0],
        setLoading = _useState4[1];

    var _useState5 = React.useState([]),
        _useState6 = _slicedToArray(_useState5, 2),
        npmClients = _useState6[0],
        setNpmClients = _useState6[1];

    var _useState7 = React.useState(false),
        _useState8 = _slicedToArray(_useState7, 2),
        modalVisible = _useState8[0],
        setModalVisible = _useState8[1];

    var _Form$useForm = antd.Form.useForm(),
        _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
        form = _Form$useForm2[0]; // Mount: 获取 task detail


    var _useTaskDetail = useTaskDetail(taskType$4),
        detailLoading = _useTaskDetail.loading,
        detail = _useTaskDetail.detail; // Mount: 监听 task state 改变


    React.useEffect(function () {
      setLoading(detailLoading);
      setTaskDetail(detail);
      var unsubscribe = api.listenRemote({
        type: 'org.umi.task.state',
        onMessage: function onMessage(_ref2) {
          var result = _ref2.detail,
              type = _ref2.taskType;

          if (!isCaredEvent(type, taskType$4)) {
            return null;
          }

          if (result) {
            setTaskDetail(result);
          }
        }
      });
      return function () {
        unsubscribe && unsubscribe();
      };
    }, [detail]);
    React.useEffect(function () {
      _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var _ref4, data;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return api.callRemote({
                  type: '@@project/getNpmClients'
                });

              case 2:
                _ref4 = _context.sent;
                data = _ref4.data;
                setNpmClients(data);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }, []); // UnMount: reset form

    React.useEffect(function () {
      return function () {
        form.resetFields();
        var terminal = getTerminalIns(taskType$4);
        terminal && terminal.clear();
      };
    }, []);

    function install(_x) {
      return _install.apply(this, arguments);
    }

    function _install() {
      _install = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(npmClient) {
        var _ref6, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return exec(taskType$4, {
                  NPM_CLIENT: npmClient
                });

              case 2:
                _ref6 = _context2.sent;
                triggerState = _ref6.triggerState;
                errMsg = _ref6.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    type: 'error',
                    title: intl('org.umi.ui.tasks.install.execError'),
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _install.apply(this, arguments);
    }

    function cancelInstall() {
      return _cancelInstall.apply(this, arguments);
    }

    function _cancelInstall() {
      _cancelInstall = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3() {
        var _ref7, triggerState, errMsg;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return cancel(taskType$4);

              case 2:
                _ref7 = _context3.sent;
                triggerState = _ref7.triggerState;
                errMsg = _ref7.errMsg;

                if (triggerState === TriggerState.FAIL) {
                  api.notify({
                    title: intl('org.umi.ui.tasks.install.cancelError'),
                    message: errMsg
                  });
                }

              case 6:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));
      return _cancelInstall.apply(this, arguments);
    }

    var openModal = function openModal() {
      setModalVisible(true);
    };

    var handleOk = function handleOk() {
      form.validateFields().then(function (values) {
        install(values.npmClient);
        setModalVisible(false);
      }).catch(function (_) {});
    };

    var handleCancel = function handleCancel() {
      setModalVisible(false);
    };

    var isTaskRunning = taskDetail && taskDetail.state === TaskState.ING;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("h1", {
      className: styles.title
    }, intl('org.umi.ui.tasks.install')), loading ? React__default.createElement(antd.Spin, null) : React__default.createElement(React__default.Fragment, null, React__default.createElement(antd.Row, null, React__default.createElement(antd.Col, {
      span: 8,
      className: styles.buttonGroup
    }, React__default.createElement(antd.Button, {
      type: "primary",
      onClick: isTaskRunning ? cancelInstall : openModal,
      loading: loading
    }, isTaskRunning ? intl('org.umi.ui.tasks.install.cancel') : intl('org.umi.ui.tasks.install.start')), React__default.createElement(antd.Modal, {
      visible: modalVisible,
      title: intl('org.umi.ui.tasks.install'),
      okText: intl('org.umi.ui.tasks.install.okText'),
      cancelText: intl('org.umi.ui.tasks.install.cancelText'),
      onOk: handleOk,
      onCancel: handleCancel
    }, React__default.createElement("div", {
      className: styles.modalContainer
    }, React__default.createElement("div", {
      className: styles.confirmMessage
    }, intl('org.umi.ui.tasks.install.tip')), React__default.createElement(antd.Form, {
      name: "intasllEnv",
      form: form,
      layout: "vertical"
    }, React__default.createElement(antd.Form.Item, {
      label: intl('org.umi.ui.tasks.install.npmClient'),
      name: "npmClient"
    }, React__default.createElement(antd.Select, {
      defaultValue: npmClients[0],
      style: {
        width: 120
      }
    }, npmClients.map(function (key) {
      return React__default.createElement(Option, {
        key: key,
        value: key
      }, key);
    })))))))), React__default.createElement("div", {
      className: styles.logContainer
    }, React__default.createElement(SizeMe$5, {
      monitorWidth: true,
      monitorHeight: true
    }, function (_ref5) {
      var size = _ref5.size;
      return React__default.createElement(TerminalComponent, {
        api: api,
        size: size,
        terminal: getTerminalIns(taskType$4),
        log: taskDetail.log,
        onClear: function onClear() {
          clearLog(taskType$4);
        }
      });
    }))));
  };

  var _orgUmiUiTasksTit;

  var enUS = (_orgUmiUiTasksTit = {
    'org.umi.ui.tasks.title': 'Task Manager',
    'org.umi.ui.tasks.dev': 'DEV',
    'org.umi.ui.tasks.build': 'BUILD',
    'org.umi.ui.tasks.test': 'TEST',
    'org.umi.ui.tasks.lint': 'LINT',
    'org.umi.ui.tasks.install': 'INSTALL',
    'org.umi.ui.tasks.dev.desc': 'Start local project',
    'org.umi.ui.tasks.build.desc': 'Build local project',
    'org.umi.ui.tasks.test.desc': 'Test local project',
    'org.umi.ui.tasks.lint.desc': 'Lint local project',
    'org.umi.ui.tasks.install.desc': 'Install local project',
    // dev
    'org.umi.ui.tasks.dev.startError': 'Start project error',
    'org.umi.ui.tasks.dev.cancelError': 'Cancel start error',
    'org.umi.ui.tasks.dev.start': 'START',
    'org.umi.ui.tasks.dev.cancel': 'STOP',
    'org.umi.ui.tasks.envs': 'ENVS',
    'org.umi.ui.tasks.envs.port': 'PORT',
    'org.umi.ui.tasks.envs.babelPolyfill': '@babel/polyfill',
    'org.umi.ui.tasks.envs.babelPolyfill.desc': 'Babel polyfill',
    'org.umi.ui.tasks.envs.hmr': 'HMR',
    'org.umi.ui.tasks.envs.hmr.desc': 'Webpack hot module replacement',
    'org.umi.ui.tasks.envs.babelCache': 'BABEL_CACHE',
    'org.umi.ui.tasks.envs.babelCache.desc': 'BABEL CACHE',
    'org.umi.ui.tasks.envs.mock': 'MOCK',
    'org.umi.ui.tasks.envs.mock.desc': 'Mock',
    'org.umi.ui.tasks.envs.BROWSER': 'Browser',
    'org.umi.ui.tasks.envs.BROWSER.desc': 'Open browser when start up',
    'org.umi.ui.tasks.envs.clear': 'CLEAR CONSOLE',
    'org.umi.ui.tasks.envs.clear.desc': 'Clear terminal log',
    'org.umi.ui.tasks.envs.tsCheck': 'TS Check',
    'org.umi.ui.tasks.envs.tsCheck.desc': 'Type Script definition check',
    // build
    'org.umi.ui.tasks.build.buildError': 'Build project error',
    'org.umi.ui.tasks.build.cancelError': 'Cancel build error',
    'org.umi.ui.tasks.build.start': 'BUILD',
    'org.umi.ui.tasks.build.cancel': 'STOP'
  }, _defineProperty(_orgUmiUiTasksTit, "org.umi.ui.tasks.envs", 'ENVS'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.envs.compress', 'COMPRESS'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.envs.compress.desc', 'Compress js file'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.envs.cssCompress', 'CSS COMPRESS'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.envs.cssCompress.desc', 'Compress css file'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.envs.html', 'HTML'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.envs.html.desc', 'Generate html'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.test.testError', 'Test project error'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.test.cancelError', 'Cancel test error'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.test.start', 'RUN'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.test.cancel', 'STOP'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.lint.execError', 'Lint project error'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.lint.cancelError', 'Cancel lint error'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.lint.start', 'RUN'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.lint.cancel', 'STOP'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.install.execError', 'Install dependences error'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.install.cancelError', 'Cancel install error'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.install.start', 'INSTALL'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.install.cancel', 'STOP'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.install.tip', 'Reinstall dependences?'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.install.npmClient', 'Npm Client'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.install.okText', 'OK'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.install.cancelText', 'Cancel'), _defineProperty(_orgUmiUiTasksTit, 'org.umi.ui.tasks.log.title', 'LOG'), _orgUmiUiTasksTit);

  var _orgUmiUiTasksTit$1;

  var zhCN = (_orgUmiUiTasksTit$1 = {
    'org.umi.ui.tasks.title': '任务管理',
    'org.umi.ui.tasks.dev': '本地开发',
    'org.umi.ui.tasks.build': '构建',
    'org.umi.ui.tasks.test': '测试',
    'org.umi.ui.tasks.lint': '代码风格检查',
    'org.umi.ui.tasks.install': '重装依赖',
    'org.umi.ui.tasks.dev.desc': '启动本地服务器',
    'org.umi.ui.tasks.build.desc': '项目构建',
    'org.umi.ui.tasks.lint.desc': '代码风格校验',
    'org.umi.ui.tasks.test.desc': '项目测试',
    'org.umi.ui.tasks.install.desc': '重装项目依赖',
    // dev
    'org.umi.ui.tasks.dev.startError': '启动项目失败',
    'org.umi.ui.tasks.dev.cancelError': '取消启动失败',
    'org.umi.ui.tasks.dev.start': '启动',
    'org.umi.ui.tasks.dev.cancel': '停止',
    'org.umi.ui.tasks.envs': '环境变量',
    'org.umi.ui.tasks.envs.port': '端口号',
    'org.umi.ui.tasks.envs.port.desc': '本地开发端口号',
    'org.umi.ui.tasks.envs.babelPolyfill': '@babel/polyfill',
    'org.umi.ui.tasks.envs.babelPolyfill.desc': 'Babel 补丁',
    'org.umi.ui.tasks.envs.hmr': 'HMR',
    'org.umi.ui.tasks.envs.hmr.desc': 'Webpack 热更新'
  }, _defineProperty(_orgUmiUiTasksTit$1, "org.umi.ui.tasks.envs.babelPolyfill", 'Babel 缓存'), _defineProperty(_orgUmiUiTasksTit$1, "org.umi.ui.tasks.envs.babelPolyfill.desc", 'Babel 缓存，加速开发和构建'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.babelCache', 'BABEL_CACHE'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.babelCache.desc', 'Babel 缓存'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.mock', 'MOCK'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.mock.desc', 'MOCK'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.BROWSER', '浏览器'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.BROWSER.desc', '自动打开浏览器'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.clear', '日志清屏'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.clear.desc', '启动日志自动清除'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.tsCheck', 'TS 类型检查'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.tsCheck.desc', 'TS 类型定义检查（适用于 TS 项目）'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.build.buildError', '执行构建失败'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.build.cancelError', '取消构建失败'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.build.start', '构建'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.build.cancel', '停止'), _defineProperty(_orgUmiUiTasksTit$1, "org.umi.ui.tasks.envs", '环境变量'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.compress', 'JS 压缩'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.compress.desc', '压缩 JS 文件'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.cssCompress', 'CSS 压缩'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.cssCompress.desc', '压缩 CSS 文件'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.html', 'HTML'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.envs.html.desc', '产物生成 HTML'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.test.testError', '执行测试失败'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.test.cancelError', '取消测试失败'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.test.start', '执行'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.test.cancel', '停止'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.lint.execError', '执行代码规范检查失败'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.lint.cancelError', '取消代码检查失败'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.lint.start', '执行'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.lint.cancel', '停止'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.install.execError', '安装依赖失败'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.install.cancelError', '取消安装依赖失败'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.install.start', '安装'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.install.cancel', '停止'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.install.tip', '确认重新安装依赖么?'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.install.npmClient', '使用客户端'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.install.okText', '确认'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.install.cancelText', '取消'), _defineProperty(_orgUmiUiTasksTit$1, 'org.umi.ui.tasks.log.title', '输出'), _orgUmiUiTasksTit$1);

  var ui = function ui(api) {
    var _SCRIPTS;

    initApiToGloal(api);
    var TwoColumnPanel = api.TwoColumnPanel,
        callRemote = api.callRemote;
    var imgProperty = {
      width: '32',
      height: '32'
    };
    var SCRIPTS = (_SCRIPTS = {}, _defineProperty(_SCRIPTS, TaskType.DEV, {
      key: 'dev',
      title: 'org.umi.ui.tasks.dev',
      icon: React__default.createElement("img", Object.assign({}, imgProperty, {
        src: "https://gw.alipayobjects.com/zos/basement_prod/c5c1ced2-ac8c-4979-b725-e7d094364597.svg"
      })),
      description: 'org.umi.ui.tasks.dev.desc',
      Component: DevComponent
    }), _defineProperty(_SCRIPTS, TaskType.BUILD, {
      key: 'build',
      title: 'org.umi.ui.tasks.build',
      icon: React__default.createElement("img", Object.assign({}, imgProperty, {
        src: "https://gw.alipayobjects.com/zos/basement_prod/c5c1ced2-ac8c-4979-b725-e7d094364597.svg"
      })),
      description: 'org.umi.ui.tasks.build.desc',
      Component: BuildComponent
    }), _defineProperty(_SCRIPTS, TaskType.LINT, {
      key: 'lint',
      title: 'org.umi.ui.tasks.lint',
      icon: React__default.createElement("img", Object.assign({}, imgProperty, {
        src: "https://gw.alipayobjects.com/zos/basement_prod/fb3b6fab-253e-41fc-981a-8bfc5dc4fede.svg"
      })),
      description: 'org.umi.ui.tasks.lint.desc',
      Component: LintComponent
    }), _defineProperty(_SCRIPTS, TaskType.TEST, {
      key: 'test',
      title: 'org.umi.ui.tasks.test',
      icon: React__default.createElement("img", Object.assign({}, imgProperty, {
        src: "https://gw.alipayobjects.com/zos/basement_prod/f0d64a31-1767-4ab7-a7f9-eea044d92ce3.svg"
      })),
      description: 'org.umi.ui.tasks.test.desc',
      Component: TestComponent
    }), _defineProperty(_SCRIPTS, TaskType.INSTALL, {
      key: 'install',
      title: 'org.umi.ui.tasks.install',
      icon: React__default.createElement("img", Object.assign({}, imgProperty, {
        src: "https://gw.alipayobjects.com/zos/basement_prod/d9fbc2fa-5bb6-46f4-bd15-385a94bc6d1c.svg"
      })),
      description: 'org.umi.ui.tasks.install.desc',
      Component: InstallComponent
    }), _SCRIPTS); // 插件初始化

    callRemote({
      type: 'plugin/init'
    });
    api.listenRemote({
      type: 'org.umi.task.log',
      onMessage: function onMessage(_ref) {
        var _ref$log = _ref.log,
            log = _ref$log === void 0 ? '' : _ref$log,
            taskType = _ref.taskType;

        if (!log) {
          return;
        }

        getTerminalIns(taskType).write(log.replace(/\n/g, '\r\n'));
      }
    }); // 全局通知

    api.listenRemote({
      type: 'org.umi.task.state',
      onMessage: function onMessage(_ref2) {
        var result = _ref2.detail,
            type = _ref2.taskType;
        var state = result.state;

        if ([TaskState.INIT, TaskState.ING].indexOf(state) > -1) {
          return;
        }

        api.notify(getNoticeMessage(type, state));
      }
    });

    var TasksView = function TasksView() {
      return React__default.createElement(TwoColumnPanel, {
        sections: Object.keys(SCRIPTS).map(function (taskType) {
          var _SCRIPTS$taskType = SCRIPTS[taskType],
              key = _SCRIPTS$taskType.key,
              title = _SCRIPTS$taskType.title,
              icon = _SCRIPTS$taskType.icon,
              description = _SCRIPTS$taskType.description,
              Component = _SCRIPTS$taskType.Component;
          return {
            key: key,
            title: title,
            icon: icon,
            description: description,
            component: function component() {
              return React__default.createElement(Component, {
                api: api
              });
            }
          };
        })
      });
    };

    api.addLocales({
      'zh-CN': zhCN,
      'en-US': enUS
    });
    api.addPanel({
      title: 'org.umi.ui.tasks.title',
      path: '/tasks',
      icon: {
        type: 'project',
        theme: 'filled'
      },
      component: TasksView
    });
  };

  return ui;
});